Package: CHRONOS
Version: 1.38.0
Date: 2020-09-05
Title: CHRONOS: A time-varying method for microRNA-mediated sub-pathway
        enrichment analysis
Author: Aristidis G. Vrahatis, Konstantina Dimitrakopoulou, Panos
        Balomenos
Maintainer: Panos Balomenos <balomenos@upatras.gr>
Description: A package used for efficient unraveling of the inherent
        dynamic properties of pathways. MicroRNA-mediated subpathway
        topologies are extracted and evaluated by exploiting the
        temporal transition and the fold change activity of the linked
        genes/microRNAs.
Depends: R (>= 3.5)
SystemRequirements: Java version >= 1.7, Pandoc
License: GPL-2
NeedsCompilation: no
LazyLoad: yes
Imports: XML, RCurl, RBGL, parallel, foreach, doParallel, openxlsx,
        igraph, circlize, graph, stats, utils, grDevices, graphics,
        methods, biomaRt, rJava
Suggests: RUnit, BiocGenerics, knitr, rmarkdown
VignetteBuilder: knitr
biocViews: SystemsBiology, GraphAndNetwork, Pathways, KEGG
git_url: https://git.bioconductor.org/packages/CHRONOS
git_branch: RELEASE_3_22
git_last_commit: 6ae799a
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
Packaged: 2025-10-30 03:07:55 UTC; biocbuild

downloadKEGGPathwayList <- function(org)
{
    link <- 'https://rest.kegg.jp/list/pathway/'
    if (!missing(org))
    {
        link <- paste0(link, org, '/', org, '.txt')
        rp   <- paste0('path:', org)
    }else
    {
        rp   <- 'path:map'
    }

    r  <- unlist(strsplit(getURIAsynchronous(link), '\n'))

    r  <- mapply(strsplit, as.list(r), split = '\t')
    r1 <- sapply(r, function(x){gsub(rp,'',x[1])})
    r2 <- lapply(r, function(x){x[2]})
    # Remove organism name
    r2 <- sapply(r2, function(x) { unlist(strsplit(x, ' -'))[1] }) 

    s  <- sprintf('%s\t%s',r1,r2)
    # pathways        <- r1
    # names(pathways) <- r2
    pathways           <- data.frame(r1, r2, stringsAsFactors = FALSE)
    colnames(pathways) <- c('Id', 'Name')

    return(pathways)
}

downloadPathways  <- function(org, pathways)
{
    if (missing(pathways)) { pathways <- 'All'}
    paths <- pathways
    if ( length(pathways) == 1 && 
        pathways %in% c('All', 'Metabolic', 'Non-Metabolic'))
    {
        # Download availiable KEGG pathways list 
        paths        <- downloadKEGGPathwayList(org)
        metabolicThr <- 2000

        if ('Metabolic' %in% pathways)
        {   
            paths <- paths[which(as.integer(paths[,1]) < metabolicThr), 1]
        }
        if ('Non-Metabolic' %in% pathways)
        {
            paths <- paths[which(as.integer(paths[,1]) >= metabolicThr), 1]
        }
        if ('All' %in% pathways)
        {
            paths <- paths[, 1]
        }
        if (!'Metabolic' %in% pathways && !'Non-Metabolic' %in% pathways 
                && !'All' %in% pathways)
        {
            if ( is(pathways, 'character') )
            {
                paths <- pathways
            }
            if ( is(pathways,'numeric') || is(pathways,'integer') )
            {
                paths <- as.vector(t(paths[pathways, 1, drop=FALSE]))
            }
        }
    }

    # Download files
    message('Downloading files...', appendLF = FALSE)

    paths <- .downloadPathways(org, paths)

    message('done.')

    return(paths)
}

.downloadPathways <- function(org, paths)
{
    xmlDir <- cache$dirs$xml
    xmlDir <- paste(xmlDir, org, sep='//')

    # Create the organism subdirectory if it does not exist
    if (!file.exists(xmlDir)) 
    { 
        dir.create(xmlDir, recursive=TRUE)
    }
    xmlList <- paste(org, paths, sep='')

    # If any of the requested files have already been downloaded, skip them.
    downloadedPaths <- paste(xmlDir, list.files(path=xmlDir), sep='//')
    downloadQueue   <- unname(xmlList)
    downloadedFiles <- gsub('.xml','', list.files(path=xmlDir))
    idx             <- which(downloadQueue %in% downloadedFiles)
    if (length(idx) > 0) 
    { 
        downloadQueue <- downloadQueue[-idx] 
    }
    if (length(downloadQueue) == 0) 
    { 
        return(paths)
    }

    # Current http links for retrieving KEGG xml file
    prefix <- 'http://rest.kegg.jp/get/' 
    suffix <- '/kgml'
    concurrentDownloads <- 10
    while ( TRUE )
    {
        # Create download links
        links  <- paste0(prefix, downloadQueue, suffix)
        # Create destination paths
        dest   <- paste0(xmlDir, '//', downloadQueue, '.xml')
        # Split queue to batches of jobs
        N      <- length(downloadQueue)
        k      <- max(floor(N/concurrentDownloads), 1)
        jobs <- list('1'=seq_len(N))
        if (N > 1)
        {
            jobs <- split(
                1:N, cut(1:N, quantile(1:N, (0:k)/k), 
                include.lowest=TRUE, labels=FALSE))
        }
        export <- c('getURIAsynchronous', 'foreach', '%do%')
        cores  <- ifelse( N > detectCores()*10, 'default', 1 )
        lens   <- .doSafeParallel(
                    funcName=downloadPathway,
                    export=export, combine='c',
                    N=k, cores=cores,
                    links, dest, jobs)

        # Do some error-reporting
        errIdx <- which( lens < 3 )
        files  <- list('valid'=c(), 'invalid'=c())
        files$valid <- downloadQueue
        if ( length(errIdx) > 0 )
        {
            files$valid   <- downloadQueue[-errIdx]
            files$invalid <- downloadQueue[errIdx]
        }

        if ( length(files$invalid) == 0)
            { break; }
        if ( length(files$invalid) != 0)
            { downloadQueue <- files$invalid }
    }

    return(paths)
}

downloadPathway   <- function(i, ...)
{
    # ------- Unpacking arguments -------
    args  <- list(...)
    links <- args[[1]]
    dest  <- args[[2]]
    jobs  <- args[[3]]
    # ----------------------------------
    idx <- jobs[[i]]

    raw <- getURIAsynchronous(links[idx], noprogress=TRUE, 
                            .opts = list(timeout = 200, verbose=FALSE))

    lens <- vector(mode='numeric', length=length(raw))
    j <- 0; foreach (j = 1:length(raw)) %do% 
    {
        if( !grepl('Access forbidden', raw[[j]]) )
        { 
            write(raw[[j]], file = dest[idx][[j]]) 
            lens[j] <- nchar(raw[[j]])
        }
        if( grepl('Access forbidden', raw[[j]]) )
        { 
            lens[j] <- 0
        }
    }
    return(lens)
}

##
## Score subpathways using an interacting scoring scheme (IS) for each time 
## point
##

scoreSubpathways   <- function(subpathways, filters, measures, parameters,
                                miRNAinteractions)
{
    tryCatch(
    {        
        res <- .scoreSubpathways(subpathways, filters, measures, parameters,
                                miRNAinteractions)
        return(res)
    }, warning = function(war) 
    {
    }, error = function(e) 
                { 
                    closeAllConnections()
                    message('\nParall error in refinement'); 
                }
    , finally = { }
    )
    
    return(res)
}

.scoreSubpathways  <- function(subpathways, filters, measures, parameters,
                                miRNAinteractions)
{
    if (missing(filters))        
    { 
        stop('Missing filters.')
    }
    if (missing(parameters))     
    { 
        parameters <- c('C'=1, 'K'=5, 'T'=0.3) 
    }
    if (missing(miRNAinteractions))        
    { 
        miRNAinteractions <- NULL
    }
    if ('measures' %in% names(filters) && missing(measures))
    {
        stop('Measures parameter missing.')
    }
    if (!'subScore' %in% names(filters))
    {
        filters <- c(filters, 'subScore'=0.0)
    }
    if ( 'mirScore' %in% names(filters) )
    {
        if ( is.null(miRNAinteractions) )
        {
            # Download miTargets file if it is not availiable
            org    <- subpathways$org
            miFile <- paste(cache$dirs$miDir, org, cache$dirs$miFile, sep='//')
                    
            if (!file.exists(miFile))
            {
                downloadMiRecords(org=org, update=FALSE, databases='All', pn=5)
            }
        }
        if ( !is.null(miRNAinteractions) )
        {
            org <- subpathways$org
            saveMiRNAFile(org=org, miRNAinteractions=miRNAinteractions)
        }
    }

    # Load imported gene expressions
    load(cache$dirs$geneExpressions, e <- new.env())
    geneExpr <- e[[ls(e)[1]]]

    if ( is.null(geneExpr) ) 
    { 
        stop('Error importing gene expression data.\n')
        return(NULL) 
    }

    if ( 'mirScore' %in% names(filters) )
    {
        if(!file.exists(cache$dirs$mirnaExpressions))
        {
            message('Error, no miRNA expressions data supplied.\n')
            return(NULL)
        }

        # Load imported miRNA expressions
        load(cache$dirs$mirnaExpressions, e <- new.env())

        mirnaExpr <- e[[ls(e)[1]]]
        if (is.null(mirnaExpr))
        {
            stop('Error importing miRNA expression data.\n')
            return(NULL)
        }         
    }

    res <- .evaluateSubpaths(subpathways, filters, measures, parameters,
                            geneExpr, mirnaExpr)

    return(res)
}

.evaluateSubpaths  <- function(subpathways, filters, measures, parameters, 
                                geExpr, miExpr)
{
    subpaths  <- subpathways$subpaths
    adjMats   <- subpathways$adjMats
    groupMode <- subpathways$groupMode
    type      <- subpathways$subpathwayType
    org       <- subpathways$org
    fci.C     <- parameters['C']
    fci.K     <- parameters['K']
    fci.T     <- parameters['T']
    res       <- list(org=org, filters=filters, type=type)

    if (is.null(subpaths)) { return(NULL) }

    if (type == 'Linear')
    {
        # Filter adjacency matrices with user genes
        adjMats <- filterMatrix( adjMats=adjMats, org=org, 
                                userGenes=rownames(geExpr) )

        # Build global gene and edge indexer
        lex <- matrixToLexicon( adjMats=adjMats, org=org, groupMode=groupMode )
    }

    if (type == 'Non-Linear')
    {

        lex <- subpathways$lex
    }
    

    # Filter gene expressions
    geExpr     <- .filterExpressions( geExpr, lex, groupMode )

    message('\t#', nrow(subpaths), ' subpathways initially')


    if ('p-value' %in% names(filters))         
    {
        # Find most significant subpaths using hypergeometric testing
        qValues     <- .getStatistics(subpaths, names(lex$genes), type=type, 
                                    pVal=filters['p-value'], pAdjust = '')
        # Keep subpaths with good q-value
        idx0         <- which(qValues < 0.05) 
        subpaths     <- subpaths[idx0, , drop=FALSE]
        qValues     <- qValues[idx0]
        res          <- c(res, list(pValues=qValues))

        message('\t#', nrow(subpaths), ' subpathways after p.value.')
    }


    if ('subScore' %in% names(filters))    
    {
        if( nrow(subpaths) == 0 ) { return(NULL) }
                
        message('Calculating subscores...', appendLF = FALSE)

        # Index subpaths
        edgeList     <- lex$edges
        iSubs        <- .indexSubpaths(subpaths, edgeList, type, org)

        # Score only subpath interactions    
        uEdges       <- as.integer(unique(as.vector(iSubs)))
        uEdges       <- uEdges[which(uEdges != 0)]
        edgeList     <- edgeList[uEdges,, drop=FALSE]

        # Calculate edge scores for all subpathway edges
        edgeScores  <- .getEdgeScores(expr=geExpr, edges=edgeList, 
                        fci.C=fci.C, fci.K=fci.K, fci.T=fci.T)

        # Calculate subscore for each subpathway
        subScores   <- .scoreSubpaths(edgeScores=edgeScores, iSubs=iSubs, 
                                    type=type)

        # Keep subpaths with specific subscore
        idx1        <- .filterSubScore(subpaths, subScores, 
                                        filters['subScore'])
        subpaths    <- subpaths[idx1, , drop=FALSE]
        subScores   <- subScores[idx1, , drop=FALSE]
        res$pValues <- res$pValues[idx1] # NULL if not specified.


        message('done.')

        message('\t#', nrow(subpaths), ' subpathways after subscore.')

        res <- c(res, list(subScores=subScores))
    }

    if ('mirScore' %in% names(filters))
    {
        if( nrow(subpaths) == 0 ) { return(NULL) }

        message('Calculating mirscores...', appendLF = FALSE)
        
        miLex       <- .createMirnaLexicon(org=org, genes=lex$genes)
        
        # Score subpathway specific interactions
        subGenes    <- getSubpathwayGenes(subpaths, type)
        idx         <- which(miLex$edges[,4] %in% subGenes)
        miLex$edges <- miLex$edges[idx, ]
        edgeList    <- miLex$edges
        
        edgeScores  <- .getMiScores(geExpr, miExpr, edgeList, lex, type, 
                            fci.C=fci.C, fci.K=fci.K, fci.T=fci.T)

        # Append edge scores as third column of mirna-gene edgelist
        miLex$edges <- cbind(miLex$edges, edgeScores)
        edgeList    <- miLex$edges[, -c(1,2)]

        summary     <- .filterMiScores(subpaths, miLex, filters['mirScore'], 
                            type=type, lex=lex) 
        res         <- c(res, summary)

        message('...end.')
    }


    if ('measures' %in% names(filters))
    {
        # Apply topological evaluator to data
        top <- .getMeasures(names(lex$genes), subpaths, measures, mode)
        res <- c(res, list(measures=top))
    }

    res <- c(res, list(subpaths=subpaths))

    return (res)
}

.filterExpressions <- function( expressions, lex, groupMode )
{

    # Keep only gene expressions of genes belonging to user pathway list
    idx  <- which(rownames(expressions) %in% names(lex$genes))
    expr <- expressions[idx, , drop=FALSE]

    if (groupMode == 'collapse')
    {    
        # Find nodes with multiple genes and organize them to a matrix
        gn  <- lapply(as.list(names(lex$genes)), function(x) 
                    { matrix(unlist(strsplit(x, ' ')), nrow=1) } )
        len <- sapply(gn, function(x) { ncol(x) } )

        d     <- 0: max(len)
        idxT  <- which(len <= d[length(d)])
        nexp  <- matrix(, nrow=length(idxT), ncol=ncol(expr))
        rownames(nexp) <- 1:nrow(nexp)
        for (j in 1:(length(d)-1))
        {
            idx <- intersect(which(len > d[j]), which(len <= d[j+1]))
            if (length(idx) == 0) 
            { 
                next() 
            }
            gni <- unlistToMatrix(fillMatrixList(gn[idx]))

            # Keep relevant gene expressions
            ugenes  <- unique(as.vector(gni))
            idx     <- which(rownames(expressions) %in% ugenes)
            expr    <- expressions[idx, , drop=FALSE]
            
            nei     <- matrix(, nrow=nrow(gni), ncol=ncol(expr))
            for (t in 1:ncol(expr))
            {
                lb        <- expr[, t]
                names(lb) <- rownames(expr)
                expr_t    <- matrix(lb[gni], nrow=nrow(gni), ncol=ncol(gni))
                nei[,t]   <- apply( expr_t, 1, function(x) 
                                                { median(x, na.rm=TRUE ) } )
            }
            rownames(nei) <- apply( gni, 1, function(x)
                                { 
                                    paste(x[which(x!=0)], collapse=' ') 
                                } )
            idx1                <- which(len[idxT] > d[j])
            idx2                <- which(len[idxT] <= d[j+1])
            idx                 <- intersect(idx1, idx2)
            nexp[idx,]          <- nei
            rownames(nexp)[idx] <- rownames(nei)
        }

        # Add complex expression values to original
        expr <- rbind(expr, nexp)         
    }

    return(expr)
}



## 
## Evaluate mRNA-miRNA interactions in subpathways
##

.indexSubpaths  <- function(subpaths, edgeList, type, org)
{
    if (type=='Linear')
    {
        # Replace every 2 consecutive genes with a corresponding interaction.
        # Create a named vector containing all pathway interactions.
        # Used to transform the entrez subpaths to indexed subpaths.
        # Index reference lexicon
        y   <- sprintf('%s-%s-%s', edgeList[,1], edgeList[,2], edgeList[,6]) 
        ids <- 1:length(y)
        names(ids) <- y

        # Split linear queue to batches of jobs
        k     <- floor(nrow(subpaths)/5)
        jobs  <- splitWork(N=nrow(subpaths), k)$jobs
        cores <- ifelse( nrow(subpaths) > detectCores()*1000, 'default', 1 )
        iSubs <- .doSafeParallel(
                    funcName=indexSubpath, export=NULL, 
                    combine='rbind', N=k, cores=cores,
                    subpaths, org, ids, jobs )
        return(iSubs)
    }

    if (type=='Non-Linear')
    {
        # Replace every 2 consecutive genes with a corresponding interaction.
        # Create a named vector containing all pathway interactions.
        # Used to transform the entrez subpaths to indexed subpaths.

        y   <- sprintf('%s-%s-%s', edgeList[,1], edgeList[,2], edgeList[,6]) 
        ids <- 1:length(y)
        names(ids) <- y
        rnames     <- gsub(org, '', rownames(subpaths))
        subpaths   <- apply(subpaths, 2, function(x, y) 
                                    {
                                        paste(x, y, sep='-') 
                                    }, rnames )
        rownames(subpaths) <- rnames        
        Ld                 <- matrix(ids[subpaths], ncol=ncol(subpaths), 
                                    byrow=FALSE)
        Ld[is.na(Ld)]      <- 0
        rownames(Ld)       <- rnames

        return(Ld)
    }
}


indexSubpath    <- function(i, ...)
{
    # ------- Unpacking arguments -------
    args     <- list(...)
    subpaths <- args[[1]]
    org      <- args[[2]]
    ids      <- args[[3]]
    jobs     <- args[[4]]
    # ----------------------------------
    idx      <- jobs[[i]]

    subs          <- subpaths[idx, ,drop=FALSE]
    x1            <- subs[, 1:(ncol(subs) - 1)]
    x2            <- subs[, 2:ncol(subs)]
    x3            <- gsub(org, '', rownames(subs))
    x             <- sprintf('%s-%s-%s', x1, x2, x3)
    x             <- x
    Ld            <- as.numeric(ids[x])
    Ld            <- matrix(Ld, ncol=ncol(subs)-1, byrow=FALSE)
    rownames(Ld)  <- rownames(subs)
    Ld[is.na(Ld)] <- 0

    return(Ld)
}

.scoreSubpaths  <- function(edgeScores, iSubs, type)
{
    if ( is.null(iSubs) || nrow(iSubs)==0 || is.null(edgeScores) ) 
    {
        return(NULL) 
    }

    # Recreate the original edgelist which corresponds to all interactions
    # and not just the ones in subpaths used to calculate edgescores,
    # since original subpath indexing was done using all interactions.
    # Otherwise, the subpaths would require reindexing.
    edgeScores  <- edgeScores[,-c(1:6)]
    maxIdx      <- max(as.integer(rownames(edgeScores)))
    E           <- matrix(, nrow=maxIdx, ncol=ncol(edgeScores))
    idx         <- as.integer(rownames(edgeScores))
    E[idx,]     <- as.matrix(edgeScores)
    # Zero as scores for each time point, for indexing of '0' to work
    edgeScores  <- rbind(E, rep(0, ncol(E))) 

    # Calculate subpath lengths
    len         <- getLengths(iSubs)
    t           <- ncol(edgeScores)
    
    # Replace '0' with a valid index which point to '0' again
    iSubs[iSubs == 0]  <- nrow(edgeScores)
    # Each column holds the score for each interaction from iSubs, 
    # columnwise (i.th time point).
    edgeScores         <- edgeScores[iSubs, ]

    subScores      <- matrix(0,nrow=nrow(iSubs), ncol=t)
    for (i in 1:t)
    {
        # iSubs turned into scores for i.th time point
        iSubsToScores     <- matrix(edgeScores[, i], ncol=ncol(iSubs))
        # Divide sum of scores with number of interactions to obtain subScore
        subScores[,i]     <- rowSums(iSubsToScores) / len
    }


    if (type == 'Non-Linear') { subScores <- normalize(subScores) }

    return(geneScores=subScores)    
}

.getEdgeScores  <- function(expr, edges, fci.C, fci.K, fci.T)
{
    if (is.null(edges) || is.null(expr))
    {
        return(NULL)
    }

    edgeList <- edges[,3:4]
    rel      <- edges[,5]
    pathway  <- edges[,6]

    # Calculate FCI score    
    fci <- foreach(i = 1:1, .export='scoreFCI',.combine='rbind') %do% 
    {
        scoreFCI(expr, edgeList, fci.C=fci.C, fci.K=fci.K, fci.T=fci.T)
    }
    t <- ncol(expr)

    # Calculate TVI score
    i   <- 0
    tvr <- foreach(i = 1:1, .export='scoreTVI', .combine='rbind') %do% 
    {
        scoreTVI(expr, edgeList)
    }

    # Calculate edge list's gene expressions
    x1 <- matrix(0,ncol=t, nrow=nrow(edgeList))
    x2 <- matrix(0,ncol=t, nrow=nrow(edgeList))
    for (j in 1:t)
    {
        x1[,j] <- expr[as.numeric(edgeList[,1]), j]
        x2[,j] <- expr[as.numeric(edgeList[,2]), j]    
    }

    # Calculate gene-gene interactions final score
    idx1       <- matrix(rel==1 & fci>0 & tvr>0, nrow=nrow(edgeList)) 
    idx2       <- matrix(rel==2 & fci<0 & tvr<0, nrow=nrow(edgeList))
    idx3       <- matrix(rel==3 & sign(fci*tvr)>0, nrow=nrow(edgeList))
    edgeScores <- (0.8*abs(fci) + 0.2*abs(tvr)) * (idx1 + idx2 + idx3)


    edgeScores           <- cbind(edges, edgeScores)
    rownames(edgeScores) <- rownames(edges)

    return(edgeScores)
}

.filterSubScore <- function(subpaths, scores, thr)
{
    if ( is.null(subpaths) || nrow(subpaths) == 0 || is.null(scores) )
    {
        return(NULL)
    }

    minNumberOfGoodScores <- 1

    # Calculate average of scores for all time points
    avgScorePerSub <- rowSums(scores)/ncol(scores)
    upaths         <- unique(rownames(subpaths))

    # Find highest ranking subpathway per pathway 
    idx0 <- c()
    for (i in 1:length(upaths))
    {
        # Find all subpaths of a single pathway
        lindx <- which(rownames(subpaths) == upaths[i])
        # Find the average scores for each of the subpaths
        lavg  <- avgScorePerSub[lindx]
        # Find max average value amomg subpaths
        mx    <- lindx[which.max(lavg)]

        if (avgScorePerSub[mx] > thr) 
        { 
            idx0 <- c(idx0, mx) 
        }
    }

    # Subpath with largest average score first
    idx0  <- idx0[order(avgScorePerSub[idx0], decreasing = TRUE)]
    
    # Keep subpaths with at least one good score
    rSums <- rowSums(matrix(scores > thr, nrow=nrow(scores)))
    
    # Remove top results of first phase
    iiidx <- which(rSums >= minNumberOfGoodScores)
    idx1  <- setdiff(iiidx, idx0)

    # Sort by decreasing average
    idx1  <- idx1[order(avgScorePerSub[idx1], decreasing = TRUE)]
    
    # Join previous two results categories
    idx   <- c(idx0, idx1)
    
    return(idx)
}

cache <- new.env()

.onLoad            <- function(libname, pkgname) 
{
    #
    #
}

.onAttach          <- function(libname, pkgname)
{
    # Create ext directory internal structure.
    .buildDirectories()
}

.onUnload          <- function(libname) 
{

    # 
}

.buildDirectories  <- function()
{
    # The function creates data directories for user usage.
    #
    # extdata
    #    -- Downloads
    #       -- KEGG
    #          -- hsa
    #             + hsa00010.xml, hsa00020.xml ...
    #          -- mmu
    #                   + mmu00010.xml, mmu00020.xml ...
    #       -- miRecords
    #          -- hsa
    #          -- mmu
    #    -- Input
    #       -- Default
    #          - mirnaTargets.txt
    #       -- User
    #               + geneExpressions.txt
    #               + mirnaExpressions.txt
    #    -- Output
    #       -- Subpaths
    #          -- Linear
    #             -- hsa
    #                + subpaths1.RData
    #                + subpaths1.txt
    #                + subpaths2.txt
    #             -- mmu
    #                + subpaths1.RData
    #                + subpaths1.txt
    #          -- Non Linear
    #             -- hsa
    #                + subpaths1.txt
    #             -- mmu
    #                + subpaths1.RData
    #       -- Scores
    #          -- Linear
    #             -- hsa
    #                + score1a.xlsx
    #                + score1b.xlsx
    #                + score2a.xlsx
    #                + score2b.xlsx
    #             -- mmu
    #                + score1a.xlsx
    #                + score1b.xlsx
    #          -- Non Linear
    #             -- hsa
    #                + score1a.xlsx
    #                + score1b.xlsx
    #             -- mmu
    #                + score1a.xlsx
    #                + score1b.xlsx
    #                + score2a.xlsx
    #                + score2b.xlsx
    dirs  <- list()

    path <- switch(.Platform$OS.type, unix = path.expand("~"),
                    windows= file.path(gsub("\\\\", "/",
                    Sys.getenv("USERPROFILE")), "AppData"))
    opt <- getOption("CHRONOS_CACHE", file.path(path, '.CHRONOS'))
    chronosDir <- Sys.getenv("CHRONOS_CACHE", opt)

    # Directory for user files
    inDir <- paste(chronosDir, '//extdata//User',sep='')
    dirs  <- c(dirs, list(usr=inDir))
    msg0 <- sapply(list(inDir), function(x) 
        { dir.create(x, showWarnings=FALSE, recursive=TRUE)} )    

    if ( is.null(dirs$geneExpressions) )
    {
        gf1   <- paste(inDir, 'mRNAExpressions.txt', sep='//')
        dirs  <- c(dirs, list(geneExpressions=gf1) )
    }
    if ( is.null(dirs$mirnaExpressions) )
    {
        mf1   <- paste(inDir, 'miRNAExpressions.txt', sep='//')
        dirs  <- c(dirs, list(mirnaExpressions=mf1) )
    }
    if ( is.null(dirs$interestingGenes) )
    {
        igf   <- paste(inDir, 'interestingGenes.txt', sep='//')
        dirs  <- c(dirs, list(interestingGenes=igf) )
    }
    if ( is.null(dirs$miRecordsFile) )
    {
        mrc   <- paste(inDir, 'miRecords.xlsx', sep='//')
        dirs  <- c(dirs, list(miRecordsFile=mrc) )
    }
    if ( is.null(dirs$tarBaseFile) )
    {
        trb   <- paste(inDir, 'TarBase.xlsx', sep='//')
        dirs  <- c(dirs, list(tarBaseFile=trb) )
    }

    # Directory for downloaded data
    pDir    <- paste(chronosDir, '//extdata', sep='')
    xmlDir  <- paste(pDir, '//Downloads//KEGG', sep = '')
    miDir   <- paste(pDir, '//Downloads//miRecords', sep = '')
    anDir   <- paste(pDir, '//Downloads//mirbase', sep = '')
    msg1    <- sapply(list(xmlDir, miDir, anDir), function(x) 
        { dir.create(x, showWarnings=FALSE, recursive=TRUE)} )
    dirs    <- c(dirs, list(xml=xmlDir, miDir=miDir, anDir=anDir,
                            miFile='miRNATargets.RData'))

    # Directory for temporary files
    intDir  <- paste(chronosDir, '//extdata',
                '//Internal', sep='')
    matDir  <- paste(intDir, '//mat', sep='') #
    idsDir  <- paste(intDir, '//ids', sep='') #
    parDir  <- paste(intDir, '//par', sep='') #
    subDir  <- paste(intDir, '//out', sep='') #
    logDir  <- paste(intDir, '//log', sep='') #

    jDir    <- paste(chronosDir, '//java', sep='')
    tmpDirs <- list(
        mat=matDir,ids=idsDir, par=parDir, sub=subDir, log=logDir)
    dirs    <- c(dirs, list(int=intDir, tmp=tmpDirs,java=jDir))

    #
    # Directories for output
    # 
    outDir  <- paste0(chronosDir, '//extdata','//Output')
    # Subpaths
    nlDir   <- paste(outDir, '//Subpaths//Non Linear', sep = '')
    lnDir   <- paste(outDir, '//Subpaths//Linear', sep='')
    dirs    <- c(dirs, list(lnr=lnDir,nlr=nlDir))
    msg2    <- sapply(list(nlDir, lnDir), function(x) 
        { dir.create(x, showWarnings=FALSE, recursive=TRUE)} )

    # Scores
    snlDir  <- paste(outDir, '//Scores//Non Linear', sep = '')
    slnDir  <- paste(outDir, '//Scores//Linear', sep='')
    dirs    <- c(dirs, list(slnr=slnDir, snlr=snlDir))
    msg2    <- sapply(list(snlDir, slnDir), function(x) 
        { dir.create(x, showWarnings=FALSE, recursive=TRUE)} )

    # Visualizations
    vnlDir  <- paste(outDir, '//Visualizations//Non Linear', sep = '')
    vlnDir  <- paste(outDir, '//Visualizations//Linear', sep='')
    dirs    <- c(dirs, list(vlnr=vlnDir, vnlr=vnlDir))
    msg3    <- sapply(list(vnlDir, vlnDir), function(x) 
        { dir.create(x, showWarnings=FALSE, recursive=TRUE)} )

    cache$dirs <- dirs

    # Copy demo files from package directory to user directort
    file.copy(  from=system.file('extdata', package='CHRONOS'), 
                to=file.path(chronosDir), 
                overwrite = FALSE, recursive = TRUE, copy.mode = TRUE)

    return(dirs)
}

.createDirectories <- function(org)
{
    #
    # Create subdirectories for specific organism inside each parent folder
    #
    d0 <- paste(cache$dirs$tmp$log, org, sep='//') 
    d1 <- paste(cache$dirs$tmp$mat, org, sep='//') 
    d2 <- paste(cache$dirs$tmp$ids, org, sep='//') 
    d3 <- paste(cache$dirs$tmp$par, org, sep='//') 
    d4 <- paste(cache$dirs$tmp$sub, org, sep='//') 
    d5 <- paste(cache$dirs$lnr, org, sep='//')
    d6 <- paste(cache$dirs$nlr, org, sep='//')
    d7 <- paste(cache$dirs$slnr, org, sep='//')
    d8 <- paste(cache$dirs$snlr, org, sep='//')

    mapply(dir.create, list(d0, d1, d2, d3, d4, d5, d6, d7, d8), 
            showWarnings=FALSE, rec=TRUE)
}

.cleanDirectories  <- function()
{
    #
    unlink(cache$dirs$int, recursive=TRUE)
}

importExpressions      <- function( data, type, sep, org, mRNAnomenclature )
{
    #
    # Import gene or mirna expression data.
    # Data can be imported either by providing the filename of a txt file
    # containing them or by directly supplying a matrix.
    # 
    message('Importing ', type , ' data...', appendLF = FALSE)

    if (missing(type))         
    { 
        message('\nError. Please specify a type.')
        return()
    }
    if (missing(sep))               { sep  <- '\t' }

    if (missing(mRNAnomenclature))  { mRNAnomenclature  <- 'entrezgene' }
    
    if (!'miRNA' %in% type)  
    {
        mRNAExpr <- importGeneExpressions(org=org, sep=sep, file=data, 
                    mRNAnomenclature=mRNAnomenclature) 

        if (org == 'hsa')
        {
            cache$nomenclature <- c('from'=mRNAnomenclature, 
                                    'to'='hgnc_symbol')
        }
        if (org == 'mmu')
        {
            cache$nomenclature <- c('from'=mRNAnomenclature, 
                                    'to'='mgi_symbol')
        }

        message('done.')

        return(mRNAExpr)
    }
    if ('miRNA' %in% type) 
    {
        miRNAExpr <- importMiRNAExpressions(org=org, sep=sep, file=data)

        message('done.')

        return(miRNAExpr)
    }
}


importGeneExpressions  <- function( org, sep, file, mRNAnomenclature )
{
    # File can either be a filepath in input directory or a matrix
    if ( is(file, 'character') )
    {
        # If a different filename than the default has been supplied, 
        # replace it at the filepath
        dir <- unlist(strsplit(cache$dirs$geneExpressions, '//'))
        dir <- dir[-length(dir)]
        dir <- paste(dir, collapse='//')
        cache$dirs$geneExpressions <- paste(dir, file, sep='//')

        if (!file.exists(cache$dirs$geneExpressions))
        { 
            message('No gene expression data availiable.')
            return(invisible()) 
        }

        # Get file extension
        ext <- tail(unlist(strsplit(file, '\\.')), 1)

        if (tolower(ext) == 'rdata')
        {
            e=new.env(); load(file=cache$dirs$geneExpressions, envir=e)

            if (length(ls(e)) == 0) 
            { 
                message('File ', file, ' is empty.\n') 
            }

            geneEx <- e[[ls(e)[1]]]

            if ( !is(geneEx,'matrix') ) 
            { 
                message('Please supply a matrix of gene expressions.')
                message('File ', file, ' does not contain a matrix.\n') 
            }
            if (is.null(rownames(geneEx)))
            {
                message('mRNA expression matrix must contain gene ids.')
            }
            if (ncol(geneEx) == 1)
            {
                message('mRNA expression matrix should contain more 
                    than one columns.')
            }

            return(geneEx) 
        }

        filepath <- cache$dirs$geneExpressions

        # Read expressions file
        data    <- as.matrix(read.table(filepath, sep = sep, as.is=TRUE))
        ids     <- data[,1]
        geneEx  <- matrix(as.numeric(data[,-1]), nrow=nrow(data))
        rownames(geneEx) <- ids
        
        # Remove NA's
        geneEx  <- na.omit(geneEx)
        attributes(geneEx)$'na.action' <- NULL

        # Replace txt file with processed RData file and save data
        file <- gsub('.txt', '.RData', cache$dirs$geneExpressions)
        cache$dirs$geneExpressions <- file 
    }

    if ( is(file,'matrix') )
    {
        geneEx  <- file
        dir     <- unlist(strsplit(cache$dirs$geneExpressions, '//'))
        dir     <- dir[-length(dir)]
        dir     <- paste(dir, collapse='//')
        file    <- paste(dir, 'geneExpressions.RData', sep='//')
        cache$dirs$geneExpressions <- file
    }

    if (mRNAnomenclature != 'entrezgene')
    {
        #
        # Convert nomenclature to entrez if necessary
        #
        
        # Check if supplied type is supported
        supportedNomenclature <- names(.getFilters())

        if (!(mRNAnomenclature %in% supportedNomenclature)) 
        {
            strErr <- sprintf('Error, %s nomenclature not supported\n', 
                                mRNAnomenclature)
            stop(strErr)
            return(NULL)
        }

        ids <- rownames(geneEx)
        res <- convertNomenclature(ids=ids, org=org, from=mRNAnomenclature, 
                                    to='entrezgene')

        # Remove conversion giving the same answer
        idx <- which((res[, 1] == res[, 2]))

        if (length(idx) > 0)
        {
            res <- res[-idx, ]    
        }

        # Create a hash to map distinct refseq ids to entrez ids.
        lib1        <- res[,2]
        names(lib1) <- res[,1]
        renamed     <- lib1[ids]
        
        # Remove gene expressions with ids with no entrez number
        idx         <- which(is.na(lib1[ids]))

        if (length(idx) > 0)
        {
            geneEx      <- geneEx[-idx, ]
            ids         <- ids[-idx]
            renamed     <- renamed[-idx]
        }
        rownames(geneEx) <- renamed

        # Sort expression matrix according to name
        geneEx <- geneEx[order(as.numeric(rownames(geneEx)) ),]
    }

    # Remove multiple entries
    geneEx <- geneEx[which(!duplicated(rownames(geneEx))), , drop=FALSE]
    
    save(geneEx, file=cache$dirs$geneExpressions)

    return(geneEx)
}


importMiRNAExpressions <- function(org, sep, file)
{
    # File can either be a filepath in input directory or a matrix
    if ( is(file,'character') )
    {
        # If a different filename than the default has been supplied, 
        # replace it at the filepath
        dir <- unlist(strsplit(cache$dirs$mirnaExpressions, '//'))
        dir <- dir[-length(dir)]
        dir <- paste(dir, collapse='//')
        cache$dirs$mirnaExpressions <- paste(dir, file, sep='//')

        if (!file.exists(cache$dirs$mirnaExpressions))
        { 
            message('No miRNA expression data availiable.')
            return(invisible()) 
        }

        # Get file extension
        ext <- tail(unlist(strsplit(file, '\\.')), 1)

        if (tolower(ext) == 'rdata')
        { 
            e=new.env(); load(file=cache$dirs$mirnaExpressions, envir=e)

            if (length(ls(e)) == 0) 
            { 
                message('File ', file, ' is empty.\n') 
            }

            miEx <- e[[ls(e)[1]]]

            if ( !is(miEx, 'matrix') ) 
            { 
                message('Please supply a matrix of miRNA expressions.')
                message('File ', file, ' does not contain a matrix.\n') 
            }
            if (is.null(rownames(miEx)))
            {
                message('miRNA expression matrix must contain miRNA ids.')
            }
            if (ncol(miEx) == 1)
            {
                message('miRNA expression matrix should contain more 
                    than one columns.')            }

            return(miEx) 
        }

        filepath <- cache$dirs$mirnaExpressions

        # Read expressions file
        data    <- as.matrix(read.table(filepath, sep = sep, as.is=TRUE))

        ids     <- data[,1]
        miEx  <- matrix(as.numeric(data[,-1]), nrow=nrow(data))
        rownames(miEx) <- ids
        
        # Remove NA's
        miEx  <- na.omit(miEx)
        attributes(miEx)$'na.action' <- NULL

        # Replace txt file with processed RData file and save data
        cache$dirs$mirnaExpressions <- gsub('.txt', '.RData', 
                                    cache$dirs$mirnaExpressions) 

    }

    if ( is(file,'matrix') )
    {
        miEx    <- file
        dir     <- unlist(strsplit(cache$dirs$mirnaExpressions, '//'))
        dir     <- dir[-length(dir)]
        dir     <- paste(dir, collapse='//')
        cache$dirs$mirnaExpressions <- paste0(dir, '//miRNAExpressions.RData')
    }

    result <- tryCatch(
    {
        # Conform user miRNA annotations to the ones used by miRecords
        userMirs       <- rownames(miEx)
        finalMirs      <- convertMiRNANomenclature(org, userMirs)
        rownames(miEx) <- finalMirs[,2]
    }, warning = function(war) 
    {
    }, error = function(e) { }
    , finally = {}) 
    
    save(miEx, file=cache$dirs$mirnaExpressions)

    return(miEx)
}


importMiRNAFile        <- function(org)
{
    file <- paste(cache$dirs$miDir, org, cache$dirs$miFile, sep='//')

    e=new.env(); load(file=file, envir=e)
    df <- as.data.frame(e$targets, stringsAsFactors=FALSE)

    return(df)
}

saveMiRNAFile        <- function(org, miRNAinteractions)
{
    # Create organism subdirectory if it does not exist
    orgDir <- paste0(cache$dirs$miDir, '//' ,org) 
    if ( !file.exists(orgDir) )
    {
        dir.create(orgDir, showWarnings=FALSE, recursive=TRUE)
    }

    file <- paste0(orgDir, '//', cache$dirs$miFile)

    targets <- as.data.frame(miRNAinteractions, stringsAsFactors=FALSE)
    save(file=file, targets, compress='xz')

    return(targets)
}

test_subExtractionNonLinear <- function() 
{
    message('Testing test_subExtractionNonLinear...', appendLF = FALSE)

    # Load pathway graphs from toy data
    load(system.file('extdata', 'Examples//data.RData', package='CHRONOS'))

	sink( tempfile() ) 

    # Import mRNA expressions
    mRNAexpr <- importExpressions(data=mRNAexpr, type='entrezgene', org='hsa')

    # Extract linear subpathways
    nliSubsRun  <- extractNonLinearSubpathways(graphs=graphs, filter=TRUE)

    sink()

    all.equal(nliSubsRun, nliSubs)

    message('done.')
}

##
## Genelist and edgelist maintainance
##


matrixToLexicon <- function( adjMats, org, groupMode )
{
    if ( missing(groupMode) )
    {
        groupMode <- 'collapse'
    }

    lex <- list('org'=org,'genes'=NULL,'edges'=NULL, 'adjMat'=NULL)
    if (length(adjMats) == 0) { return(lex) }

    #
    # Find unique genes in organism's pathways
    #
    genes <- c()
    for (i in 1:length(adjMats))
    {
        adjMat  <- adjMats[[i]]
        res     <- c() 

        for (m in 1:length(rownames(adjMat)))
        {
            s   <- rownames(adjMat)[m]
            s   <- gsub(paste(org,':',sep=''), '', s )
            res <- c(res, s)
        }
        genes <- c(genes, unique(unlist(res)) )
    }
    if (groupMode == 'expand') { genes <- sort(unique(as.numeric(genes))) }
    
    geneLex <- NULL
    if ( length(genes) > 0 )
    {
        geneLex         <- 1:length(genes)
        names(geneLex)  <- genes
    }

    #
    # Find unique edges in organism's pathways
    #
    edges   <- data.frame()
    pathway <- names(adjMats)
    for (i in 1:length(adjMats))
    {
        if (!is.matrix(adjMats[[i]])) { next() }
        if (nrow(adjMats[[i]]) == 0) { next() }

        X     <- t(adjMats[[i]])
        rn    <- gsub(paste(org,':',sep=''), '', rownames(X))
        cn    <- gsub(paste(org,':',sep=''), '', colnames(X))
        y     <- expand.grid(rn, cn, stringsAsFactors = FALSE)
        y     <- cbind(y, as.vector(X), gsub(org,'',pathway[i]))
        edges <- rbind(edges, y[which(X > 0),])
    }
    edges   <- unique(edges)
    edgeLex <- NULL
    if ( nrow(edges) > 0 )
    {
        # Indexed columns of edgelist, with entrez ids as names.
        edgeLex <- data.frame( 'E1'=edges[,2],'E2'=edges[,1],
                        'e1'=geneLex[ as.character(edges[,2]) ],
                        'e2'=geneLex[ as.character(edges[,1]) ], 
                        edgeType=edges[,3], pathway=edges[,4], 
                        stringsAsFactors = FALSE )
    }

    adjMat <- NULL
    if (nrow(edges) > 0)
    {
        # Keep only one interaction type
        idx     <- which(!duplicated(edgeLex[,1:2]))
        adjMat  <- ftM2adjM(as.matrix(edgeLex[idx, 1:2]), edgeLex[idx, 5], 
                            edgemode="directed")
        adjMat  <- adjMat[order(as.numeric(rownames(adjMat)) ), ]
        adjMat  <- adjMat[, order(as.numeric(colnames(adjMat)) )]
    }

    # Return values
    lex <- list('org'=org, 'genes'=geneLex, 'edges'=edgeLex, 'adjMat'=adjMat)
    
    return(lex)
}


filterMatrix <- function( adjMats, org, userGenes )
{

    if (is.null(userGenes))
    {
        return(adjMats)
    }

    filtAdjMats <- adjMats
    for (i in 1:length(adjMats))
    {
        if (is.null(adjMats[[i]]))  { next() }

        genes  <- rownames(adjMats[[i]])
        genes  <- lapply(genes, function(x) 
                    { matrix(as.numeric(unlist(strsplit(x, ' '))), nrow=1) })
        genes       <- unlistToMatrix(fillMatrixList(genes))
        idxGenes    <- matrix(genes %in% userGenes, nrow=nrow(genes)) * 1
        filtGenes   <- genes * idxGenes
        filtGenes[filtGenes == 0] <- ''
        rnames      <- apply(filtGenes, 1, function(x) 
                    { paste(x[which(x != '')], collapse=' ') })

        rownames(filtAdjMats[[i]])  <- rnames
        colnames(filtAdjMats[[i]])  <- rnames
        idx                         <- which(rnames != '')
        filtAdjMats[[i]]            <- filtAdjMats[[i]][idx, idx, drop=FALSE]

        # Remove rows and columns with duplicated names        
        idx              <- which(!duplicated(rownames(filtAdjMats[[i]])))
        filtAdjMats[[i]] <- filtAdjMats[[i]][idx, idx, drop=FALSE]
    }

    return(filtAdjMats)
}


##
## MiRNAs
##
.createMirnaLexicon <- function(org, genes)
{
    # Given a list of genes, and a file which maps miRNA's with their gene 
    # targets. Construct a vector containing the genes, followed by the 
    # miRNA's that target them. Their indexes are used to construct a two 
    # column matrix, containing the mirna's on the first column, and their 
    # respective gene targets on the second (index-index). 
    
    # Import mirgene map
    targets     <- importMiRNAFile(org)
    
    # Keep user miRNAs 
    e=new.env(); load(file=cache$dirs$mirnaExpressions, envir=e)
    miEx        <- e[[ls(e)[1]]]
    targets     <- targets[which((targets[,1] %in% rownames(miEx))),]
    
    # Find mirnas that target the given genes
    targets     <- targets[which((targets[,2] %in% names(genes))),]
    userMirs    <- unique(targets[,1])

    # Mirna names are accompanied by their indexes 
    mirs        <- (length(genes) + 1) : (length(genes) + length(userMirs))
    names(mirs) <- userMirs

    # Create edge list between mirnas and gene targets 
    edgeList           <- unique(targets[, 1:2])
    rownames(edgeList) <- 1:nrow(edgeList)

    # Create indexer
    interact     <- c(names(genes), userMirs)
    lib          <- 1:length(interact) 
    names(lib)   <- as.character(interact)

    # Edgelist
    idx           <- matrix(0, nrow=nrow(edgeList), ncol=2)
    # Index mirna's column
    idx[,1]       <- as.numeric(lib[edgeList[,1]])
    # Index gene targets column
    idx[,2]       <- as.numeric(lib[as.character(edgeList[,2])])
    colnames(idx) <- c(' ', ' ')
    edgeList      <- cbind(idx, edgeList)

    return(list('nodes'=mirs, 'edges'=edgeList))
}

    

##
## Others
##
getSubpathwayGenes <- function(subpaths, type)
{
    if ( !is(subpaths,'matrix') )
    {
        subpaths <- matrix(subpaths, nrow=1)
    }

    if (type == 'Linear')     
    {
        genes <- unique(as.vector(subpaths))
        genes <- genes[which(genes!=0)]
    }
    if (type == 'Non-Linear') 
    {
        usubs <- vector(mode='list', length=nrow(subpaths))
        for(i in 1:nrow(subpaths))
        {
            usub       <- unique(unlist(strsplit(subpaths[i,], split='-')))
            usubs[[i]] <- matrix(as.numeric(usub[which(usub!='0')]), nrow=1)
        }

        # Join list of named matrices to a single named matrix
        usubs <- unlistToMatrix(fillMatrixList(usubs))
        genes <- unique(as.vector(usubs))
    }


    return(genes)
}

extractNonLinearSubpathways  <- function(graphs, pathways, a, b, k, filter, 
                                        groupMode, export, verbose)
{
    if ( missing(verbose) ) { verbose <- TRUE }
    
    tryCatch(
    {        
        message('Extracting Non Linear Subpathways...', appendLF = FALSE)
        
        subsNonLinear <- .extractNonLinearSubpathways(graphs, pathways, 
                        a, b, k, filter, groupMode, export, verbose)

        message('done.')

        return(subsNonLinear)
    }, warning = function(war) 
    {
    }, error = function(e) 
                { 
                    closeAllConnections()
                    message('\nError in non linear extraction.'); 
                }
    , finally = { }
    )   
}


.extractNonLinearSubpathways <- function(graphs, pathways, a, b, k, filter, 
                                        groupMode, export, verbose)
{
    if (missing(verbose))   { verbose   <- TRUE }
    if (missing(a))         { a         <- 3  }
    if (missing(b))         { b         <- 10 }
    if (missing(k))         { k         <- 2  }
    if (missing(filter))    { filter    <- FALSE }
    if (missing(groupMode)) { groupMode <- c('expand') }
    if (missing(export))    { export    <- c('.RData') }

    opts     <- list(filter=filter, k=k, a=a, b=b, export=export)
    dirs     <- cache$dirs
    eAdjMats <- graphs$expanded
    cAdjMats <- graphs$combined
    org      <- graphs$org

    if (!missing(pathways))
    {
        # Keep a subset of pathways
        pathways <- paste(org, pathways, sep='')
        eAdjMats <- eAdjMats[pathways]
        cAdjMats <- cAdjMats[pathways]
    }

    .createDirectories(org)

    # Find user genes
    if (opts$filter)   
    {
        e=new.env(); load(cache$dirs$geneExpressions, e)
        geneEx     <- e[[ls(e)[1]]]
        genes     <- sort(as.numeric(unique(rownames(geneEx))))
    }
    if (!(opts$filter)) { genes <- NULL}


    # Filter adjacency matrices according to user genes
    if (groupMode == 'expand')   { adjMats <- eAdjMats }
    if (groupMode == 'collapse') { adjMats <- cAdjMats }

    adjMats  <- filterMatrix(adjMats=adjMats, org=org, userGenes=genes)

    # Build global gene and edge indexer
    lex      <- matrixToLexicon(adjMats=adjMats, org=org, 
                                    groupMode=groupMode)

    # Convert edgeType matrix to adjacency matrix
    adjMatsBin <- adjMats
    for (i in 1:length(adjMatsBin) ) 
    {
        if (is.matrix(adjMatsBin[[i]])) #if (!is.null(adjMatsBin[[i]]))
        {
            adjMatsBin[[i]][adjMatsBin[[i]] > 1] <- 1 
        }         
    }

    # Apply k-clique algorithm to find the k-subpaths for each pathway.
    export <- c('unlistToMatrix', 'as', 'graphAM', 'kCliques', 'ugraph')
    cores  <- ifelse( length(adjMatsBin) > detectCores()*10, 'default', 1 )
    subs   <- .doSafeParallel(funcName=.nlSubpaths,
                    export=export,
                    combine='default',
                    N=length(adjMatsBin),
                    cores=cores,
                    adjMatsBin, lex, k, names(adjMatsBin), a, b)

    if ( !is.null(subs) )        { names(subs) <- names(adjMatsBin) }
    if ( !is(subs,'list') ) { subs <- list(subs) }

    
    # Ensure that all subpaths have the same number of columns
    subs <- fillMatrixList(subs)

    # Join list of named matrices to a single named matrix
    subs <- unlistToMatrix(subs)

    # Delete temporaty files and directories
    .cleanDirectories()

    # Export subpaths
    exportSubpaths(subs, dir=paste(dirs$nlr, org, sep='//'), type=opts$export,
                    verbose=FALSE)

    subsNonLinear <- list(subpaths=subs, adjMats=adjMats, 
        groupMode=groupMode, org=org, lex=lex, subpathwayType='Non-Linear')

    return(subsNonLinear)
}


.nlSubpaths                   <- function(i, ...)
{
    # ------- Unpacking arguments -------
    args      <- list(...)
    adjMat    <- args[[1]][[i]]
    lex       <- args[[2]]
    k         <- args[[3]]
    pathname  <- args[[4]][i]
    a         <- args[[5]]
    b         <- args[[6]]
    # ----------------------------------

    org      <- lex$org
    edgeList <- lex$edges

    if (!is.matrix(adjMat)) { return() }

    tmp              <- paste(org,':',sep='')
    rownames(adjMat) <- gsub(tmp,'', rownames(adjMat))  #!!
    colnames(adjMat) <- gsub(tmp,'', colnames(adjMat))  #!!

    # Create a graphNEL graph from the adjacency matrix
    if (nrow(adjMat) * sum(adjMat) > 1e05)  
    { adjMat[lower.tri(adjMat, diag = FALSE)] <- 0 }
    G                <- as(graphAM(adjMat, 'directed'), 'graphNEL')
    ksubpath         <- kCliques(ugraph(G))[[paste(k, 'cliques', sep='-')]]
    if (is.null(ksubpath)) { return() }

    # Keep cliques of length a to b
    lgt             <- sapply(ksubpath, function(x) { length(x) })

    # Set max column count if right border is not supplied
    if(is.null(b)) { b <- max(lgt) }
    droppedSubsIdx  <- which(lgt<a  | lgt>b)
    acceptedSubsIdx <- which(lgt>=a & lgt<=b)

    # A subpath is stored in each line on Ld, and its maximum length is b.
    Ld <- matrix(0, nrow=length(ksubpath), ncol=b)

    for (j in acceptedSubsIdx)
    {
        Ld[j,] <- c(ksubpath[[j]], rep(0, b-lgt[j]))
    }
    if (length(droppedSubsIdx) > 0) 
    {  
        Ld <- matrix(Ld[-droppedSubsIdx,], ncol=b) 
    }
    if (nrow(Ld) == 0) {  return() }


    # Each subpath by now is a bucket of genes. Lets consider all the possible
    # interactions between those genes. Not all of them correspond to actual 
    # interactions. The ones that do are the final subpath. 
    R <- list()

    for (j in seq(nrow(Ld),1))
    {
        # Edge list indexes
        r1   <- as.numeric(is.element(edgeList[,1], Ld[j,]))
        r2   <- as.numeric(is.element(edgeList[,2], Ld[j,]))
        idx1 <- which((r1 + r2) == 2)
        idx2 <- which(edgeList[,6] == gsub(org, '', pathname))
        r    <- intersect(idx1, idx2)

        if ( length(r) > 0 ) 
        { 
            R <- c(R, list(r))
        }
    }
    names(R) <- rep(pathname, length(R))

    # Turn list of uneven subpaths to matrix (indexes of edgelist)
    iSubpaths <- unlistToMatrix(R)

    # Replace zeros with next availiable row index (max_index + 1). 
    iSubpaths[which(iSubpaths==0)] <- nrow(lex$edges) + 1

    # Create mapper from indexes to entrez numbers
    lib <- paste(lex$edges[,1], lex$edges[,2], sep='-')

    # Zero mapping (map (max_index + 1) to zero)
    lib <- c(lib, 0)

    # Turn indexes to entrez names edges
    subpaths <- matrix(lib[iSubpaths], nrow=nrow(iSubpaths))

    return(subpaths)
}

convertNomenclature  <- function(ids, org, from, to)
{
    
    tryCatch(
        .mRNAconversion(values=ids, 
                        org=org, 
                        filter=from, 
                        attributes=to),
        error=function(e) ' error ')
}

.mRNAconversion <- function(values, org, filter, attributes)
{
    # Find dataset
    datasets <- listDatasets(useMart("ensembl"))[, 'dataset']
    names(datasets) <- sapply(as.list(datasets), function(x) {substr(x,1,3)})
    dataset  <- unname(datasets[org])

    # Basic error checking
    if (org=='mmu') 
        { dataset <- 'mmusculus_gene_ensembl' }
    if (is.na(dataset) && !missing(org))     
        { cat('No dataset availiable for',org,'.\n'); return() }
    if (is.na(dataset) && missing(org))
        { cat('Please specify an organism.\n'); return() }
    if(missing(filter))
        { cat('Please specify a valid filter\n'); return() }
    if(missing(attributes))
        { cat('Please specify valid attributes.\n'); return() }
    
    # Perform query
    ensembl <- useMart("ensembl", dataset=as.character(dataset))
    attributes <- c(filter, attributes)
    res <- getBM(attributes=attributes, filters=filter, 
                    values=values, mart=ensembl)
    res <- trimws( as.matrix(res) )

    # Remove genes with no conversion
    idx <- which(res[, 2] == '')
    if ( length(idx) > 0 ) { res<- res[-idx, ] }

    rownames(res) <- 1:nrow(res)
    colnames(res) <- .getFilters()[colnames(res)]

    return(res)
}

.getFilters          <- function()
{
    filters     <- vector(mode="numeric", length=14)
    fnames      <- vector(mode="numeric", length=14)
    filters[1]  <- 'Ensembl Gene ID(s)'
    filters[2]  <- 'Ensemble transcript ID'
    filters[3]  <- 'Ensemble Protein ID'
    filters[4]  <- 'HGNC ID'
    filters[5]  <- 'HGNC symbol'
    filters[6]  <- 'HGNC transcript name'
    filters[7]  <- 'EntrezGene ID'
    filters[8]  <- 'Refseq mRNA ID(s)'
    filters[9]  <- 'Refseq protein ID(s)'
    filters[10] <- 'UniProt/Swissprot Accession(s)'
    filters[11] <- 'UniProt/Swissprot ID(s)'
    filters[12] <- 'UniGene ID(s)'
    filters[13] <- 'UniProt Genename ID(s)'
    filters[14] <- 'MGI symbol'
    fnames[1]   <- 'ensembl_gene_id'           
    fnames[2]   <- 'ensembl_transcript_id'
    fnames[3]   <- 'ensembl_peptide_id'
    fnames[4]   <- 'hgnc_id'
    fnames[5]   <- 'hgnc_symbol'
    fnames[6]   <- 'hgnc_transcript_name'
    fnames[7]   <- 'entrezgene'
    fnames[8]   <- 'refseq_mrna'
    fnames[9]   <- 'refseq_peptide'
    fnames[10]  <- 'uniprot_swissprot_accession'
    fnames[11]  <- 'uniprot_swissprot'
    fnames[12]  <- 'unigene'
    fnames[13]  <- 'uniprot_genename'
    fnames[14]  <- 'mgi_symbol'
    names(filters) <- fnames

    return(filters)
}

test_subVisualization <- function() 
{
    message('Testing test_subVisualization...', appendLF = FALSE)

    load(system.file('extdata', 'Examples//data.RData', package='CHRONOS'))
    
    sink( tempfile() ) 

    importExpressions(data=mRNAexpr, type='entrezgene', org='hsa')
    
    # Export the final subpathways to a xlsx file 
    linSubsVisualRun <- visualizeResults(summary=linSubsScored, export='.xlsx',
                        from='entrezgene', to='entrezgene')
    nliSubsVisualRun <- visualizeResults(summary=nliSubsScored, export='.xlsx',
                        from='entrezgene', to='entrezgene')

    # Visualize a subpathway
    linSubsmiRNAsRun <- subpathwayMiRNAs(summary=linSubsScored, subIdx=2, 
                                        timePoints=3)

    # Opening selected subpathways in default browser
    linLinksRun <- subpathwayKEGGmap(subpathways=linSubs$subpaths[1:2, , drop=FALSE], 
                                    type='Linear', openInBrowser=FALSE)

    sink()

    all.equal(linSubsVisualRun[, -9], linSubsVisual[, -9])
    all.equal(linSubsmiRNAsRun, linSubsmiRNAs)
    all.equal(linLinksRun, linLinks)

    message('done.')
}

visualizeResults <- function(summary, export, expand, colors, from, to)
{
    message('Summarising scores...', appendLF = FALSE)
    # 
    # Merging data to presentable form.
    # 
    subpaths      <- summary$subpaths
    pValues       <- summary$pValues
    subScore      <- summary$subScore
    sb            <- summary$measures[,1] # subPathness
    sp            <- summary$measures[,2] # subBC
    sd            <- summary$measures[,3] # subDEG 
    org           <- summary$org
    filters       <- summary$filters
    type          <- summary$type
    miRNAoverSubs <- as.vector(summary$miRNAsOverSubpathway)


    if (is.null(subpaths) || nrow(subpaths) == 0) 
    { 
        message('done.'); return(invisible()) 
    }
    if (missing(export)) 
    { 
        export <- c('.txt', '.xlsx') 
    }
    if (missing(expand)) 
    { 
        expand <- TRUE 
    }
    if (missing(colors)) 
    { 
        colors <- c('#FFFFFF', '#DCFFDC', '#99FF99', '#00EB00', '#00E100') 
    }
    if (missing(from)) { from <- 'entrezgene' } 
    if (missing(to)) { to <- 'entrezgene' } 

    # Round data
    pValues     <- format(ceiling(pValues*10^2)/10^2, scientific=FALSE)
    subScore    <- ceiling(subScore*10^3)/10^3
    sb          <- ceiling(sb*10^2)/10^1
    sp          <- ceiling(sp*10^2)/10^1
    sd          <- ceiling(sd*10^2)/10^1 

    # Creating directories    
    .createDirectories(org=org)


    # Map subpath ids to pathway names 
    pathways    <- downloadKEGGPathwayList(org)
    subpathIds  <- gsub(org, '', rownames(subpaths))
    y           <- pathways[,2]
    names(y)    <- pathways[,1]
    subNames    <- y[subpathIds]


    if (type == 'Linear')     
    {
        d   <- paste(cache$dirs$slnr, org, sep='//')
        f1  <- createScoreFile(dir=d, type='a', fileType='.txt')
        f2  <- createScoreFile(dir=d, type='a', fileType='.xlsx')
    }
    if (type == 'Non-Linear') 
    { 
        d   <- paste(cache$dirs$snlr, org, sep='//')
        f1  <- createScoreFile(dir=d, type='a', fileType='.txt')
        f2  <- createScoreFile(dir=d, type='a', fileType='.xlsx') 
    }

    pathnames <- list()

    # Subpath members (by removing zero placeholders)
    if (type=='Linear')
    {
        # Convert nomenclature
        ids <- unique(as.vector(subpaths))

        psubs2 <- NULL
        if ( from != to ) 
        {
            y <- convertNomenclature(ids=ids, org=org, from=from, to=to)

            if (nrow(y) > 1)
            {
                lib         <- y[,2]
                names(lib)  <- y[,1]
                
                z <- matrix(,nrow=nrow(subpaths), ncol=ncol(subpaths))
                for (i in 1:nrow(subpaths))
                {
                    z[i,] <- lib[as.character(subpaths[i,])]
                }    
                psubs2 <- apply(z, 1, paste, collapse=' ')
                psubs2 <- gsub(' NA',' ',psubs2)  # Remove zeros
            }else 
            {
                psubs2 <- apply(subpaths, 1, paste, collapse=' ')
                psubs2 <- gsub(' 0',' ',psubs2)  # Remove zeros          
            }
        }

        psubs1 <- apply(subpaths, 1, paste, collapse=' ')
        psubs1 <- gsub(' 0',' ',psubs1)  # Remove zeros
    }

    if (type=='Non-Linear')
    {
        usubs <- vector(mode='list', length=nrow(subpaths))
        for(i in 1:nrow(subpaths))
        {
            usub       <- unique(unlist(strsplit(subpaths[i,], split='-')))
            usubs[[i]] <- matrix(as.numeric(usub[which(usub!='0')]), nrow=1)

        }
        subs <- unlistToMatrix(fillMatrixList(usubs))
        ids  <- unique(as.vector(subs))

        psubs2 <- NULL
        if ( from != to ) 
        {
            y <- convertNomenclature(ids=ids, org=org, from=from, to=to)
            if (nrow(y) > 1)
            {
                lib         <- y[,2]
                names(lib)  <- y[,1]
                
                z <- matrix(,nrow=nrow(subs), ncol=ncol(subs))
                for (i in 1:nrow(subs))
                {
                    z[i,] <- lib[as.character(subs[i,])]
                }    
                psubs2 <- apply(z, 1, paste, collapse=' ')
                psubs2 <- gsub(' NA',' ',psubs2)  # Remove zeros
            }else 
            {
                psubs2 <- apply(subs, 1, paste, collapse=' ')
                psubs2 <- gsub(' 0',' ',psubs2)  # Remove zeros          
            }
        }

        psubs1 <- apply(subs, 1, paste, collapse=' ')
        psubs1 <- gsub(' 0',' ',psubs1)  # Remove zeros
    }

    # Create the links
    links        <- createKEGGLinks(subpaths, type=type, openInBrowser=FALSE)
    names(links) <- paste('S', 1:nrow(subpaths), sep='')

    # Create the main data frame
    titles <- paste('(', paste(org, names(subNames), ') ', sep=''), subNames, 
                    sep='')
    df     <- data.frame('Subpath'=links, 'Pathway'=titles, 
                    stringsAsFactors=FALSE)
    class(df$Subpath) <- c('hyperlink')

    # isMetabolic
    rnames        <- as.numeric(gsub(org, '', rownames(subpaths)))
    names(rnames) <- rownames(subpaths)
    isMetabolic   <- ifelse(rnames < 2000, '+', '-')
    df            <- cbind(df, data.frame('isMetabolic'=isMetabolic, 
                                            stringsAsFactors=FALSE)) 

    if ('subScore' %in% names(filters))  
    {
        # Append the gene scores for all time points
        dft           <- data.frame(subScore, stringsAsFactors=FALSE)
        colnames(dft) <- paste('T', 1:ncol(subScore), sep='')
        df            <- cbind(df, dft)
    }

    if ('p-value' %in% names(filters))           
    {
        df <- cbind(df, data.frame('q-value'=pValues, stringsAsFactors=FALSE))
    }


    if ('measures' %in% names(filters))           
    {
        df <- cbind(df, data.frame('subPathness'=sb, stringsAsFactors=FALSE))
        df <- cbind(df, data.frame('subBC'=sp, stringsAsFactors=FALSE)) 
        df <- cbind(df, data.frame('subDEG'=sd, stringsAsFactors=FALSE))
    }

    from.name      <- .getFilters()[from]
    to.name        <- .getFilters()[to]
    dft1           <- data.frame(psubs1, stringsAsFactors=FALSE)
    colnames(dft1) <- from.name
    if ( !is.null(psubs2) )
    {
        dft2           <- data.frame(psubs2, stringsAsFactors=FALSE)
        colnames(dft2) <- to.name
        df             <- cbind(df, dft2, dft1)
        rr <- 2
    }
    if ( is.null(psubs2) )
    {
        df <- cbind(df, dft1)
        rr <- 1
    }


    # Create a header mapper
    header <- c('baseStart'=1, 'baseStop'=3)
    header <- c(header, 'scoreStart'=(3+1), 'scoreStop'=(3+ncol(subScore)))
    right  <- (3 + ncol(subScore))
    if ('p-value' %in% names(filters))
    {
        header     <- c(header, 'p-value'=(right + 1))
        right     <- (right + 1)
    }
    if ('measures' %in% names(filters))
    {
        header <- c(header, 'measuresStart'=(right + 1), 
                    'measuresStop'=(right + 3))
        right  <- (right + 3)
    }    
    header     <- c(header, 'memberStart'=(right + 1), 
                    'memberStop'=(right + rr))
    right     <- (right + rr)
    if ('mirScore' %in% names(filters))
    {
        header <- c(header, 'mirStart'=(right + 1), 'mirStop'=(right + 1))
        right  <- (right + 1)
    }

    if ('mirScore' %in% names(filters))        
    {
        df <- cbind(df, data.frame('miRNA'=miRNAoverSubs, 
                                stringsAsFactors=FALSE))
    }
    if ('.xlsx' %in% export  &&  expand)
    { 
        .createExcelOutputMulti(df=df, links=links, file=f2, filters=filters,
                                header=header, colors=colors)
    }
    if ('.xlsx' %in% export  &&  !expand)
    { 
        .createExcelOutputSingle(df=df, links=links, file=f2, filters=filters,
                                header=header, colors=colors)
    }
    if ('.txt' %in% export)
    {
        df[,1] <- names(links)
        exportToFile(df, f1, append=FALSE)        
    }


    message('done.')

    return(df)
}

.createExcelOutputSingle <- function(df, links, file, filters, header, colors)
{
    # Specify columns according to specified filters
    ncols   <- 2 # Members
    hypCols <- 0; mesCols <- 0; mirCols <- 0
    if ('p-value' %in% names(filters))       
    { 
        ncols <- ncols + 1
        hypCols <- 1
    }
    if ('measures' %in% names(filters))      
    { 
        ncols <- ncols + 3 
        mesCols <- 3
    }
    if ('mirScore' %in% names(filters))      
    { 
        ncols <- ncols + 1
        mirCols <- 1
    }

    # Determime columns for each group
    subScoreRange <- 4 : (ncol(df) - ncols)

    if ('measures' %in% names(filters))      
    {
        measuresRange <- (ncol(df) - ncols + 1 + hypCols) : 
                            (ncol(df) - ncols + hypCols + mesCols) 
    }

    a             <- (ncol(df) - ncols + hypCols + mesCols)
    membersRange  <- (a + 1) : (a + 2)


    # Bind a row on top of df with column groupings 
    # (Subscores, Measures, miRNA Mediated Subpathway Members)
    cnames <- colnames(df)
    cnames <- paste(' ', cnames, ' ', sep='')
    df     <- rbind(cnames,df)
    cnames <- c('', '', '')
    cnames <- c(cnames, rep('Subscores', length(subScoreRange)), '')
    
    if ('measures' %in% names(filters))       
    {
        cnames <- c(cnames, rep('Measures',3))    
    }

    cnames <- c(cnames, rep('miRNA Mediated Subpathway Members',2), '')
    df     <- rbind(cnames, df)

    wb    <- createWorkbook()
    addWorksheet(wb, 'Results')
    cl    <- lapply(df, function(x) tolower(class(x)))
    wb$writeData(sheet='Results', df=df, startRow=1, startCol=1, 
                colClasses = cl, hlinkNames = c('','SubId',names(links)), 
                colNames=FALSE, keepNA=FALSE) 


    # Customize output
    setColWidths(wb, sheet='Results', cols=1:ncol(df), widths='auto')
    modifyBaseFont(wb, fontSize=10, fontColour='#000000', fontName="Segoe UI")
    freezePane(wb, sheet='Results', firstActiveRow=3, firstActiveCol=2)


    # Main Body
    style <- createStyle(fontSize=10, fontName='Segoe UI', halign="left", 
                        valign = "center", fgFill='#ffffff', 
                        borderColour='#000000')
    addStyle(wb, sheet='Results', style=style, rows=2:(nrow(df)+1),
                        cols=1:ncol(df), gridExpand=TRUE)

    # Gene scores and topologics
    style <- createStyle(fontSize=10, fontName='Segoe UI', halign="center", 
                        valign = "center", fgFill='#ffffff', 
                        borderColour='#000000')
    addStyle(wb, sheet='Results', style=style, rows=2:(nrow(df)+1), 
                cols=3:ncol(df), gridExpand=TRUE)

    # Gene members and mirnas
    style <- createStyle(fontSize=10, fontName='Segoe UI', halign="left", 
                        valign = "center", fgFill='#ffffff', 
                        borderColour='#000000')

    if (!'mirScore' %in% names(filters)) 
    { 
        tcols <- ncol(df) 
    } 
    if ('mirScore' %in% names(filters))   
    { 
        tcols <- (ncol(df)-1):ncol(df) 
    }
    addStyle(wb, sheet='Results', style=style, rows=2:(nrow(df)+1), 
        cols=tcols, gridExpand=TRUE)


    # Header
    mergeCells(wb, sheet='Results', rows=1, cols=subScoreRange)
    if ('measures' %in% names(filters))          
    {
        mergeCells(wb, sheet='Results', rows=1, cols=measuresRange)
    }
    mergeCells(wb, sheet='Results', rows=1, cols=membersRange)


    style <- createStyle(fontSize=11, fontName='Segoe UI', 
            fontColour='#000000', halign="center", valign = "center", 
            fgFill='#ffffff', borderColour = '#000000')
    addStyle(wb, sheet='Results', style=style, rows=1, cols=1:ncol(df),
            gridExpand=TRUE)


    # Header Column
    style <- createStyle(fontSize=11, fontName='Segoe UI', halign="left", 
                        valign = "center", fgFill='#ffffff', 
                        borderColour='#000000')
    addStyle(wb, sheet='Results', style=style, rows=1:(nrow(df)+1), cols=1:1, 
                        gridExpand=TRUE)

    setRowHeights(wb, sheet='Results', rows = 1, heights = 35)
    setRowHeights(wb, sheet='Results', rows = 2:(nrow(df)+1), heights = 25)

    # Split gene score matrix to part based on the score
    S      <- df[, 4:(ncol(df) - ncols), drop=FALSE]
    rn     <- 1:12
    breaks <- unname(sapply(split(rn,cut(rn,quantile(rn,(0:k)/k), 
                    include.lowest=TRUE)), function(x) { x[2] }))
    breaks <- c(0, breaks/10)
    k      <- length(colors) + 1

    for (i in 2:k)
    {
        idx  <- which((S >= breaks[i-1]) & (S < breaks[i]))
        rows <- ((idx-1) %% nrow(S)) + 1
        cols <- floor((idx-1)/nrow(S)) + 1
        # Set cell colors of gene scores according to their scores
        style <- createStyle(fontSize=10, fontName='Segoe UI', 
            halign="center", valign = "center", fgFill=colors[i-1])
        addStyle(wb, sheet='Results', style=style, rows=0+rows, cols=3+cols,
            gridExpand=FALSE)
    }

    saveWorkbook(wb, file, overwrite=TRUE)  
}

.createExcelOutputMulti  <- function(df, links, file, filters, header, colors)
{

    # Find number of necessary miRNA columns 
    mirCols <- 0
    if ('mirScore' %in% names(filters))      
    {
        mirCols <- 1
        for (i in 1:nrow(df))
        {
            mirs = unlist(strsplit(df[i,header['mirStart']], ' '))
            if (length(mirs) > mirCols) { mirCols <- length(mirs) }
        }
    }

    # Find number of necessary members columns 
    genCols <- 0
    for (i in 1:nrow(df))
    {
        gens = unlist(strsplit(df[i,header['memberStart']], ' '))
        if (length(gens) > genCols) { genCols <- length(gens) }
    }
    genCols <- (header['memberStop'] - header['memberStart'] + 1)*genCols

    x           <- matrix('', nrow=nrow(df), ncol=mirCols + genCols)
    colnames(x) <- rep(' ', mirCols + genCols)

    # Fill first b columns of expansion with individual genes
    for (i in 1:nrow(x))
    {
        if (header['memberStop'] - header['memberStart'] > 0)
        {
            # Symbol
            geneSymbols <- unlist(strsplit(df[i,header['memberStart']], ' '))
            x[i, 1:length(geneSymbols)]  <- geneSymbols

            # Entrez
            geneEntrez <- unlist(strsplit(df[i,header['memberStop']], ' '))
            idx1 <- length(geneSymbols) + 1
            idx2 <- length(geneSymbols) + length(geneEntrez)
            x[i, idx1: idx2]  <- as.integer(geneEntrez)
        }
        if (header['memberStop'] - header['memberStart'] == 0)
        {
            geneEntrez <- unlist(strsplit(df[i,header['memberStart']], ' '))
            x[i, 1:length(geneEntrez)]  <- geneEntrez
        }

        if ('mirScore' %in% names(filters))      
        {    
            mirs  <- unlist(strsplit(df[i,header['mirStart']], ' '))
            if (length(mirs) > 0)
            {
                x[i, (genCols + 1) : (genCols + length(mirs))] <- mirs    
            }
        }
    }
    # Remove empty columns
    idx <- which(is.na(x))
    if ( length(idx) > 0 ) { x[idx] <- ''  }
    idx <- table(which(x == '', arr.ind=TRUE)[, 'col'])
    idx <- as.numeric(names(idx)[which(unname(idx) == nrow(x))])

    if ( length(idx) > 0 ) 
    { 
        x <- x[, -idx, drop=FALSE]
        genCols <- genCols - length(idx)
    }

    from     <- colnames(df)[header['memberStart']]
    to       <- colnames(df)[header['memberStop']]
    qvalCols <- 0
    mesCols  <- 0
    if ('p-value'  %in% names(filters))   { qvalCols<- 1 }
    if ('measures'  %in% names(filters))  { mesCols <- 3 }
    if ('mirScore' %in% names(filters))
    {
        idx <- c(header['memberStart'], header['memberStop'], 
                header['mirStart'])
    }
    if (!'mirScore' %in% names(filters))  
    {
        idx <- c(header['memberStart'], header['memberStop'])
    }
    df <- cbind(df[,-idx], as.data.frame(x, stringsAsFactors=FALSE))


    # Specify columns according to specified filters
    subScoreRange <- 4 : (ncol(df) - (mirCols + genCols + qvalCols + mesCols))
    a             <- tail(subScoreRange,1) + 1

    if ('p-value' %in% names(filters))   
    {
        qvaluesRange <- a : a
        a            <- tail(qvaluesRange,1) + 1  
    }
    if ('measures' %in% names(filters))      
    {
        measuresRange <- a : (a + 2)
        a             <- tail(measuresRange,1) + 1
    }

    membersRange <- a : (a + genCols - 1) 

    if ('mirScore' %in% names(filters))      
    { 
        a        <- tail(membersRange,1) + 1
        mirRange <- a : (a + mirCols - 1)
    }

    # Bind a row on top of df with column groupings 
    # (Subscores, Measures, miRNA Mediated Subpathway Members)
    df     <- rbind(paste(' ', colnames(df), ' ', sep=''), df)
    cnames <- c(rep('',3), rep('Subscores', length(subScoreRange)))

    if ('p-value' %in% names(filters))    
    { 
        cnames <- c(cnames, rep('', 1)) 
    }
    if ('measures' %in% names(filters))    
    { 
        cnames <- c(cnames, rep('Measures', 3)) 
    }

    if (from != to)
    {
        title <- paste0('miRNA Mediated Subpathway Members  (', from, ', ', 
                    to, ')')
    }
    if (from == to)
    {
        title <- paste0('miRNA Mediated Subpathway Members  (', from, ')')
    }
    cnames <- c(cnames, rep(title, genCols), rep('miRNAs', mirCols))
    df     <- rbind(cnames, df)
    wb     <- createWorkbook()
    addWorksheet(wb, 'Results')
    cl     <- lapply(df, function(x) tolower(class(x)))
    wb$writeData(sheet='Results', df=df, startRow=1, startCol=1, 
                colClasses = cl, hlinkNames = c('','SubId',names(links)), 
                colNames=FALSE, keepNA=FALSE) 


    # Customize output
    cols <- c(1:3, subScoreRange)
    if ('p-value' %in% names(filters))   { cols <- c(cols, qvaluesRange) }
    if ('measures' %in% names(filters))  { cols <- c(cols, measuresRange) }
    if ('mirScore' %in% names(filters))  { cols <- c(cols, mirRange) }


    setColWidths(wb, sheet='Results', cols=cols, widths='auto')
    modifyBaseFont(wb, fontSize=10, fontColour='#000000', fontName="Segoe UI")
    freezePane(wb, sheet='Results', firstActiveRow=3, firstActiveCol=2)


    # Main Body
    style <- createStyle(fontSize=10, fontName='Segoe UI', halign="left", 
                        valign = "center", fgFill='#ffffff', 
                        borderColour='#000000')
    addStyle(wb, sheet='Results', style=style, rows=2:(nrow(df)+1), 
                cols=1:ncol(df), gridExpand=TRUE)

    # Gene scores and topologics
    style <- createStyle(fontSize=10, fontName='Segoe UI', halign="center", 
                        valign = "center", fgFill='#ffffff', 
                        borderColour='#000000')
    addStyle(wb, sheet='Results', style=style, rows=2:(nrow(df)+1), 
                        cols=3:ncol(df), gridExpand=TRUE)

    # Gene members and mirnas
    style <- createStyle(fontSize=10, fontName='Segoe UI', halign="left", 
                        valign = "center", fgFill='#ffffff', 
                        borderColour='#000000')

    addStyle(wb, sheet='Results', style=style, rows=3:nrow(df), 
                cols=membersRange, gridExpand=TRUE)

    # Header
    mergeCells(wb, sheet='Results', rows=1, cols=subScoreRange)
    if ('measures' %in% names(filters))          
    {
        mergeCells(wb, sheet='Results', rows=1, cols=measuresRange)
    }

    mergeCells(wb, sheet='Results', rows=1, cols=membersRange)

    if ('mirScore' %in% names(filters))      
    { 
        mergeCells(wb, sheet='Results', rows=1, cols=mirRange)
    }

    style <- createStyle(fontSize=11, fontName='Segoe UI', 
            fontColour='#000000', halign="center", valign = "center", 
            fgFill='#ffffff', borderColour = '#000000')
    addStyle(wb, sheet='Results', style=style, rows=1, cols=1:ncol(df), 
            gridExpand=TRUE)

    # Header Column
    style <- createStyle(fontSize=11, fontName='Segoe UI', halign="left", 
                        valign = "center", fgFill='#ffffff', 
                        borderColour='#000000')
    addStyle(wb, sheet='Results', style=style, rows=1:(nrow(df)+1), cols=1:1, 
                        gridExpand=TRUE)

    setRowHeights(wb, sheet='Results', rows = 1, heights = 35)
    setRowHeights(wb, sheet='Results', rows = 2:(nrow(df)+1), heights = 25)


    # Split gene score matrix to part based on the score
    S          <- df[, subScoreRange, drop=FALSE]
    k         <- length(colors) + 1
    rn         <- 1:(2*k)
    breaks     <- unname(sapply(split(rn,cut(rn,quantile(rn,(0:k)/k), 
                include.lowest=TRUE)), function(x) { x[2] }))
    breaks     <- c(0, breaks/((k-1)*2))
    
    for (i in 2:k)
    {
        idx  <- which((S >= breaks[i-1]) & (S < breaks[i]))
        # Index to row and column
        rows <- ((idx-1) %% nrow(S)) + 1
        cols <- floor((idx-1)/nrow(S)) + 1
        # Set cell colors of gene scores according to their scores
        style <- createStyle(fontSize=10, fontName='Segoe UI', 
                    halign="center", valign = "center", fgFill=colors[i-1])
        addStyle(wb, sheet='Results', style=style, rows=rows, cols=3+cols, 
                    gridExpand=FALSE)
    }

    saveWorkbook(wb, file, overwrite=TRUE)  
}


subpathwayKEGGmap <- function(subpathways, type, openInBrowser)
{
    
    createKEGGLinks(subpathways, type, openInBrowser)
}

createKEGGLinks   <- function(subpaths, type, openInBrowser)
{
    links <- vector(mode='numeric', length=nrow(subpaths))
    for(i in 1:nrow(subpaths))
    {
        if (type == 'Linear')
        {
            links[i] <- createKEGGLink(subpaths[i,,drop=FALSE], 
                        openInBrowser=openInBrowser)
        }
        if (type == 'Non-Linear')
        {
            sub           <- unlist(strsplit(subpaths[i,], split='-'))
            sub           <- matrix(unique(sub), nrow=1)
            rownames(sub) <- rownames(subpaths[i,,drop=FALSE])
            links[i]      <- createKEGGLink(sub, openInBrowser)
        }
    }

    return(links)
}

createKEGGLink    <- function(subpath, openInBrowser)
{
    #
    # Create KEGG map link
    #

    if (missing(openInBrowser)) { openInBrowser <- TRUE}

    pathway <- rownames(subpath)
    prefix  <- paste0('http://www.kegg.jp/kegg-bin/show_pathway?', pathway)
    suffix  <- c()
    for (i in 1:ncol(subpath))
    {
        sf     <- paste(as.numeric(subpath[1,i]), '%09yellow,red')
        suffix <- paste(suffix, sf, sep='/')
    }
    link <- paste(prefix, suffix, sep='')

    if (openInBrowser) { browseURL(link) }
    
    return(link)
}



subpathwayMiRNAs  <- function(summary, subIdx, timePoints)
{
    subpath  <- summary$subpaths[subIdx, , drop=FALSE]
    edgeList <- summary$edgeList
    tt       <- ncol(edgeList) - 2
    thres    <- unname(summary$filters['mirScore'])
    org      <- summary$org
    type     <- summary$type

    if (type == 'Linear')     { baseDir <- cache$dirs$vlnr }
    if (type == 'Non-Linear') { baseDir <- cache$dirs$vnlr }

    filename <- paste0(baseDir, '//subpathway', subIdx, '.pdf')

    if ( missing(timePoints) )
    {
        timePoints <- 1:tt
    }
    if ( !missing(timePoints) )
    {        
        if ( length(which(!timePoints %in% 1:tt)) > 0 )
        {
            message('Invalid time point.')
            return(NULL)
        }
    }

    # Final miRNA-mRNA interactions (miRNA x mRNA)
    sub.edgeList <- edgeList[edgeList[, 2] %in% subpath, ]
    sub.edgeList[, 1] <- gsub(paste0(org,'-'), '', sub.edgeList[, 1])

    mats <- list()
    for ( t in timePoints)
    {
        sub.t.edgeList <- sub.edgeList[, c(1:2, 2+t)]
        idx            <- which(sub.t.edgeList[, 3,  drop=TRUE] > thres)
        sub.t.edgeList <- sub.edgeList[idx, , drop=FALSE]
        sub.miRNAs  <- unique(sub.t.edgeList[, 1])
        sub.mRNAs   <- getSubpathwayGenes(subpath, 'Linear')
        nrows       <- length(sub.miRNAs)
        ncols       <- length(sub.mRNAs)
        sub.edgeMat <- matrix(0, nrow=nrows, ncol=ncols)
        rownames(sub.edgeMat) <- sub.miRNAs
        colnames(sub.edgeMat) <- sub.mRNAs

        for ( i in 1:nrow(sub.t.edgeList) )
        {
            idx1 <- which(rownames(sub.edgeMat) == sub.t.edgeList[i, 1])
            idx2 <- which(colnames(sub.edgeMat) == sub.t.edgeList[i, 2])
            sub.edgeMat[idx1, idx2] <- sub.edgeMat[idx1, idx2] + 1
        }

        # sub.edgeMat <- sub.edgeMat[which(rowSums(sub.edgeMat) > 0), , 
        #                             drop=FALSE]
        # sub.edgeMat <- sub.edgeMat[, which(colSums(sub.edgeMat) > 0), 
        #                             drop=FALSE]

        # Add a null miRNA that targets all genes by default so that mRNAs
        # with no interactions do not have to be removed.
        mat           <- sub.edgeMat * 100
        mat           <- rbind(rep(1, ncol(mat)), mat)
        rownames(mat) <- c(' ', rownames(sub.edgeMat) )
        mats         <- c(mats, list(mat))
    }

    doCirclize(mats, filename)

    return( mats )
}

doCirclize        <- function(mats, filename)
{
    # doCirclize
    tt <- length(mats)
    pdf(filename, width=3*tt, height=3, onefile=TRUE)
    par(mfrow=c(1, tt))

    for ( t in 1:tt )
    {
        mat <- mats[[t]]
        order <- c(rownames(mat), rev(colnames(mat)))
        
        # miRNA colors
        colors        <- c('#ffffff', rainbow(nrow(mat)-1))
        names(colors) <- rownames(mat)

        bgap <- 50

        gd   <- c(rep(2, nrow(mat)-1), bgap, rep(2, ncol(mat)-1), bgap)
        gcol <- NULL
        gcol[rownames(mat)]   <- colors[rownames(mat)]
        gcol[colnames(mat)]   <- 'lightgray'

        # Example
        degree <- 163

        circos.par(start.degree = degree, gap.degree = gd)
        chordDiagram(mat,order=order, grid.col = gcol, transparency = 0.5, 
                    annotationTrack="grid", annotationTrackHeight=0.01, 
                    preAllocateTracks=1)

        # since default text facing in `chordDiagram` is fixed, we need to 
        # manually add text in track 1
        for(si in get.all.sector.index()) 
        {
            xlim = get.cell.meta.data("xlim", sector.index = si, 
                                    track.index = 1)
            ylim = get.cell.meta.data("ylim", sector.index = si, 
                                    track.index = 1)
            circos.text(mean(xlim), ylim[1], si, facing = "clockwise", 
                        adj = c(0, 1.5),
            niceFacing = TRUE, cex = 0.7, col = "black", sector.index = si, 
                        track.index = 1)
        }

        circos.clear() 
    }
    
    dev.off()
}

test_subExtractionLinear <- function() 
{
    message('Testing test_subExtractionLinear...', appendLF = FALSE)

    # Load pathway graphs from toy data
    load(system.file('extdata', 'Examples//data.RData', package='CHRONOS'))

    sink( tempfile() ) 

    # Import mRNA expressions
    mRNAexpr <- importExpressions(data=mRNAexpr, type='entrezgene', org='hsa')
    # Extract linear subpathways
    linSubsRun <- extractLinearSubpathways(graphs=graphs, filter=TRUE)
    
    sink()

    all.equal(linSubsRun, linSubs)

    message('done.')
}

test_subRefinement <- function() 
{
    message('Testing test_subRefinement...', appendLF = FALSE)

    # Load extracted subpathways from toy data
    load(system.file('extdata', 'Examples//data.RData', package='CHRONOS'))

    sink( tempfile() ) 

    # Import mRNA expressions
    mRNAexpr  <- importExpressions(data=mRNAexpr, type='entrezgene', org='hsa')
    # Import miRNA expressions
    miRNAexpr <- importExpressions(data=miRNAexpr, type='miRNA', org='hsa')

    # Score extracted linear subpathways
    filters          <- c('subScore'=0.4, 'mirScore'=0.4)
    linSubsScoredRun <- scoreSubpathways(subpathways=linSubs, filters=filters,
                        miRNAinteractions=miRNAinteractions)
    all.equal(linSubsScoredRun, linSubsScored)    

    sink()

    message('done.')
}

downloadMiRecords     <- function(org, pn, update, databases)
{
    #
    # Downloads mirna data from miRecords and summarizes all organism 
    # interactions between mirnas and gene targets. 
    #

    message('Downloading miRecords data...', appendLF = FALSE)
    if (missing(update))    { update    <- FALSE }
    if (missing(databases)) { databases <- 'All' }
    if (missing(pn))        { pn        <- 5 }


    # Create the organism download directory and file
    dir  <- cache$dirs$miDir
    file <- cache$dirs$miFile
    dir  <- paste(dir, org, sep='//')
    file <- paste(dir, file, sep='//')
    if (!file.exists(dir))  { dir.create(dir, recursive=TRUE) }
    if (!file.exists(file)) { file.create(file) }

    # Create full records and store them locally 
    targets <- tryCatch( 
    { 
        if (!update)
        {
            # Download from remote server
            df <- .getProcessedData(pn=pn, file=file, databases=databases,
                org=org)
        }
        if (update)
        {
            miRecordsFile <- cache$dirs$miRecordsFile
            tarBaseFile   <- cache$dirs$tarBaseFile

            df1 <- .getValMiRecordsTargets(miRecordsFile=miRecordsFile, 
                                            org=org)

            df2 <- .getValTarbaseTargets(tarBaseFile=tarBaseFile, org=org)

            df3 <- .getMiRecordsData(org=org, pn=pn, k=24)
            
            # Filter predicted targets according to selected databases.
            df3 <- .filterRecords(targets=df3, databases=databases)

            df  <- rbind(df1, df2, df3)
            df  <- df[!duplicated(df[,1:2]), ]
        }
        targets <- df
    }, 
        error = function(e) 
        {
            df <- .getProcessedData(pn=pn, file=file, mode='error', 
                    databases=databases, org=org)
        }
    ) 

    save(file=file, targets, compress='xz')

    message('done.')

    return(targets)
}


#
# Download miRNA predicted targets from miRecords
#
.getMiRecordsData     <- function(org, pn, k)
{
    # Create and register parallel backend
    cl <- makeCluster(detectCores(logical=FALSE))
    on.exit(stopCluster(cl), add=TRUE)
    registerDoParallel(cl)

    # Get the list of all availiable mirnas for organism
    lines  <- .getMiRecordsMiRNAs(org)

    # Current http links for retrieving KEGG xml file
    mirror <- 'http://c1.accurascience.com/miRecords'
    prefix <- paste(mirror, '/download_data.php?p=1', sep='') 
    suffix <- '&targetgene_type=refseq_acc'
    suffix <- paste0(suffix, '&targetgene_info=&search_int=Search&pn=')
    
    # Create download links 
    species <- paste('&species=', org, sep='') 
    mirnas  <- paste('&mirna_acc=', lines, sep='')
    links   <- paste(prefix, species, mirnas, suffix, pn, sep='')    

    # Download data 
    S <- splitWork(N=length(lines), k=k)
    i <- 0
    R <- foreach (i = 1:S$k, .combine='rbind') %do%
    {
        rawText <- getURL(links[S$jobs[[i]]], 
                            .opts = list(timeout = 20, verbose=FALSE))
        Sys.sleep(1)
        # Data cleanup
        Rt <- matrix(nrow=0, ncol=14)
        for (r in rawText)
        {
            r1 <- as.list(unlist(strsplit(r, '\n'))[-c(1,2)])
            r2 <- sapply(r1, function(x)   { strsplit(x, '\t') })
            rt <- t(sapply(r2, function(x) { x[-c(2,5)] }))

            if(ncol(rt) == ncol(Rt)) { Rt <- rbind(Rt, rt) }
        }

        return(Rt)
    }
    if ( nrow(R) > 0 ) { rownames(R) <- 1:nrow(R) } 
    
    db <- c('diana', 'microinspector', 'miranda', 'mirtarget2', 'mitarget', 
            'nbmirtar', 'pictar', 'pita', 'rna22', 'rnahybrid', 'targetscan')
    colnames(R) <- c('mirna', 'Refseq', 'GeneName', db)
    R         <- as.data.frame(R, stringsAsFactors=FALSE)
    
    if ( nrow(R) == 0 )
    {
        colnames(R)[2] <- 'Entrez'; return(R)
    }

    #
    # Annotate genes from NCBI Refseq to Entrez Gene Accession
    #
    targets <- R[, 2]
    
    # Annotate targets to entrez ids.
    annMap <- convertNomenclature(ids=targets, org=org, from='refseq_mrna', 
                                    to='entrezgene')

    # Annotation answer from ensembl server contains unique matches, 
    # whereas a gene can be the target of multiple miRNAs. 
    # Create a hash to map distinct refseq ids to entrez ids.
    lib1        <- annMap[, 2]
    names(lib1) <- annMap[, 1]
    hitIdx      <- !is.na(lib1[targets])
    R           <- R[hitIdx, ]
    targets     <- targets[hitIdx]

    # Map all original refseq targets to entrez
    R[,2]          <- lib1[targets]
    colnames(R)[2] <- 'Entrez'

    if ( nrow(R) == 0 ) { return(R) }

    # Remove duplicates
    idx <- which(duplicated(R[, 2:3]) )
    if (length(idx) > 0) 
    { 
        R       <- R[-idx, , drop=FALSE]
        targets <- targets[-idx]
    }
        
    # Remove interactions between miRNAs and genes with no entrez annotation
    idx <- which(R[,2] == targets)
    if (length(idx) > 0) { R <- R[-idx, , drop=FALSE] }

    if ( nrow(R) > 0 )
    {
        R           <- R[!duplicated(R[,1:2]), ]
        rownames(R) <- 1:nrow(R)
    }

    return(R)
}


.getMiRecordsMiRNAs  <- function(org)
{
    #
    # Downloads HTML code and parses it for all availiable mirnas of organism
    #
    link    <- 'http://c1.accurascience.com/miRecords/prediction_query.php'
    rawText <- getURL(link)
    
    # Extract mirnas for each organism 
    R   <- strsplit(rawText, 'species.value==')
    R   <- lapply(R, function(x) { unlist(strsplit(x, 'else')) })
    R   <- sapply(R, function(x) { x[-seq(1,length(x)-1,2)] })
    R   <- sapply(R, function(x) { unlist(strsplit(x, '[()]')) } )
    orgs <- sapply(R, function(x) { gsub('\'','',x[1]) } )
    R   <- sapply(R, function(x) { x[seq(1,length(x)-1,2)] })
    R   <- sapply(R, function(x) { gsub('\'','',x) })
    R   <- sapply(R, function(x) { unlist(strsplit(x, ',')) } )
    R   <- sapply(R, function(x) { x[seq(3,length(x)-1,2)] })
    R   <- R[-length(R)]

    names(R) <- sapply(strsplit(orgs[-length(orgs)],' '), function(x) 
                { 
                    tolower(paste(substr(x[1],1,1), substr(x[2],1,2), sep=''))
                })


    # If an organism has been specified, return only corresponding mirnas.
    if (!org %in% names(R)) 
    { 
        message(org, 'mirnas not availiable in miRecords.')
        return(NULL) 
    }
    if (!missing(org))
    { 
        R <- R[[org]] 
    }

    return(R)
}


#
# Download miRNA validated targets from miRecords
#
.getValTarbaseTargets   <- function(tarBaseFile, org)
{
    data    <- read.xlsx(xlsxFile=tarBaseFile)
    data    <- data[, c('Organism', 'miRNA', 'Gene', 'Ensembl')]
    orgName <- ''

    if (org == 'hsa')   { orgName <- 'Human' }
    if (org == 'mmu')   { orgName <- 'Mouse' }
    if (org == 'rno')   { orgName <- 'Rat' }
    if (orgName == '')  { return(NULL) }

    # Keep only organism specific interactions
    idx       <- which(data[,1] == orgName)
    if (length(idx) > 0) { data <- data[idx, -1, drop=FALSE] }

    df        <- cbind(data[,1], data[,3], data[,2])
    summary   <- matrix(0, nrow=nrow(df), ncol=11)
    R         <- cbind(df, summary)
    db        <- c('diana', 'microinspector', 'miranda', 'mirtarget2', 
                        'mitarget', 'nbmirtar', 'pictar', 'pita', 'rna22', 
                        'rnahybrid', 'targetscan')
    colnames(R)  <- c('mirna',  'Ensembl', 'GeneName', db)
    rownames(R)  <- 1:nrow(R)
    R            <- as.data.frame(R, stringsAsFactors=FALSE)
    R[,'diana']  <- 1

    # Convert miRNA names to the ones currently used by miRecords
    mirOld    <- paste(org, '-', unique(R[,1]), sep='')
    mirConv   <- convertMiRNANomenclature(org=org, miRNAs=mirOld)

    # Find miRNAs with no conversion
    idx       <- which(is.na(mirConv[,2]))
    if (length(idx) > 0)
    {
        mirDeleted  <- mirConv[idx, 1]
        mirDeleted  <- gsub(paste(org, '-', sep=''), '', mirDeleted)
        # Remove these miRNAs from results
        idx   <- which(R[,1] %in% mirDeleted)
        if (length(idx) > 0)
        { 
            R <- R[-idx, ,drop=FALSE] 
        }
        if (nrow(R) == 0)     { return(R) }
    }

    # Remove interactions with no ensembl targets
    idx   <- which(R[,2] == 'n_a')
    if (length(idx) > 0)
    {
        R <- R[-idx, ,drop=FALSE]
    }
    if (nrow(R) == 0) { return(R) }

    R[, 1]      <- paste(org, '-', R[,1], sep='') 
    rownames(R)  <- 1:nrow(R)

    #
    # Annotate genes from GeneName to Entrez Gene Accession
    #

    targets <- R[,2]

    # Annotate targets to entrez ids.
    annMap <- convertNomenclature(ids=targets, org=org, 
                        from='ensembl_gene_id', to='entrezgene')
    if ( !is(annMap, 'matrix') ) 
    { 
        return(NULL) 
    }

    # Annotation answer from ensembl server contains unique matches, 
    # whereas a gene can be the target of multiple miRNAs. 
    # Create a hash to map distinct refseq ids to entrez ids.
    lib1            <- annMap[,2]
    names(lib1)     <- annMap[,1]
    # Map all original refseq targets to entrez
    R[, 2]          <- lib1[targets]
    colnames(R)[2]  <- 'Entrez'
    hitIdx          <- !is.na(R[, 2])
    R               <- R[hitIdx, ,drop=FALSE]
    targets         <- targets[hitIdx]

    # Remove duplicates
    idx       <- duplicated(R[, 2:3]) 
    if (length(idx) > 0) 
    { 
        R       <- R[-idx, , drop=FALSE]
        targets <- targets[-idx]
    }
    
    # Remove interactions between miRNAs and genes with no entrez annotation
    idx         <- which(R[,2] == targets)
    if (length(idx) > 0) { R <- R[-idx, , drop=FALSE] }
    R           <- R[!duplicated(R[,1:2]), ]
    rownames(R) <- 1:nrow(R)

    # Keep only relevant information
    R           <- R[, 1:3, drop=FALSE]

    return(R)
}


#
# Download miRNA validated targets from TarBase
#
.getValMiRecordsTargets <- function(miRecordsFile, org)
{
    data     <- read.xlsx(xlsxFile=miRecordsFile)
    selCols  <- c('Target.gene_species_scientific', 'miRNA_mature_ID', 
                    'Target.gene_Refseq_acc', 'Target.gene_name')
    data        <- data[, selCols]

    orgNames    <- unlist(sapply(unique(data[,1]), function(x) 
    {
        data    <- unlist(strsplit(x, ' ') )
        res  <- NULL
        if (length(data) == 2)
        {
            res <- tolower(paste(substr(data[1],1,1), substr(data[2],1,2), 
                            sep=''))
        }
    }))

    orgName <- names(orgNames)[which(orgNames == org)]
    idx <- which(data[, 1] == orgName)
    if (length(idx) == 0) { return(NULL) }
    df  <- data[idx, -1, drop=FALSE]

    summary <- matrix(-1, nrow=nrow(df), ncol=11)
    R       <- cbind(df, summary)
    db      <- c('diana', 'microinspector', 'miranda', 'mirtarget2', 
                'mitarget', 'nbmirtar', 'pictar', 'pita', 'rna22', 
                'rnahybrid', 'targetscan')
    colnames(R)  <- c('mirna',  'Ensembl', 'GeneName', db)
    rownames(R)  <- 1:nrow(R)
    R            <- as.data.frame(R, stringsAsFactors=FALSE)

    # Convert miRNA names to the ones currently used by miRecords
    mirOld    <- unique(R[,1])
    mirConv   <- convertMiRNANomenclature(org=org, miRNAs=mirOld)

    # Find miRNAs with no conversion
    idx       <- which(is.na(mirConv[,2]))

    if (length(idx) > 0)
    {
        mirDeleted  <- mirConv[idx, 1]
        # Remove these miRNAs from results
        idx   <- which(R[,1] %in% mirDeleted)
        if (length(idx) > 0)    { R <- R[-idx, ,drop=FALSE] }
        if (nrow(R) == 0)     { return(R) }
    }

    #
    # Annotate genes from GeneName to Entrez Gene Accession
    #

    targets   <- R[,2]

    # Annotate targets to entrez ids.
    annMap      <- convertNomenclature(ids=targets, org=org, 
                        from='refseq_mrna', to='entrezgene')
    if ( !is(annMap,'matrix') ) 
    { 
        return(NULL) 
    }

    # Annotation answer from ensembl server contains unique matches, 
    # whereas a gene can be the target of multiple miRNAs. 
    # Create a hash to map distinct refseq ids to entrez ids.
    lib1        <- annMap[,2]
    names(lib1) <- annMap[,1]
    # Map all original refseq targets to entrez
    R[, 2]      <- lib1[targets]
    colnames(R)[2] <- 'Entrez'
    hitIdx  <- !is.na(R[, 2])
    R       <- R[hitIdx, ,drop=FALSE]
    targets <- targets[hitIdx]

    # Remove duplicates
    idx       <- duplicated(R[, 2:3]) 
    if (length(idx) > 0) 
    { 
        R     <- R[-idx, , drop=FALSE]
        targets <- targets[-idx]
    }
    
    # Remove interactions between miRNAs and genes with no entrez annotation
    idx       <- which(R[,2] == targets)
    if (length(idx) > 0) { R <- R[-idx, , drop=FALSE] }

    R             <- R[!duplicated(R[,1:2]), ]
    rownames(R)  <- 1:nrow(R)
    
    # Keep only relevant information
    R             <- R[, 1:3, drop=FALSE]
    
    return(R)
}



#
# Filter downloaded records keeping a subset of targets for a set of 
# selected databases
#
.filterRecords     <- function(targets, databases)
{
    if (missing(databases) || databases=='All')
    {
        targets <- targets[, 1:3, drop=FALSE]
        return(targets)
    }
    
    # Databases indexes belong in 1:11
    if (length(which((!unique(databases) %in% 1:11))))
    {
        message('Please supply databases indexes from 1 to 11.')
        return(NULL)
    }

    # Targets are outputs of at least 'pn' databases. 
    # Databases argument can further limit the results.
    targets <- targets[, c(1:3, 3 + databases)]
    
    # Remove targets with no matches
    data     <- matrix(as.integer(as.matrix(targets[, -(1:3)])), 
                        nrow=nrow(targets)) 
    idx  <- which(rowSums( data ) > 0)
    targets <- targets[idx,  1:3, drop=FALSE]
    targets <- as.data.frame(targets, stringsAsFactors=FALSE)
    

    return(targets)
}



#
# Download backup data from server
#
.getProcessedData   <- function(pn, file, mode, databases, org) 
{
    if (missing(mode)) { mode <- '' }
    error1 <- sprintf('\nUnable to connect to miRecords, 
                        downloading backup data.')
    error2 <- sprintf('\nError while downloading data.\n')
    error3 <- sprintf('\nUnable to download backup miRNA targets file.')

    # Downloading from server due to failure to connect to miRecords
    if (mode=='error') { message(error1) }

    # Try downloading from server
    url <- .getMiRNAtargetsUrl(pn=pn, org=org)

    con <- file(file, open = "wb")
    tryCatch(writeBin(getBinaryURL(url, ssl.verifypeer = FALSE), con),
        error = function(e) { message(error3) })
    close(con)
    e=new.env(); tryCatch(load(file=file, envir=e), error=function(e) {   })
    df <- e$targets

    if (!is.null(df))
    {
        # Filter targets according to selected databases.
        df <- .filterRecords(targets=df, databases=databases)
    }

    return(df)
}

.getMiRNAtargetsUrl <- function(pn, org) 
{
    orgs <- c('cel', 'cfa', 'dme', 'dre', 'gga', 'hsa', 'mmu', 'oar', 'rno')

    miKeys  <- vector(mode='list', length=6)
    if (org =='cel')
    {
        miKeys[[1]]  <- c('lk3ws6k5269ihn1', 'miRNAtargets_cel_1.RData')
        miKeys[[2]]  <- c('8tqmr5mh1xqenvd', 'miRNAtargets_cel_2.RData')
        miKeys[[3]]  <- c('z52jmlrwkenwcjf', 'miRNAtargets_cel_3.RData')
        miKeys[[4]]  <- c('8yxktk8cwunnpgx', 'miRNAtargets_cel_4.RData')
        miKeys[[5]]  <- c('pa1u4j81ghcxui1', 'miRNAtargets_cel_5.RData')
        miKeys[[6]]  <- c('f8vczynapddlcrq', 'miRNAtargets_cel_6.RData')
        miKeys[[7]]  <- c('3ns58ooy2p7zefm', 'miRNAtargets_cel_7.RData')
        miKeys[[8]]  <- c('qj46i938a8g7osk', 'miRNAtargets_cel_8.RData')
        miKeys[[9]]  <- c('59ivtx2l7bxfu2u', 'miRNAtargets_cel_9.RData')
        miKeys[[10]] <- c('c75wqk7dllcaysx', 'miRNAtargets_cel_10.RData')
        miKeys[[11]] <- c('q6bvxfqrz6bzzqp', 'miRNAtargets_cel_11.RData')
    }
    if (org =='cfa')
    {
        miKeys[[1]]  <- c('eevs9uh2dz8t4ll', 'miRNAtargets_cfa_1.RData')
        miKeys[[2]]  <- c('rt5ye1bzqap457t', 'miRNAtargets_cfa_2.RData')
        miKeys[[3]]  <- c('ooqbjpfcsavelhj', 'miRNAtargets_cfa_3.RData')
        miKeys[[4]]  <- c('gvi2fi0880lstb6', 'miRNAtargets_cfa_4.RData')
        miKeys[[5]]  <- c('xkewhltcouk24uo', 'miRNAtargets_cfa_5.RData')
        miKeys[[6]]  <- c('nhyz1438ei1flzl', 'miRNAtargets_cfa_6.RData')
        miKeys[[7]]  <- c('zvnz77xyv9tm8mi', 'miRNAtargets_cfa_7.RData')
        miKeys[[8]]  <- c('yxjxwzu7ln30ie3', 'miRNAtargets_cfa_8.RData')
        miKeys[[9]]  <- c('0qogawcoeon87rd', 'miRNAtargets_cfa_9.RData')
        miKeys[[10]] <- c('m7lyjft51xhlppy', 'miRNAtargets_cfa_10.RData')
        miKeys[[11]] <- c('rnaz7476wyq58tf', 'miRNAtargets_cfa_11.RData')
    }
    if (org =='dme')
    {
        miKeys[[1]]  <- c('bv98y2ou5qxtn7k', 'miRNAtargets_dme_1.RData')
        miKeys[[2]]  <- c('unis5d46y8fo733', 'miRNAtargets_dme_2.RData')
        miKeys[[3]]  <- c('fd2xd4j4ph7wlvm', 'miRNAtargets_dme_3.RData')
        miKeys[[4]]  <- c('gf6jnhysfdiqwlu', 'miRNAtargets_dme_4.RData')
        miKeys[[5]]  <- c('d9tx12902ybfevc', 'miRNAtargets_dme_5.RData')
        miKeys[[6]]  <- c('h5kxhosghasg02d', 'miRNAtargets_dme_6.RData')
        miKeys[[7]]  <- c('qsrypy5xfywsd8t', 'miRNAtargets_dme_7.RData')
        miKeys[[8]]  <- c('yvtjpviu8995yp7', 'miRNAtargets_dme_8.RData')
        miKeys[[9]]  <- c('j59am4o0z7uaza5', 'miRNAtargets_dme_9.RData')
        miKeys[[10]] <- c('f0hrkye8aab0y2h', 'miRNAtargets_dme_10.RData')
        miKeys[[11]] <- c('86qt9wn5nbwnt6q', 'miRNAtargets_dme_11.RData')
    }
    if (org =='dre')
    {
        miKeys[[1]]  <- c('b20bwh7wddo328l', 'miRNAtargets_dre_1.RData')
        miKeys[[2]]  <- c('580gu82122yxm7k', 'miRNAtargets_dre_2.RData')
        miKeys[[3]]  <- c('t87acvrksydoqz7', 'miRNAtargets_dre_3.RData')
        miKeys[[4]]  <- c('gtxigfkrz7alav6', 'miRNAtargets_dre_4.RData')
        miKeys[[5]]  <- c('1cf0abkkhogfhi5', 'miRNAtargets_dre_5.RData')
        miKeys[[6]]  <- c('sch97a78dhtzl5j', 'miRNAtargets_dre_6.RData')
        miKeys[[7]]  <- c('vi98uvq80gi5ank', 'miRNAtargets_dre_7.RData')
        miKeys[[8]]  <- c('ik5w9mekugadnfj', 'miRNAtargets_dre_8.RData')
        miKeys[[9]]  <- c('d3c9dlnq0jy7223', 'miRNAtargets_dre_9.RData')
        miKeys[[10]] <- c('gye1kn4zjak6ewr', 'miRNAtargets_dre_10.RData')
        miKeys[[11]] <- c('rfazqoxw6pv7mqo', 'miRNAtargets_dre_11.RData')
    }
    if (org =='gga')
    {
        miKeys[[1]]  <- c('hcnmq8jdll2p3p3', 'miRNAtargets_gga_1.RData')
        miKeys[[2]]  <- c('avcysl4hvqj5cxp', 'miRNAtargets_gga_2.RData')
        miKeys[[3]]  <- c('qplewyvve72kvhj', 'miRNAtargets_gga_3.RData')
        miKeys[[4]]  <- c('0f2dqnj1ehagfgv', 'miRNAtargets_gga_4.RData')
        miKeys[[5]]  <- c('3sjyofi68uxjnpk', 'miRNAtargets_gga_5.RData')
        miKeys[[6]]  <- c('a01hqd5rs6lxwfj', 'miRNAtargets_gga_6.RData')
        miKeys[[7]]  <- c('dqqusm7sc8wtnfm', 'miRNAtargets_gga_7.RData')
        miKeys[[8]]  <- c('bcthqigqtbzqqi1', 'miRNAtargets_gga_8.RData')
        miKeys[[9]]  <- c('yqtx0w9lpcsvyrh', 'miRNAtargets_gga_9.RData')
        miKeys[[10]] <- c('c2xup5ccsfcidpi', 'miRNAtargets_gga_10.RData')
        miKeys[[11]] <- c('qjqc7yypf8tkf17', 'miRNAtargets_gga_11.RData')
    }
    if (org =='hsa')
    {
        miKeys[[1]]  <- c('zf7efg2f241sf7g', 'miRNAtargets_hsa_1.RData')
        miKeys[[2]]  <- c('2k82cbvm8zlwimb', 'miRNAtargets_hsa_2.RData')
        miKeys[[3]]  <- c('4ftt3afronh6zfz', 'miRNAtargets_hsa_3.RData')
        miKeys[[4]]  <- c('gsy14uirkwqknst', 'miRNAtargets_hsa_4.RData')
        miKeys[[5]]  <- c('nordc6iniokqfur', 'miRNAtargets_hsa_5.RData')
        miKeys[[6]]  <- c('wkda1rd9vf1ta0v', 'miRNAtargets_hsa_6.RData')
        miKeys[[7]]  <- c('9xvan8qky7dvjg7', 'miRNAtargets_hsa_7.RData')
        miKeys[[8]]  <- c('owlnyhz47972chw', 'miRNAtargets_hsa_8.RData')
        miKeys[[9]]  <- c('ec1yuhh9nnvj6mu', 'miRNAtargets_hsa_9.RData')
        miKeys[[10]] <- c('4ksggx0q2g97v2q', 'miRNAtargets_hsa_10.RData')
        miKeys[[11]] <- c('4uxnid3aeyxk85f', 'miRNAtargets_hsa_11.RData')
    }
    if (org =='mmu')
    {
        miKeys[[1]]  <- c('heaaqjfym8fhxli', 'miRNAtargets_mmu_1.RData')
        miKeys[[2]]  <- c('vjyogjecevvky5j', 'miRNAtargets_mmu_2.RData')
        miKeys[[3]]  <- c('p12p30cxdvia7qu', 'miRNAtargets_mmu_3.RData')
        miKeys[[4]]  <- c('3402paa4mda1thk', 'miRNAtargets_mmu_4.RData')
        miKeys[[5]]  <- c('qh0eapmat0vb5jv', 'miRNAtargets_mmu_5.RData')
        miKeys[[6]]  <- c('sxyclzohrrryd2i', 'miRNAtargets_mmu_6.RData')
        miKeys[[7]]  <- c('318ilma6p5v4hk6', 'miRNAtargets_mmu_7.RData')
        miKeys[[8]]  <- c('gg9jt8tcxzrswza', 'miRNAtargets_mmu_8.RData')
        miKeys[[9]]  <- c('i2qx257s3dw677e', 'miRNAtargets_mmu_9.RData')
        miKeys[[10]] <- c('0pr8gg5ksa7k94a', 'miRNAtargets_mmu_10.RData')
        miKeys[[11]] <- c('bf8jm388gvg3ssa', 'miRNAtargets_mmu_11.RData')
    }
    if (org =='oar')
    {
        miKeys[[1]]  <- c('h53xpu6u1o96rav', 'miRNAtargets_oar_1.RData')
        miKeys[[2]]  <- c('thvrfwsx3pggmrz', 'miRNAtargets_oar_2.RData')
        miKeys[[3]]  <- c('wc4eullh495ame7', 'miRNAtargets_oar_3.RData')
        miKeys[[4]]  <- c('ixtu0vwii6ncy6w', 'miRNAtargets_oar_4.RData')
        miKeys[[5]]  <- c('wf6paifn14l5ofz', 'miRNAtargets_oar_5.RData')
        miKeys[[6]]  <- c('ar9z5meiwdyxe08', 'miRNAtargets_oar_6.RData')
        miKeys[[7]]  <- c('a74qewl9pxujb3l', 'miRNAtargets_oar_7.RData')
        miKeys[[8]]  <- c('54viw7lha6oklvb', 'miRNAtargets_oar_8.RData')
        miKeys[[9]]  <- c('x9twcfnov3nuz3m', 'miRNAtargets_oar_9.RData')
        miKeys[[10]] <- c('tcvnienq5hh58bk', 'miRNAtargets_oar_10.RData')
        miKeys[[11]] <- c('qaxs98dvmhj508a', 'miRNAtargets_oar_11.RData')
    }
    if (org =='rno')
    {
        miKeys[[1]]  <- c('w5pk0lucthmijqf', 'miRNAtargets_rno_1.RData')
        miKeys[[2]]  <- c('fsq8c2699yedfcw', 'miRNAtargets_rno_2.RData')
        miKeys[[3]]  <- c('cf2oj6oy6n1u3lf', 'miRNAtargets_rno_3.RData')
        miKeys[[4]]  <- c('86er146w3ejv0ke', 'miRNAtargets_rno_4.RData')
        miKeys[[5]]  <- c('ecwmjmknf090mbb', 'miRNAtargets_rno_5.RData')
        miKeys[[6]]  <- c('ufh9hjk6anatmkj', 'miRNAtargets_rno_6.RData')
        miKeys[[7]]  <- c('2quj6pkjip1asup', 'miRNAtargets_rno_7.RData')
        miKeys[[8]]  <- c('t4h9v5y149xbhro', 'miRNAtargets_rno_8.RData')
        miKeys[[9]]  <- c('bvf0g9qm60y3sad', 'miRNAtargets_rno_9.RData')
        miKeys[[10]] <- c('9qocuom43ihl7um', 'miRNAtargets_rno_10.RData')
        miKeys[[11]] <- c('dmtek3fx529ky23', 'miRNAtargets_rno_11.RData')
    }
    if (!org %in% orgs)
    {
        miKeys[[1]]  <- c('vz774t044y2v4bq', 'miRNAtargets_null.RData')
        miKeys[[2]]  <- c('vz774t044y2v4bq', 'miRNAtargets_null.RData')
        miKeys[[3]]  <- c('vz774t044y2v4bq', 'miRNAtargets_null.RData')
        miKeys[[4]]  <- c('vz774t044y2v4bq', 'miRNAtargets_null.RData')
        miKeys[[5]]  <- c('vz774t044y2v4bq', 'miRNAtargets_null.RData')
        miKeys[[6]]  <- c('vz774t044y2v4bq', 'miRNAtargets_null.RData')
        miKeys[[7]]  <- c('vz774t044y2v4bq', 'miRNAtargets_null.RData')
        miKeys[[8]]  <- c('vz774t044y2v4bq', 'miRNAtargets_null.RData')
        miKeys[[9]]  <- c('vz774t044y2v4bq', 'miRNAtargets_null.RData')
        miKeys[[10]] <- c('vz774t044y2v4bq', 'miRNAtargets_null.RData')
        miKeys[[11]] <- c('vz774t044y2v4bq', 'miRNAtargets_null.RData')
    }

    key <- miKeys[[pn]][1]
    x   <- miKeys[[pn]][2]
    url <- paste0("https://dl.dropboxusercontent.com/s/", key, "/", x)

    return(url)
}

createPathwayGraphs <- function(org, pathways, edgeTypes, doubleEdges, choice,
                                groupMode)
{
    if ( missing(edgeTypes) )
    {
        edgeTypes   <- getEdgeTypes()
    }
    if ( missing(doubleEdges) )
    {
        doubleEdges <- getDoubleEdges()
    }
    if ( missing(choice) )
    {
        choice <- 'reactions'
    }
    if ( missing(groupMode) )
    {
        groupMode <- 'expand'    
    }
    if (missing(org))
    {
        message('Please specify a valid organism id.')
        return(NULL)
    } 

    # Xml directory for organism
    xmlDir    <- paste(cache$dirs$xml, org, sep='//')

    # Choose valid pathways
    if (missing(pathways))  
    { 
        paths <- list.files(xmlDir) 
    }

    if (!missing(pathways)) 
    { 
        paths <- paste(org, pathways, '.xml', sep='') 
    }

    message('Creating adjacency matrices...', appendLF = FALSE)

    # Create compact adjacency matrices for given pathways.
    types  <- getPathwayType(paste(xmlDir, paths, sep='//'))
    N <- length(paths)
    cores  <- ifelse( N > detectCores()*10, 'default', 1 )
    export <- c(
        'nonMetabolicPathwayToGraph', 'expandMetabolicGraph', 
        'removeCompoundsNonMetabolicGraph', 
        'metabolicPathwayToGraph', 'expandNonMetabolicGraph',
        'removeCompoundsMetabolicGraph',
        'xmlTreeParse', 'xmlRoot', 'xmlGetAttr', 'xmlName', 'xmlChildren')

    cAdjMats <- .doSafeParallel(
                    funcName=pathwayToGraph,
                    export=export, 
                    combine='default',
                    N=length(paths),
                    cores=cores,
                    xmlDir, paths, types, FALSE, edgeTypes, 
                    doubleEdges, choice, groupMode)

    names(cAdjMats) <- gsub('.xml', '', paths)

    # Create expanded adjacency matrices with edge type information 
    eAdjMats <- .doSafeParallel(funcName=pathwayToGraph,
                                export=export, 
                                combine='default',
                                N=length(paths),
                                cores=cores,
                                xmlDir, paths, types, TRUE, edgeTypes, 
                                doubleEdges, choice, groupMode)

    names(eAdjMats) <- gsub('.xml', '', paths)

    message('done.')

    return(list(combined=cAdjMats, expanded=eAdjMats, org=org))
}


pathwayToGraph <- function (i, ...)
{

    # ------- Unpacking arguments -------
    args        <- list(...)
    dir         <- args[[1]]
    file        <- args[[2]][i]
    type        <- args[[3]][i]
    expand      <- args[[4]]
    edgeTypes   <- args[[5]]
    doubleEdges <- args[[6]]
    choice      <- args[[7]]
    groupMode   <- args[[8]]
    # ----------------------------------

    adjMat <- NULL
    if ( type == 'Metabolic'  &&  choice == 'reactions' )
    {
        path <- paste(dir, file, sep='//')
        gr   <- metabolicPathwayToGraph(path)
        if (length(gr) > 0)
        {
            if (!expand)
            {
                adjMat <- removeCompoundsMetabolicGraph(gr)
            }
            else
            {
                adjMat <- removeCompoundsMetabolicGraph(gr)
                adjMat <- expandMetabolicGraph(adjMat)
            }
        } 
    }
    if ( ( type == 'Metabolic'  &&  choice == 'relations' )  
        ||  type == 'Non-Metabolic' )
    {
        path <- paste(dir, file, sep='//')
        gr   <- nonMetabolicPathwayToGraph(path, doubleEdges, groupMode)

        if (!expand)
        {
            adjMat <- removeCompoundsNonMetabolicGraph(gr, unique=FALSE,
                                                    edgeTypes=edgeTypes)
        }
        else
        {
            adjMat <- removeCompoundsNonMetabolicGraph(gr, unique=FALSE,
                                                    edgeTypes=edgeTypes)
            adjMat <- expandNonMetabolicGraph(adjMat)
        }
    }

    return(adjMat)
}

#
# Find Graph Type
#
getPathwayType                    <- function(filepath, file)
{
    types <- vector(mode='numeric', length=length(filepath))
    for (i in 1:length(filepath))
    {
        num <- tail(unlist(strsplit(filepath[i], '//')), 1)
        num <- as.numeric(gsub("[^0-9]", "", num))
        if (num <= 2000)    { type = 'Metabolic'    }
        if (num > 2000)     { type = 'Non-Metabolic'}
        types[i] <- type
    }

    return(types)
}
#
# Graph from Metabolic Pathways
#

metabolicPathwayToGraph           <- function(filepath)
{
    xmlDoc <- tryCatch(xmlTreeParse(filepath,error=NULL),
            error=function(e) "error")
    if(!('XMLDocument' %in% class(xmlDoc) )) { return() }

    root          <- xmlRoot(xmlDoc)
    org           <- xmlGetAttr(root,"org")
    nodes         <- as.vector(mapply(xmlName, root))
    entryNodes    <- root[which(nodes == 'entry')]
    reactionNodes <- root[which(nodes == 'reaction')]

    # Create vertices from entry nodes
    idx           <- sapply(1:length(entryNodes), function(x) x)
    eid           <- sapply(entryNodes, xmlGetAttr, "id")        
    enames        <- gsub(paste(org,':',sep=''),'', 
                        sapply(entryNodes, xmlGetAttr, "name")) 
    etype         <- sapply(entryNodes, xmlGetAttr, "type")
    vertices      <- data.frame(ID=eid,id=eid,names=enames, type=etype, 
                    stringsAsFactors=FALSE)

    # Create edges from reaction nodes
    edges <- list(); e <- 1
    for (r in reactionNodes)
    {
        rids        <- sapply(xmlChildren(r), xmlGetAttr, "id")
        subsId      <- which(names(rids) == "substrate")
        prodId      <- which(names(rids) == "product")
        substrate   <- list()
        product     <- list()  
        for (s in 1:length(subsId)) 
        { substrate[[s]] <- list(id=rids[subsId[s]]) }
        for (p in 1:length(prodId)) 
        { product[[p]]   <- list(id=rids[prodId[p]]) }

        enzyme      <- xmlGetAttr(r,"id")
        substrateId <- unname(sapply(substrate, '[[', "id"))
        productId   <- unname(sapply(product,   '[[', "id"))

        #  Non Reversible 
        for (i in 1:length(substrateId))     
        { edges[[e]] <- c(substrateId[i], enzyme); e <- e + 1 }
        for (i in 1:length(productId))       
        { edges[[e]] <- c(enzyme, productId[i]);   e <- e + 1 }
        
        #  Double the edges if reversible  
        if(xmlGetAttr(r,"type") == "reversible")
        {             
            for (i in 1:length(productId))   
            { edges[[e]] <- c(productId[i], enzyme);   e <- e + 1 }
            for (i in 1:length(substrateId)) 
            { edges[[e]] <- c(enzyme, substrateId[i]); e <- e + 1 }
        }
    }  
    if (length(edges) > 0 )
    {
        edges <- unique(data.frame(do.call(rbind, edges), 
                                    stringsAsFactors=FALSE))
        names(edges) <- c('e1','e2')  
    }
    res <- list(name=xmlGetAttr(root,"name"), edges=edges,vertices=vertices)


    return(res)
}

removeCompoundsMetabolicGraph     <- function(path)
{
    nodeType <- 'gene'   
    if(path$name != gsub('ec','',path$name)) { nodeType<-"enzyme" }
    enzymes  <- which(path$vertices$type == nodeType)
    vid      <- path$vertices$id
    entry1 <- c(); entry2 <- c()

    if ( length(path$edges) > 0 )
    {
        # For each enzyme node find the neighbors. 
        # The neighbors that are of type 'compound' are to be removed, and 
        # newconnections have to be established with the appropriate enzymes.
        for(j in 1:length(enzymes) )   
        {       
            L <- c(); R <- c(); 
            ec  <- vid[enzymes[j]]
            # For each neighbor of the enzyme
            for (r1 in path$edges[path$edges$e1 == 
                                path$vertices[,'id'][enzymes[j]],]$e2)  
            {
                # if neighbor is a compound, find its neighbors
                for (r2 in path$edges[path$edges$e1 == 
                                path$vertices[,'id'][which(vid == r1)],]$e2)
                {
                    # for enzyme neighbors of the compound others than 
                    # the initial enzyme
                    nid <- vid[which(path$vertices$id == r2)]
                    if (!(nid %in% R) && nid != ec) 
                    { 
                        L <- c(L,ec)
                        R <- c(R,nid) 
                    }
                }
            }
            entry1 <- c(entry1,L)
            entry2 <- c(entry2,R)
        }
    } 


    # Construct the adjacency matrix
    xid    <- path$vertices$id[enzymes]
    names  <- path$vertices$names[enzymes]       
    adjMat <- matrix(rep(0,length(enzymes)^2), nrow=length(enzymes))
    colnames(adjMat) <- names
    rownames(adjMat) <- names
    for(j in 1:length(entry1) )  
    {
        adjMat[which(xid == entry1[j]), which(xid == entry2[j])] <- 1
    }
    
    return(adjMat) 
}

expandMetabolicGraph              <- function(adjMat)
{
    names  <- c()
    Vcount <- nrow(adjMat)
    Ecount <- sum(adjMat)
    if (Vcount == 0) { return(NULL); }

    n1 <- c(); n2 <- c()
    for ( j in 1:nrow(adjMat) )
    {
        for ( z in 1:ncol(adjMat) )
        {
            if (adjMat[j,z] == 1)
            {
                n1  <- c(n1, colnames(adjMat)[j] )
                n2  <- c(n2, colnames(adjMat)[z] )
            }     
        }
    }

    # Expand gene names
    for(j in 1:Vcount)
    {
        for(vk in unlist(strsplit(colnames(adjMat)[j]," ")) )
        {   
            names <- c(names, vk)
        }
    }
    names <- unique(names)

    L <- c(); R <- c()
    if (Ecount > 0)
    {
        for(j in 1:Ecount)
        {
            for(lm in unlist(strsplit(n1[j]," ")))
            {
                for(rn in unlist(strsplit(n2[j]," ")))
                {
                    L <- c(L, lm)
                    R <- c(R, rn)
                }
            }
        }
    }

    # Construct the adjacency matrix
    N      <- length(names)
    adjMat <- matrix(rep(0,N^2), nrow=N)
    for(j in 1:length(L) )  
    {
        t <- 3  # Unknown  
        adjMat[which(names == L[j]), which(names == R[j])] <- t
    }
    colnames(adjMat) <- names 
    rownames(adjMat) <- names

    # Remove self cycles
    for(j in 1:nrow(adjMat) )  { adjMat[j,j] <- 0 }

    return(adjMat)
}

#
# Graph from Mon Metabolic Pathways
#

nonMetabolicPathwayToGraph <- function(filepath, doubleEdges, groupMode)
{

    xmlDoc         <- tryCatch(xmlTreeParse(filepath,error=NULL),
                                error=function(e) "error")
    if(!('XMLDocument' %in% class(xmlDoc) )) { return(NULL) }

    # Create node families
    root           <- xmlRoot(xmlDoc)
    org            <- xmlGetAttr(root,"org")
    nodes          <- as.vector(mapply(xmlName, root))
    entryNodes     <- root[which(nodes == 'entry')]
    type           <- sapply(entryNodes, xmlGetAttr, "type")
    groupNodes     <- entryNodes[which(type == 'group')]
    orthoNodes     <- entryNodes[which(type != 'group')]
    relationNodes  <- root[which(nodes == 'relation')]
    
    # Create vertices from entry nodes
    vertices       <- list()
    vertices$id    <- as.integer(unname(sapply(orthoNodes, xmlGetAttr, "id")))
    vertices$names <- gsub(paste(org,':',sep=''), '', 
                        unname(sapply(orthoNodes, xmlGetAttr, "name")))
    vertices$type  <- unname(sapply(orthoNodes, xmlGetAttr, "type"))
    group          <- list()

    if (groupMode == 'expand')
    {
        # Create groups
        for(gn in groupNodes) 
        { 
            group <- c( group, 
                            list(sapply(xmlChildren(gn), xmlGetAttr, "id")) )
        }
        names(group) <- sapply(groupNodes, xmlGetAttr, "id")
    }

    if (groupMode == 'collapse')
    {   
        # Replace group nodes with all genes of their components
        for(gn in groupNodes) 
        { 
            entries <- unlist(lapply(xmlChildren(gn), xmlGetAttr, "id"))
            genes   <- vertices$names[which(vertices$id %in% entries)]
            genes   <- unique(unlist(lapply(as.list(genes), 
                        function(x) { strsplit(x, ' ') } )))
            genes   <- paste(genes, collapse=' ')

            vertices$id     <- c(vertices$id,    xmlGetAttr(gn, "id"))
            vertices$names  <- c(vertices$names, genes)
            vertices$type   <- c(vertices$type,  "gene")
        }
    }

    # Create relations
    rentry1  <- sapply(relationNodes, xmlGetAttr, "entry1")
    rentry2  <- sapply(relationNodes, xmlGetAttr, "entry2")
    rtype    <- sapply(relationNodes, xmlGetAttr, "type")
    rents    <- lapply(relationNodes, function(x) { xmlChildren(x) })
    rsubtype <- list()

    for(ent in rents)
    {
        subtype <- mapply(list, name='unknow', value='unknow', SIMPLIFY=FALSE)
        if(length(ent) > 0)
        {
            X       <- unname(sapply(ent, xmlGetAttr, "name"))
            Y       <- unname(sapply(ent, xmlGetAttr, "value"))
            subtype <- mapply(list, name=X, value=Y, SIMPLIFY=FALSE)
        }       
        rsubtype <- append(rsubtype, list(subtype))
    }

    bla <- function(e1, e2, name='unknow', type='noType', duplicate = FALSE)
    {
        L1 <- list(e1=e1, e2=e2, name=name, type=type)
        L2 <- list(e1=e2, e2=e1, name=name, type=type)

        if (!duplicate) { return( list( L1 ))  }
        if (duplicate)  { return( list( L1, L2 )) }
    }

    # Create edges
    E <- list(); i <- 0      
    for(subtypes in rsubtype)
    {
        i       <- i + 1
        inGroup <- FALSE
        # type    <- paste(names(subtypes), collapse='_')        
        if(length(group) != 0) 
        {
            # If a node is of type group, then create all actual edges between
            # its components and the other node. 
            GroupL <- groupL <- unlist(group[names(group) %in%  rentry1[i]])
            GroupR <- groupR <- unlist(group[names(group) %in%  rentry2[i]]) 
            if(length(groupL) == 0 && length(groupR)  > 0) 
            { GroupL <- rentry1[i] }
            if(length(groupL) >0   && length(groupR) == 0) 
            { GroupR <- rentry2[i] }

            # Create an single edge by default; if the edge is of type 
            # compound, create the actual edges connecting the compounds.
            # For an ambiguous edge type, create an edge in the other 
            # direction. 
            for(rn in subtypes)
            {
                dupl <- rn$name %in% doubleEdges
                
                for(gl in GroupL)
                {
                    for(gr in GroupR)
                    {                    
                        if (rn$name == "compound")                     
                        {    
                            E <- c(E, bla(gl,       rn$value, rn$name, 
                                    dup = dupl, type=rn$name))
                            E <- c(E, bla(rn$value, gr,       rn$name, 
                                    dup = dupl, type=rn$name))
                        }
                        if (rn$name != "compound")
                        {
                            E <- c(E, bla(gl, gr, rn$name, 
                                    dup = dupl, type=rn$name))
                        }
                    }
                }

                if (length(groupL) >0 || length(groupR) > 0) 
                { 
                    inGroup = TRUE 
                }
            }
        }
        if (inGroup) { next() }
        

        # No group nodes
        for(rn in subtypes)
        {
            dupl <- rn$name %in% doubleEdges            
            if (rn$name == "compound")
            {
                E <- c(E, bla(rentry1[i],rn$value,   dup=dupl, type=rn$name))
                E <- c(E, bla(rn$value,  rentry2[i], dup=dupl, type=rn$name))
            }                        
            if (rn$name != "compound")
            {
                E <- c(E, bla(rentry1[i], rentry2[i], rn$name, 
                        dup = dupl, type=rn$name))  
            }
        }
    }
    
    e1    <- sapply(E, function(x){ x$e1 })
    e2    <- sapply(E, function(x){ x$e2   })
    ename <- sapply(E, function(x){ x$name })
    etype <- sapply(E, function(x){ x$type })
    edges <- unique(data.frame(e1=e1, e2=e2, ename=ename, etype=etype))
    if (nrow(edges) > 0)
    {
        edges <- list(e1=edges[,1], e2=edges[,2], type=edges[,3])
    }    
    res <- list(vertices=vertices, edges=edges, name=xmlGetAttr(root,"name"))

    return(res)
}

removeCompoundsNonMetabolicGraph <- function(path, unique, edgeTypes)
{
    if (is.null(path)) return(NULL)
    vid      <- as.numeric(path$vertices$id)
    etype    <- path$vertices$type
    nodeType <- 'gene'   
    if(path$name != gsub('ko','',path$name)) { nodeType <- "ortholog" }

    source    <- c(); destin <- c(); types <- c()          
    genesIndx <- which(path$vertices$type == nodeType)
    for(gi in genesIndx)
    {               
        # For each gene, find its neighboring vertices. 
        # KEGG entries are not always numbered successively. 
        L <- c(); R <- c(); TT <- c()
        neighbors <- path$edges$e2[path$edges$e1 == vid[gi]]

        for(neighbor in neighbors)
        { 
            nbrId <- which( vid == neighbor )

            # The neighbor is a gene which has yet to be added to 
            # the edgelist.
            if( etype[nbrId] == nodeType &&  !(vid[nbrId] %in% R) )
            {
                # Connect the first gene with the neighbor        
                L    <- c( L, vid[gi]    )
                R    <- c( R, vid[nbrId] )

                # Edges with more than one types have been stored seperately.
                # Join all their types in a single entry the first time the 
                # edge has been found and make sure it is not added multiple 
                # times (2nd if clause).
                idx1 <- which( path$edges$e1 == vid[gi] )
                idx2 <- which( path$edges$e2 == vid[nbrId] )
                idx  <- intersect(idx1, idx2)
                TT   <- c( TT, paste((path$edges$type[idx]), collapse='_') )
            }

            # The neighbor is a compound. 
            if( etype[nbrId] == "compound" )
            {                
                # The compound has to be removed, while the source gene is 
                # connected with the compound's neighboring gene.
                cpdNeighbors <- path$edges$e2[ 
                                        which(path$edges$e1 == vid[nbrId]) ]

                for( cpdNeighbor in cpdNeighbors )
                {
                    idx  <- which( vid == cpdNeighbor )
                    # The compound's neighbor is a gene which has yet to be 
                    # added to the edgelist.
                    if( etype[idx] == nodeType && !(vid[idx] %in% R) )
                    {
                        # Connect source gene with the neighbor 
                        L <- c( L, vid[gi]   )
                        R <- c( R, vid[idx]  )
                        # The edgetype is 'compound'
                        TT <- c( TT, "compound")
                    }
                }
            }
        }     
        source <- c( source, L )
        destin <- c( destin, R )
        types  <- c( types, TT  )
    }


    # Construct the adjacency matrix
    if (unique)
    {
        # Recalculate indexes according to unique gene names
        names            <- unique(path$vertices$names[genesIndx])
        adjMat           <- matrix(rep(0,length(names)^2), nrow=length(names))
        colnames(adjMat) <- names
        rownames(adjMat) <- names

        if (is.null(source) || is.null(destin))
        {
            return(adjMat)
        }

        for (i in 1:length(source))
        {   
            idx1 <- which(path$vertices$id == source[i])
            idx2 <- which(path$vertices$id == destin[i])
            source[i] <- names[ names == path$vertices$names[idx1] ]
            destin[i] <- names[ names == path$vertices$names[idx2] ]
        }

        for(j in 1:length(source) )  
        {
            idx <- which(edgeTypes[,1] == types[j])
            if (length(idx) == 0)
            {
                # Set new interaction types to apathetic
                t <- 3
            }
            if (length(idx) > 0)
            {
                t <- edgeTypes[idx, 2]
            }
            
            adjMat[which(names == source[j]), which(names == destin[j])] <- t
        }
    }
    else
    {
        # Construct the adjacency matrix
        gids                <- path$vertices$id[genesIndx]
        names               <- unname(path$vertices$names[genesIndx])
        adjMat              <- matrix(rep(0,length(genesIndx)^2), 
                                        nrow=length(genesIndx))
        colnames(adjMat)    <- names 
        rownames(adjMat)    <- names

        if (is.null(source) || is.null(destin))
        {
            return(adjMat)
        }

        for(j in 1:length(source) )  
        {
            
            idx <- which(edgeTypes[,1] == types[j])
            if (length(idx) == 0)
            {
                t <- 3; # New interaction type
            }
            if (length(idx) > 0)
            {
                t <- edgeTypes[idx, 2]
            }

            adjMat[which(gids == source[j]), which(gids == destin[j])] <- t
        }
    }

    # Remove self loops
    for (j in 1:nrow(adjMat)) { adjMat[j,j] <- 0 }


    return(adjMat) 
}

expandNonMetabolicGraph          <- function(adjMat)
{
    if (!is.matrix(adjMat)) return(NULL)

    names  <- c()
    Vcount <- nrow(adjMat)
    Ecount <- sum(adjMat)
    if (Vcount == 0) { return(NULL); }

    n1 <- c(); n2 <- c(); t <- c()
    for ( j in 1:nrow(adjMat) )
    {
        for ( z in 1:ncol(adjMat) )
        {
            if (adjMat[j,z] > 0)
            {
                n1   <- c(n1, colnames(adjMat)[j] )
                n2   <- c(n2, colnames(adjMat)[z] )
                t    <- c(t, adjMat[j,z])
            }     
        }
    }

    # Expand gene names
    names <- unique(unlist(lapply(colnames(adjMat), 
                function(x) {strsplit(x,' ')} )))

    L <- c(); R <- c(); TT <- c()
    if (Ecount > 0)
    {
        for(j in 1:Ecount)
        {
            l1 <- unlist(strsplit(n1[j],' '))
            l2 <- unlist(strsplit(n2[j],' '))
            for(lm in l1) 
            { 
                for(rn in l2) 
                { 
                    L   <- c(L, lm)
                    R   <- c(R, rn) 
                    TT  <- c(TT, t[j])
                } 
            }
        }
    }
    L   <- if(!is.null(L)) { L <- na.omit((L)) } 
    R   <- if(!is.null(L)) { R <- na.omit((R)) } 
    TT  <- if(!is.null(TT)) { TT <- na.omit((TT)) } 


    # Construct the adjacency matrix
    N      <- length(names)
    adjMat <- matrix(rep(0,N^2), nrow=N)
    for(j in 1:length(L) )  
    {
        adjMat[which(names == L[j]), which(names == R[j])] <- TT[j]
    }
    colnames(adjMat) <- names
    rownames(adjMat) <- names

    # Remove self cycles
    for(j in 1:nrow(adjMat) )  { adjMat[j,j] <- 0 }

    return(adjMat)
}



getEdgeTypes   <- function(type)             
{
    # noEdge     0
    # activation 1
    # inhibition 2
    # apathetic  3

    data = c(
        'unknow', 3,
        'activation', 1,
        'inhibition', 2,
        'binding/association', 3,
        'expression', 1,
        'repression', 2,
        'phosphorylation', 3, #1
        'dephosphorylation', 3,
        'ubiquitination', 3,
        'dissociation', 3,
        'indirect effect', 3, #1
        'state change', 3,
        'compound', 3,  #1
        'hidden compound', 3,
        'missing interaction', 3,
        'activation_phosphorylation', 1,
        'activation_dephosphorylation', 1,
        'activation_ubiquitination', 1,
        'activation_indirect effect', 1,
        'activation_binding/association', 1,
        'activation_inhibition', 3,
        'activation_methylation', 1,
        'activation_phosphorylation_binding/association', 1,
        'activation_phosphorylation_indirect effect', 1,
        'inhibition_phosphorylation', 2,
        'inhibition_dephosphorylation', 2,
        'inhibition_ubiquitination', 2,
        'inhibition_indirect effect', 2,
        'inhibition_binding/association', 2,
        'inhibition_expression', 2,
        'inhibition_methylation', 2,
        'compound_expression', 1,
        'compound_activation', 1,
        'compound_inhibition', 2,
        'compound_activation_indirect effect', 1,
        'compound_activation_phosphorylation', 1,
        'phosphorylation_indirect effect', 3,
        'phosphorylation_binding/association', 3,
        'phosphorylation_dissociation', 3,
        'dephosphorylation_indirect effect', 3,
        'binding/association_missing interaction', 3,
        'binding/association_indirect effect', 3,
        'expression_indirect effect', 1,
        'repression_indirect effect', 2,
        'ubiquitination_inhibition', 2,
        'dissociation_missing interaction', 3,
        'indirect effect_phosphorylation', 3,
        'inhibition_dephosphorylation_indirect effect', 3,  #new
        'inhibition_glycosylation',3,                       #new
        'glycosylation',3                                   #new
        )


    E        <- as.numeric(data[seq(2,length(data),2)])
    names(E) <- data[seq(1,length(data),2)]


    if (!missing(type))
    {
        return(E[type])
    }
    if (missing(type))
    {
        df <- data.frame(names(E),E)
        rownames(df) <- 1:nrow(df)
        colnames(df) <- c('Edge', 'Type')
        
        return(df)
    }

    return( E[type] )
}


getDoubleEdges <- function()
{
    doubleEdges <- c('compound', 
                    'binding/association', 
                    'dissociation', 
                    'dissociation_missing interaction', 
                    'state change', 
                    'binding/association_missing interaction', 
                    'missing interaction', 'hidden compound')

    return(doubleEdges)
}

#
# Data consolidation
#


fillMatrixList <- function(L, maxLen)
{
    if (is.null(L))     { return(L) }

    # If input is not a list, return original data
    if (!is.list(L))    { return(L) }

    lens <- c()
    for (i in 1:length(L))
    {    
        if (!is.null(L[[i]]))
        {
            lens <- c(lens, getLengths(L[[i]]))
        }
    }

    if (is.null(lens)) { return(NULL) }


    # Set number of columns.
    if (missing(maxLen)) { maxLen <- max(lens, na.rm=TRUE) }


    # If no filling is necessary, return original data
    if (length(unique(lens)) == 1) { return(L) }

    # Enforce maximum length on each subpath of each pathway
    res <- L
    for (i in 1:length(L))
    {
        submat <- L[[i]]
        if (is.null(submat)) { next() }
        replmat <- matrix(0, nrow=nrow(submat), ncol=maxLen)
        for (j in 1:nrow(submat))
        {   
            replmat[j,] <- c(submat[j,], rep(0, maxLen - length(submat[j,])))
        }
        res[[i]] <- replmat
    }

    return(res)
}

unlistToMatrix <- function(L, mode='rbind')
{
    if (is.null(L))     { return(L) }

    # If input is already a matrix, return original data.
    if ( is(L,'matrix') ) { return(L) }

    # Find what type of data the list holds
    type <- NULL
    for (i in 1:length(L))
    {
        if(!is.null(L[[i]]))
        {
            if (is.vector(L[[i]])) type <- 'vector'
            if (is.matrix(L[[i]])) type <- 'matrix'
            break()
        }
    }

    if (is.null(type)) { return(NULL) }

    # List of vectors of variable size
    if (type == 'vector')
    {
        lens <- sapply(L, function(x) { length(x) })
        M    <- matrix(0, nrow=length(L), ncol=max(lens))
        for (i in 1:length(L)) 
        {
            M[i,1:lens[i]] <- L[[i]] 
        }
        rownames(M) <- names(L)
    }

    # A list of matrices with at least one common dimension size
    # rbind:same number of columns, cbind:same number of rows
    if (type == 'matrix')
    {
        M      <- do.call(mode, L)
        lnames <- names(L) 

        if (length(lnames) > 0)
        {
            lens   <- sapply(L, function(x) 
                                { 
                                    if (!is.null(x)) nrow(x) else 0 
                                } )
            rnames <- vector(mode='numeric', length=nrow(M))
            ctr   <- 0
            for (i in 1:length(lnames))
            {
                if (lens[i] > 0)
                {
                    idx         <- (ctr+1) : (ctr<-ctr+lens[i])
                    rnames[idx] <- rep(lnames[i], lens[i])               
                }
            }
            rownames(M) <- rnames
        }
    }
    return(M)
}

getLengths     <- function(M)
{
    # 
    # Count length of non zero elements in each row of a matrix.
    # Each row must consist of a prefix with non zero elements, 
    # and a suffix of consecutive zeros denote absence of data.
    # Ideal for matrices with a large number of rows.
    #
    esub <- cbind(M, rep(0, nrow(M)))
    esub <- rbind(esub, c(-1, rep(0, ncol(M))))
    df   <- which(diff(which(c(t(esub)) != 0)) - 1 > 0)
    len  <- c(df[1], diff(df))

    return(len)
}

splitWork      <- function(N, k)
{
    if (missing(k))
    {
        k <- detectCores(logical=FALSE)
    }
    if (N < k) 
    { 
        k <- N 
    }
    
    if (N > 1) 
    {
        jobs <- split(1:N, cut(1:N, quantile(1:N,(0:k)/k), 
                    include.lowest=TRUE, labels=FALSE))
    }
    if (N == 1)
    {
        jobs <- list(c(1)); names(jobs) <- '1'
    }

    return(list(jobs=jobs, k=k))
}


matrixToList   <- function(subpaths, block, k)
{
    if ( is(subpaths,'list') )
    {
        subpaths <- unlistToMatrix(subpaths)
    }
    if (missing(block)) { block <- 1000 }
    if (missing(k))     { k <- detectCores(logical=FALSE) }

    K   <- floor(nrow(subpaths)/block)
    xx  <- splitWork(nrow(subpaths), K)
    S   <- vector(mode='list', length=K)
    for (i in 1:K)
    { 
        S[[i]] <- subpaths[xx$jobs[[i]],]
    }

    kk  <- splitWork(length(S), k=k)
    res <- list(subpaths=S, jobs=kk$jobs, k=kk$k)

    return(res)
}


matrixToFile   <- function(adjMats, org, dirs )
{
    # Remove possible edge type information
    for (i in 1:length(adjMats))
    {
        adjMats[[i]][adjMats[[i]] > 1] <- 1
    }

    adjMatFiles <- paste( dirs$tmp$mat,'//', org, '//', names(adjMats) ,
                        '.txt', sep = '' )
    IdsFiles    <- paste( dirs$tmp$ids,'//', org, '//', names(adjMats) ,
                        'ids.txt', sep = '' )

    mapply( write.table, adjMats, file = adjMatFiles, sep = ",", 
            row=FALSE, col=FALSE )
    matIds <- lapply(adjMats, function(x) { colnames(x) } )
    mapply( write.table, matIds, file = IdsFiles, sep = ",", 
        row=FALSE, col=FALSE )

    return(NULL)
}



optimalLengths <- function(subpaths, mode)
{
    if (is.list(subpaths)) { subpaths <- unlistToMatrix(subpaths) }

    res  <- vector(mode='numeric', length=ncol(subpaths)) 
    lens <- getLengths(subpaths)
    for (len in 3:ncol(subpaths))
    {
        idx      <- which(lens <= len)
        res[len] <- length(unique(as.vector(subpaths[idx,])))
    }

    return(data.frame('optimalLengths'=res))
}


idxToMat       <- function(L, idx)
{
    rows <- ((idx-1) %% nrow(L)) + 1
    cols <- floor((idx-1)/nrow(L)) + 1

    return(list(rows=rows, cols=cols))
}


normalize      <- function(x)
{
    res <- (x-min(x)) / (max(x)-min(x))
    return(res)
}





#
# Data Export
#

exportSubpaths   <- function(subpaths, dir, type, verbose, mode)
{
    if (is.null(subpaths))  { return() }
    if (missing(verbose))   { verbose <- TRUE }
    if (missing(mode))      { mode <- 'clean'}
    if (missing(type))      { type <- c('.txt','.RData')}

    if (verbose)
    { 
        message('Exporting subpaths...', appendLF = FALSE) 
    }
    
    # Determine max serial number of output files already present in directory
    n1 <- 0; n2 <- 0
    f1 <- gsub('.RData', '', list.files(dir, pattern='.RData'))
    f2 <- gsub('.txt', '', list.files(dir, pattern='.txt'))
    if (length(f1) > 0)
    {
        n1 <- as.integer(unique(unlist(strsplit(f1, 'subpaths'))))
        n1 <- max(n1, na.rm=TRUE) 
    }
    if (length(f2) > 0)
    {
        n2 <- as.integer(unique(unlist(strsplit(f2, 'subpaths'))))
        n2 <- max(n2, na.rm=TRUE)
    }
    n  <- max(n1,n2)
        
    if ('.RData' %in% type)
    {   
        file <- paste0(dir, '//subpaths', sprintf("%03d", n+1),'.RData')
        file.create(file)
        save(subpaths, file=file)
    }
    if ('.txt' %in% type)
    {
        # Create output file
        file <- paste0(dir,'//subpaths', sprintf("%03d", n+1),'.txt')
        file.create(file)
        i      <- 1
        paths  <- names(subpaths)
        if (is.list(subpaths))
        {
            for (sub in subpaths)
            {
                # Append subpaths to output file
                if (is.null(sub))
                { 
                    i <- i + 1; next()
                }
                sub <- cbind(rep(paths[i], nrow(sub)), sub)
                write.table(sub, file=file, sep='\t', append=TRUE, 
                                row.names=FALSE, col.names=FALSE, quote=FALSE)
                i <- i + 1
            }
        }
        if (is.matrix(subpaths))
        {
            # Append subpaths to output file
            if (mode != 'justify')
            {
                write.table(subpaths, file=file, sep='\t', append=TRUE, 
                            row.names=TRUE, col.names=FALSE, quote=FALSE)   
            }
            if (mode == 'justify')
            {
                exportToFile(R=subpaths, expfile=file)  
            }
        }
    }

    if (verbose) { message('done.') }

    return(invisible())
}


createScoreFile  <- function(dir, type, fileType)
{
    if (missing(fileType)) { fileType <- '.txt'}

    # Determine max serial number of output files already present in directory
    n1 <- 0; n2 <- 0
    f1 <- gsub(paste('a', fileType, sep=''), '', 
                        list.files(dir, pattern=paste('a', fileType, sep='')))
    f2 <- gsub(paste('b', fileType, sep=''), '', 
                        list.files(dir, pattern=paste('b', fileType, sep='')))

    if (length(f1) > 0) 
    {
        N1 <- as.integer(unique(unlist(strsplit(f1, 'scores'))))
        n1 <- max(n1, na.rm=TRUE)
    }
    if (length(f2) > 0)
    {
        n2 <- as.integer(unique(unlist(strsplit(f2, 'scores'))))
        n2 <- max(n2, na.rm=TRUE) 
    }
    if (type == 'a')    { n <- n1 }
    if (type == 'b')    { n <- n2 }

    file <- paste0(dir,'//scores', sprintf("%03d", n+1), 
                    paste0(type, fileType))
    file.create(file)

    return(file)
}


exportToFile    <- function(R, expfile, append=FALSE)
{
    if (!file.exists(expfile)) {  file.create(expfile) }
    max.print <- getOption('max.print')
    width     <- getOption('width')
    options(width = 10000)
    if ( is(R,'matrix') )
    {
        options(max.print=nrow(R) * ncol(R))
        sink(file=expfile, append=append)
        # print.data.frame(noquote(as.data.frame(R)), row.names=T, q=F)
        print(noquote(R), row.names=TRUE, col.names=FALSE, q=FALSE)
        sink(NULL)
    }
    if ( is(R,'list') )
    {
        options(max.print=length(unlist(R)))
        sink(file=expfile); 
        print(R); sink();
    }
    if ( is(R,'numeric') )
    {
        x <- paste(names(R), '\t', R, collapse='\n')
        cat(x, file=expfile , sep = '\n')
    }
    if ( is(R,'integer') )
    {
        x <- paste(R, '\t', names(R), collapse='\n')
        cat(x, file=expfile , sep = '\n')
    }
    if ( is(R,'data.frame') )
    {
        options(max.print=nrow(R) * ncol(R))
        sink(file=expfile, append=append)
        print(noquote(R), row.names=FALSE, right=FALSE)
        sink()
        options(max.print=max.print)
    }
    if ( is(R,'character') )
    {
        options(max.print=length(R))
        sink(file=expfile)
        print(noquote(R), row.names=FALSE)
        sink()
        options(max.print=max.print)
    }
    options(width = width)
}



checkFile       <- function(dir, file, filepath='')
{
    if (filepath=='')
    {
        filepath <- paste(dir, file, sep='//')
    }
    if (!file.exists(filepath))
    {
        message('Wrong or missing filepath', filepath);
        return(FALSE)
    }
    else
    {
        return(TRUE)
    }
}



# 
# Basic fault tolerant parallel computation 
# 

.doSafeParallel <- function(funcName, export, combine, N, cores, ...)
{
    if ( missing(export) )    { export <- NULL }
    if ( cores == 'default' ) { cores <- detectCores(logical=FALSE) }


    if ( cores == 1 )
    {
        # Run sequentially for trivial inputs
        registerDoSEQ()
        exports <- NULL
    }else
    {
        # Create and register parallel backend
        cl <- makeCluster(cores)
        on.exit(stopCluster(cl), add=TRUE)
        registerDoParallel(cl)
        exports <- c(as.character(substitute(funcName)), export)
        env     <- parent.env(parent.frame())

        if ( !is.null(export) )
        {
            clusterExport(cl=cl, varlist=exports, envir=env)
        }
    }


    i <- 0
    while (TRUE)
    {
        tryCatch(
        {
            if ( combine == 'default')
            {
                res <- foreach( i=1:N, .export=exports) %do%
                {
                    funcName(i, ...)
                }
            }else
            {
                res <- foreach( i=1:N, .export=exports, 
                                .combine=combine) %do%
                {
                    funcName(i, ...)
                }
            }
            break;
        }, error = function(e) 
        {
            closeAllConnections()
            message('\n\t Master cannot establish communication with workers')
        })

        message('\t+ Reinitializing clusters...', appendLF = FALSE)
        on.exit(NULL)
        cl <- makeCluster(detectCores(logical=FALSE))
        on.exit(stopCluster(cl), add=TRUE)
        registerDoParallel(cl)
        if ( !is.null(export) )
        {
            clusterExport(cl=cl, varlist=exports, envir=env)
        }
        message('done.')
    }

    return(res)
}

#
# Obtain full path to an executable file
#
.Sys.which2 <- function(cmd) 
{
    stopifnot(length(cmd) == 1)
    if (.Platform$OS.type == "windows") 
    {
        suppressWarnings({
            pathname <- system(sprintf("where %s", cmd), intern=TRUE)[1]
        })
        if (!is.na(pathname)) return(setNames(pathname, cmd))
    }
    Sys.which(cmd)
}

## ----eval=TRUE, echo=TRUE-----------------------------------------------------
if (.Platform$OS.type == 'unix') 
    { options('CHRONOS_CACHE'=file.path(path.expand("~"), '.CHRONOS') ) }
if (.Platform$OS.type == 'windows') 
    { options('CHRONOS_CACHE'=file.path(gsub("\\\\", "/",
                            Sys.getenv("USERPROFILE")), "AppData/.CHRONOS")) }

## ----eval=TRUE, echo=TRUE-----------------------------------------------------
library('CHRONOS')
load(system.file('extdata', 'Examples//data.RData', package='CHRONOS'))
head(mRNAexpr)

## ----eval=TRUE, echo=TRUE, message=FALSE--------------------------------------
out <- CHRONOSrun(  mRNAexp=mRNAexpr,
                    mRNAlabel='entrezgene',
                    miRNAexp=miRNAexpr,
                    pathType=c('04915', '04917', '04930', '05031'),
                    org='hsa',
                    subType='All',
                    thresholds=c('subScore'=0.4, 'mirScore'=0.4),
                    miRNAinteractions=miRNAinteractions,
                    export='.txt')

convertMiRNANomenclature    <- function(org, miRNAs, update)
{
    if (missing(update)) { update <- FALSE }

    # Load or download 
    #  - Mapper from old miRNA annotations to new ones 
    #  - Availiable miRNA annotaions from miRecords

    annFile <- paste0(cache$dirs$anDir, '//miRNAmaps_', org, '.RData')
    if ( update || (!update && !file.exists(annFile)) )  
    {
        # Create mapper
        miRNA.conversions <- mirParser(org)
        # Download miRecords miRNA list
        miRNA.miRecords <- .getMiRecordsMiRNAs(org)
        # Save locally
        save(miRNA.conversions, miRNA.miRecords, file=annFile)        
    }
    if ( !update && file.exists(annFile) ) 
    {
        # If a new map has been downloaded, use it.
        e=new.env(); load(file=annFile, envir=e)
        miRNA.conversions <- e$miRNA.conversions
        miRNA.miRecords <- e$miRNA.miRecords
    }

    # Convert according to user miRNAs
    res <- mirRenamer(  org=org, map=miRNA.conversions, userMirs=miRNAs, 
                        miRecordsMirs=miRNA.miRecords)

    return ( res )
}


mirParser <- function( org )
{
    # Download data from mirbase
    mirbaseURL <- 'ftp://mirbase.org/pub/mirbase/CURRENT/database_files/'
    mirbaseURL <- paste0(mirbaseURL, 'mirna_mature.txt.gz')
    file <- tempfile()
    tryCatch( download.file(mirbaseURL, file, quiet=TRUE) , 
            error=function(e) ' ')
    data <- readLines(file)
    tryCatch( unlink(file), error=function(e) ' ')

    # Process data
    data <- strsplit(data, '\t')
    map <- do.call('rbind', lapply(data, function(x) { x[2:3]} ))
    colnames(map) <- c('Mature', 'Previous')
    # Find organism specific entries
    idx <- which( map[, 1] != gsub(org, '', map[, 1]) )
    if (length(idx) > 0 )
    {
        map <- map[idx, , drop=FALSE]
    }
    # Replace '' with NAs
    map[map[, 2] == '', 2] <- NA

    # Expand multiple old annotations delimited with ';'
    R   <- strsplit(map[,2], ';')
    len <- length(unlist(R))
    res <- matrix(, nrow=len, ncol=ncol(map))
    ctr <- 1
    for (i in 1:nrow(map))
    {
        lR <- length(R[[i]])
        res[ctr:(ctr+lR-1), ] <- as.matrix(expand.grid(map[i,1], R[[i]]))
        ctr <- ctr + lR
    }
    res <- res[-seq(ctr,nrow(res)),]
    colnames(res) <- c('Mature', 'Previous')

    # Remove entries where both old and new annotation are the same
    idx <- which(res[, 1] == res[, 2])
    if ( length(idx) > 0 ) { res <- res[-idx, , drop=FALSE] }
    # Remove duplicacted entries
    mapper <- unique(res)

    return( mapper )
}

mirRenamer                  <- function(map, userMirs, miRecordsMirs, org)
{
    #
    # Converts miRNA annotation to a miRecords-compatible one.
    # miRecords could have either a new or an old annotation.
    # Some other miRNAs might not be availiable from miRecords.
    # 

    # Cleanup data
    map      <- map[which(!is.na(map[,2])),]
    userMirs <- userMirs[which(!is.na(userMirs))]

    # Find which user miRNAs are incompatible with miRecords annotations
    oddMirs    <- unique(userMirs[which(!userMirs %in% miRecordsMirs)])

    # Find a compatible annotation using the old to new miRNA annotation map.

    # New annotations
    newOddMirs <- oddMirs[which(oddMirs %in% map[,1])]

    # Old annotations
    oldOddMirs <- oddMirs[which(oddMirs %in% map[,2])]

    # Not availiable
    naMirs     <- setdiff(oddMirs, c(newOddMirs, oldOddMirs))

    finalMirs  <- userMirs

    # Remove na annotations
    finalMirs[which(userMirs %in% naMirs)] <- NA

    # Replace old annotations with new (where necessary)
    M    <- map[which(map[,2] %in% oldOddMirs),,drop=FALSE]
    idx  <- order(M[,1])
    M    <- M[idx,,drop=FALSE]
    fidx <- which(userMirs %in% M[,2])
    finalMirs[fidx] <- M[,1]
    
    # Replace new annotations with old (where necessary)
    M    <- map[which(map[,1] %in% newOddMirs),,drop=FALSE]
    idx  <- order(M[,2])
    M    <- M[idx,,drop=FALSE]
    fidx <- which(userMirs %in% M[,1])
    finalMirs[fidx] <- M[,2]

    res <- data.frame('Initial'=userMirs, 'Final'=finalMirs, 
            stringsAsFactors=FALSE)

    return(res)
}

test_pathwayToGraph <- function() 
{
	message('Testing test_pathwayToGraph...', appendLF = FALSE)

    sink( tempfile() ) 

    load(system.file('extdata', 'Examples//data.RData', package='CHRONOS'))

    # Create pathway graph
    pathways  <- c('04915', '04917', '04930', '05031')
    graphsRun <- createPathwayGraphs(org='hsa', pathways=pathways)

    sink()

    all.equal(graphsRun, graphs)

    message('done.')
}

extractLinearSubpathways  <- function(graphs, pathways, a, b, filter, export, 
                                        groupMode, verbose)
{
    if (missing(a))         { a         <- 3 }
    if (missing(b))         { b         <- 10 }
    if (missing(export))    { export    <- c('.RData') }
    if (missing(filter))    { filter    <- FALSE }
    if (missing(groupMode)) { groupMode <- 'expand'}

    tryCatch(
    {
        message('Extracting Linear Subpathways...', appendLF = FALSE)        
        linSubs <- .extractLinearSubpathways(graphs, pathways, a, b, 
                                                filter, export, groupMode)
        message('done.')

        return(linSubs)
    }, warning = function(war) 
    {
    }, error = function(e) 
    {
        closeAllConnections()
        message('\nError in linear subpathway extraction.')
    }
    , finally = { }
    )    
}


.extractLinearSubpathways <- function(graphs, pathways, a, b, filter, 
                                        export, groupMode)
{
    if (filter)
    {
        # Extract user genes from gene expressions to keep only relevant 
        # subpaths
        load(cache$dirs$geneExpressions, e <- new.env()) 
        geneExpr  <- e[[ls(e)[1]]]

        if (is.null(geneExpr))
        { 
            stop('Please import expression data or set filter=FALSE\n')
            return(NULL) 
        }
    }

    t         <- 10000
    limit     <- 10
    opts      <- list(filter=filter, a=a, b=b, t=t, limit=limit, 
                    export=export)
    cAdjMats  <- graphs$combined
    eAdjMats  <- graphs$expanded
    org       <- graphs$org
    userGenes <- NULL

    if (!missing(pathways))
    {
        # Keep only graphs for selected pathways
        pathways <- paste(org, pathways, sep='')
        cAdjMats <- cAdjMats[pathways]
        eAdjMats <- eAdjMats[pathways]
    }

    if (length(cAdjMats) == 0) { return(NULL) }

    if (filter)
    {
        # Export genes from gene expressions
        userGenes <- sort(as.numeric(unique(rownames(geneExpr))))
    }

    # Create temporary directories
    .createDirectories(org)
        
    # Print compact adjacency matrices to disk (java input).
    matrixToFile(cAdjMats, org, cache$dirs)

    # Extract pathway names
    pathNames <- paste0(names(cAdjMats), '.txt')

    # Extract compact linear subpaths
    export <- c('getLinearPairs', 'cache', 'write.table', 'tail')
    cores  <- ifelse( length(cAdjMats) > detectCores()*10, 'default', 1 )
    res    <- .doSafeParallel( 
                funcName=getLinearSubpath, export=export,
                combine='default', N=length(cAdjMats), cores=cores,
                cAdjMats, pathNames, org, opts$a, opts$b, opts$t, opts$limit)

    # Summarize results
    if (length(res) > 0) 
    { 
        linRes <- data.frame( matrix(unlist(res), nrow=length(res), 
                            byrow=TRUE), stringsAsFactors=FALSE)    
    }else{ linRes <- NULL }


    if (groupMode == 'expand')
    {
        # Expand compact linear subpaths to obtain final subpaths.    
        subDir   <- paste(cache$dirs$tmp$sub, org, sep='//')
        subFiles <- paste(subDir, '//',names(cAdjMats), '.txt', sep='')

        export <- c('getSplittingFactor', 'expansionEvaluator',
                    'fullCollapse', 'subpathExpansion', 'fk', 'cleanSubpath')
        eSubs  <- .doSafeParallel(funcName=expandSubpath, 
                        export=export,
                        combine='default',
                        N=length(cAdjMats),
                        cores=cores,
                        cAdjMats, subFiles, opts$t, opts$b)
        names(eSubs) <- names(cAdjMats)

        # Delete temporaty files and directories
        .cleanDirectories()

        # Conform subpaths to a single matrix
        subpaths  <- unlistToMatrix(eSubs)

        if (filter)
        {
            # Filter subpaths using user genes from gene expression data
            subpaths <- .filterLinearSubpaths(subpaths=subpaths, 
                                            userGenes=userGenes)
        }

        # Export subpaths 
        exportSubpaths(subpaths, dir=paste(cache$dirs$lnr, org, sep='//'), 
                        type=opts$export, verbose=FALSE)

        adjMats <- eAdjMats    
    }

    if (groupMode == 'collapse')
    {
        # Collapse multiple genes to a single entry
        subpaths <- .collapseSubpaths(org, cAdjMats, b, userGenes)
        adjMats  <- cAdjMats    
    }

    # Remove concecutive duplicated genes from subpathways
    subpaths   <- .uniquifySubpaths(subpaths)
    subsLinear <- list(subpaths=subpaths, adjMats=adjMats, 
                        groupMode=groupMode, org=org, subpathwayType='Linear')


    return(subsLinear)
}



##
## Linear Subpathway Extraction
## 


getLinearSubpath      <- function(i, ...)
{
    # ------- Unpacking arguments -------
    args      <- list(...)
    adjMat    <- args[[1]][[i]]
    pathName  <- args[[2]][i]
    org       <- args[[3]]
    a         <- args[[4]]
    b         <- args[[5]]
    threshold <- args[[6]]
    limit     <- args[[7]]
    # ----------------------------------

    firstRun <- TRUE
    while(TRUE)
    {
        if (!firstRun) 
        {
            adjMat[upper.tri(adjMat)] <- 0 
        }

        parDir <- paste(cache$dirs$tmp$par, org, sep='//')
        lPairs <- getLinearPairs(adjMat, pathName, parDir)
        res    <- c(gsub('.txt', '', pathName), -2, -2)

        if (!is.null(lPairs$valid))
        {
            pathToJar <- system.file('java//CHRONOS.jar', package='CHRONOS')

            baseDir <- paste(gsub('//','/',cache$dirs$int),'/', sep='')
            args <- c(lPairs$valid, org,  baseDir, a, b, threshold, limit)
            .jinit(); 
            .jaddClassPath(pathToJar); 
            obj <- .jnew("LinearPaths")
            .jcall(obj, returnSig="V", method="main", args)
            
            logFile <- file.path(baseDir, 'log', org, lPairs$valid)
            logFile <- paste(gsub('//','/',logFile),'/', sep='')
            logFile <- substr(logFile, 1, nchar(logFile)-1)
            res <- unlist(strsplit(readLines(logFile)[[1]], '-'))
            res <- c(lPairs$valid, as.numeric(res[1]), as.numeric(res[2]))
        }

        if (res[2] != '0') { break() }
        if (res[2] == '0' && firstRun)  { firstRun <- FALSE; next() }
        if (res[2] == '0' && !firstRun) { break() }
    }

    return (res)
}

getLinearPairs        <- function(adjMat, pathNames, pairDir)
{

    sourceNodes  <- vector()
    destinNodes  <- vector()
    valid = c(); invalid = c()

    # Source nodes do not have any ones in their respective columns
    # Destination nodes do not have ones in their respective rows.
    if(!is.matrix(adjMat)) 
    {
        return (list(valid=NULL, invalid=pathNames))
    }


    for (i in 1:ncol(adjMat))
    {
        # A source node has no incoming edges
        isSource = ( length(which(adjMat[,i] == 0)) == ncol(adjMat) )
        # A destination node has no outgoing edges
        isDestin = ( length(which(adjMat[i,] == 0)) == nrow(adjMat) )

        # If it both source and destination node it is a remote node
        if (isSource && isDestin) { next() }

        if (isSource) { sourceNodes <- c(sourceNodes, i) }
        if (isDestin) { destinNodes <- c(destinNodes, i) }
    }

    res <- list()
    ctr <- 1
    for ( s in sourceNodes )
    {
        source <- unname(s)
        for ( d in destinNodes )
        {
            destin     <- unname(d)
            if (source != destin) 
            {
                res[[ctr]] <- list(source, destin)
                ctr        <- ctr + 1
            }
        }
    }

    if (!is.null(unlist(res))) 
    { 
        results <-  t(matrix(unlist(res), nrow = 2)) 
    }else 
    { 
        results = '' 
    }


    # Print each set of valid pairs to file
    if ( is.matrix(results) ) 
    {
        valid <- c(valid, pathNames)
    }
    else
    {
        results <- as.matrix(vector(), ncol=2)
        invalid <- c(invalid, pathNames)
    }

    outfile <- paste(pairDir,  pathNames, sep = '//')
    write.table( results, file = outfile, sep = '\t', col.names=FALSE, 
                row.names=FALSE )
    files = list(valid=valid, invalid=invalid)

    return(files)
}

filterLinearSubpaths  <- function(subpaths, userGenes)
{

    return(.filterLinearSubpaths(subpaths, userGenes))
}

.filterLinearSubpaths <- function(subpaths, userGenes)
{
    if ( is.null(subpaths) )         { return(subpaths) }
    if ( is.null(userGenes) )        { return(subpaths) }
    if ( nrow(subpaths)==0 )         { return(subpaths) }


    # Conform subpaths to a single matrix
    if (is.list(subpaths)) 
    { 
        subpaths <- unlistToMatrix(subpaths) 
    }

    userGenes     <- c(0, userGenes)
    r             <- matrix(1, nrow=nrow(subpaths), ncol=ncol(subpaths))
    R             <- subpaths
    for (i in 1:ncol(subpaths))
    {
        idx <- which(subpaths[,i]  %in% userGenes)
        if (length(idx) > 0)     { r[idx, i] <- 0 }
        if (length(idx) == 0)     { r[, i]     <- 0 }
    }
    idx <- which(rowSums(r) > 0)

    if (length(idx) > 0) 
    {
        R           <- subpaths[-idx, ,drop=FALSE]
        rownames(R) <- rownames(subpaths)[-idx]
    }
            
    return(R)
}



## 
## Linear Subpathway Collapsing
## 

.collapseSubpaths    <- function(org, adjMats, b, userGenes)
{

    message('Collapsing Linear Subpaths...', appendLF = FALSE)

    pathNames <- names(adjMats)
    subDir    <- paste(cache$dirs$tmp$sub, org, sep='//')
    subFiles  <- paste(subDir, '//',pathNames, '.txt', sep='')
    subpaths  <- matrix(,nrow=0, ncol=b)
    
    for (i in 1:length(subFiles))
    {
        if (!file.exists(subFiles[i])) { next() }

        if (file.exists(subFiles[i])) 
        {
            cSubpaths <- scan(subFiles[i], what='', sep="\n", quiet=TRUE)
            if (length(cSubpaths) == 0)  { next() }
        }
        
        genes <- vector(mode='list', length=ncol(adjMats[[i]]))
        z     <- 1
        for (col in colnames(adjMats[[i]]))
        {
            genes[[z]] <- as.integer(unlist(strsplit(col, ' ')))
            z          <- z + 1
        }

        # Check each element (single gene or group of genes) 
        # and remove genes not in user list
        if (!missing(userGenes))
        {            
            for ( j in 1:length(genes) )
            {
                idx <- which(genes[[j]] %in% userGenes)
                if (length(idx) > 0)  { genes[[j]] <- genes[[j]][idx] }
                if (length(idx) == 0) { genes[[j]] <- NA }
            }
        }

        if (length(cSubpaths) > detectCores() * 10)
        {
            # Create and register parallel backend
            cl <- makeCluster(detectCores(logical=FALSE))
            on.exit(stopCluster(cl), add=TRUE)
            registerDoParallel(cl)
        }else
        {
            # Run sequentially for trivial inputs
            registerDoSEQ()
        }

        subs <- foreach(j=1:length(cSubpaths), .combine='rbind') %dopar%
        {
            # Create a subpath as a list of bins
            sub <- as.integer(unlist(strsplit(cSubpaths[[j]], ' ')))
            sub <- c(genes[sub], as.list(rep(0, b-length(sub))))

            # Reject subpath if it has a invalidated gene (not in user list)
            if(length(which(is.na(sub))) > 0) { return(NULL) }

            sub <- sapply(sub, function(x) { paste(x, collapse=' ') })
            sub <- matrix(sub, nrow=1)
            rownames(sub) <- names(adjMats)[i]

            return(sub)
        }

        subpaths <- rbind(subpaths, subs)
    }

    message('done.')

    return(subpaths)
}


##
## Linear Subpathway Expansion
##


expandSubpath      <- function( i, ... )
{
    # ------- Unpacking arguments -------
    args      <- list(...)
    adjMat    <- args[[1]][[i]]
    subFile   <- args[[2]][i]
    threshold <- args[[3]]
    b         <- args[[4]]
    # ----------------------------------

    # Read compact subpathway from local file of created subpaths 
    if (file.exists(subFile))
    {
        cSubpaths <- scan(subFile, what='', sep="\n", quiet=TRUE)
    }else { return(NULL) }
    
    j     <- 1
    genes <- vector(mode='list', length=ncol(adjMat))
    for (col in colnames(adjMat))
    {
        genes[[j]] <- as.integer(unlist(strsplit(col, ' ')))
        j <- j + 1
    }

    sf    <- getSplittingFactor(cSubpaths, genes, b, threshold)
    k     <- sf$k
    nsubs <- sf$nsubs
    genes <- sf$genes
    
    # Full collapsing
    if (k < 1)
    {
        res <- fullCollapse(cSubpaths, adjMat, b, threshold)
    }
    # Partial collapsing
    if (k > 0)
    {
        R   <- subpathExpansion(genes, cSubpaths, nsubs, threshold,
                                k=k, b=b)
        res <- R$eSubpaths
    }

    return(res)
}

getSplittingFactor <- function(subs, genes, b, threshold)
{
    if (length(subs) > 2000) 
    { 
        return( list(k=0, nsubs=length(subs), genes=genes) ) 
    }
    
    while(TRUE)
    {
        k  <- 1
        s0 <- 0
        while(TRUE)
        {
            j     <- 1
            nsubs <- vector(mode="numeric", length=length(subs))
            for (sub in subs)
            {
                nsubs[j<-j+1] <- expansionEvaluator(sub, genes, k=k, b=b, 
                                                    threshold)
            }
            s  <- sum(nsubs)
            if ( s <= threshold && k<2 )  { s0 <- s;   break() }
            if ( s <= threshold && k>1 )  { s0 <- s;   break() }
            if ( s > s0 && k > 1 )        { k  <- k-1; break() }
            k  <- k + 1
            s0 <- s
        }

        if (s0 > threshold)        
        { 
            z <- 1
            genesCut <- vector(mode='list', length=length(genes))
            for (x in genes)
            {
                s             <- 1:ceiling(length(x)/2)
                genesCut[[z]] <- x[s]     
                z             <- z + 1
            }
            genes <- genesCut
            k     <- 1 
            s0    <- 0
            next() 
        }else { break() }
    }


    return(list(k=k,nsubs=s0,genes=genes))
} 

expansionEvaluator <- function(compactSubpath, genes, k, b, threshold)
{
    if (is.null(compactSubpath)) { return(NULL) }
    
    # Create a subpath as a list of bins
    sub <- as.integer(unlist(strsplit(compactSubpath, ' ')))
    sub <- c(genes[sub], as.list(rep(0, b-length(sub))))
        
    # Spit the compact subpath to multiple components
    s   <- vector(mode='list', length=k)        
    for (j in 1:k) { s[[j]] <- lapply(sub, fk, k, j) }

    stats <- 0
    for (j in 1:k) 
    {
        gctr <- 1
        sub  <- s[[j]]
        for (z in 1:length(s[[j]]))
        { 
            if (length(sub[[z]]) > 1) { gctr <- gctr * length(sub[[z]]) } 
        }
        stats <- stats + gctr
        if (stats > threshold) { break() }
    } 

    return(stats=stats)
}

fullCollapse       <- function(compactSubpaths, adjMat, b, threshold)
{
    j     <- 1
    genes <- vector(mode='numeric', length=ncol(adjMat))
    for (cnames in colnames(adjMat))
    {
        x        <- unlist(strsplit(cnames, ' '))
        s        <- 1
        genes[j] <- as.integer(x[s])          
        j        <- j + 1
    }

    N <- length(compactSubpaths)

    if (N > threshold) 
    { 
        s               <- 1:threshold
        compactSubpaths <- compactSubpaths[s]   
        N               <- length(compactSubpaths)
    }
    eSubpaths <- matrix(0, nrow=N, ncol=b)
    j <- 1
    for (compactSubpath in compactSubpaths)
    {
        sub             <- as.integer(unlist(strsplit(compactSubpath, ' ')))
        sub             <- c(genes[sub], rep(0, b-length(sub)))
        eSubpaths[j,]   <- sub
        j               <- j + 1
    }

    return(eSubpaths)
}

subpathExpansion   <- function(genes, compactSubpaths, nsubs, threshold, 
                                k, b)
{
    if(length(compactSubpaths) == 0) { return(NULL) }
    
    rowCtr    <- 0
    eSubpaths <- matrix(0, nrow=nsubs, ncol=b)
    for (compactSubpath in compactSubpaths)
    {
        # Create a subpath as a list of bins
        sub <- as.integer(unlist(strsplit(compactSubpath, ' ')))
        sub <- c(genes[sub], as.list(rep(0, b-length(sub))))
        # Remove a possible second occurences of a gene in consecutive bins.
        sub <- cleanSubpath(sub)

        # Spit the compact subpath to multiple components
        s   <- vector(mode='list', length=k[1])
        for (i in 1:k) { s[[i]] <- lapply(sub, fk, k, i) }

        # Expand components
        for (i in 1:k) 
        {
            m <- t(t(expand.grid(s[[i]])))
            m <- unname(split(m, 1:nrow(m)))
            if ( !is(m, 'matrix') ) 
            { 
                m <- matrix(unlist(m), ncol=b, byrow=FALSE)
            }
            if ( is(m, 'matrix') )
            { 
                m <- matrix(unlist(m), ncol=b, byrow=TRUE) 
            }
            eSubpaths[(rowCtr+1):(rowCtr+nrow(m)),] <- m
            rowCtr <- rowCtr + nrow(m)
        }
    }
    # Remove exceeding rows (produced by emptying successive bins 
    # with same gene ids)
    eSubpaths <- eSubpaths[1:rowCtr,]
    if (!is.matrix(eSubpaths)) { eSubpaths <- matrix(eSubpaths, ncol=b) }
    

    return(list(eSubpaths=eSubpaths))
}

fk                 <- function(x,k,i)
{
    if (length(x) < k)  
    { 
        r <- x[1:length(x)] 
    }
    if (length(x) >= k) 
    { 
        r <- x[(floor((i-1)*length(x)/k)+1) : floor(i*length(x)/k)] 
    }
    return(r)
}

cleanSubpath       <- function(x)
{
    for (i in 1:(length(x)-1))
    {
        a <- x[[i]]
        b <- x[[i+1]]
        S <- intersect(a,b)
        for (s in S)
        {
            if (length(a) == 1 & length(b) > 1) 
            { 
                b <- b[-which(b == s)]; next() 
            }
            if (length(a) > 1 & length(b) == 1) 
            { 
                a <- a[-which(a == s)]; next() 
            }
            if (length(a) > 1 & length(b) > 1)  
            { 
                b <- b[-which(b == s)]; next() 
            }
        }
        x[[i]]   <- a
        x[[i+1]] <- b
    }

    return(x)
}


#
# Subpathway cleanup
#

.uniquifySubpaths   <- function(subpaths)
{

    if (is.null(subpaths))    { return(NULL) }
    if (nrow(subpaths) == 0)  { return(subpaths) }

    # Remove duplicates
    subpaths = subpaths[which(!duplicated(subpaths)),  , drop=FALSE]

    # Split subpaths according to their lengths
    len  <- getLengths(subpaths)
    didx <- c()

    for (i in 1:max(len))
    {
        idx0     <- which(len ==i)
        subs     <- subpaths[idx0, 1:i, drop=FALSE]

        if (nrow(subs) == 0) { next() }

        dupl     <- t(apply( subs , 1 , diff ))
        idx1     <- unique(which(dupl == 0, arr.ind = TRUE)[,'row'])
        didx     <- c(didx, idx0[idx1])
    }

    if (length(didx) > 0)
    {
        for (i in 1:length(didx))
        {
            idx     <- didx[i]
            ugenes  <- subpaths[idx, cumsum(rle(subpaths[idx,])$length)]
            subpaths[idx,]                  <- rep(0, ncol(subpaths))
            subpaths[idx, 1:length(ugenes)] <- ugenes
        }
    }

    # Remove too short subpaths
    lens     <- getLengths(subpaths)
    idx     <- which(lens < 3)
    if (length(idx) > 0)
    {
        subpaths <- subpaths[-idx, , drop=FALSE]
    }

    return(subpaths)
}

#
# Fold Change Interactivity (FCI) Score
#


scoreFCI <- function(expr, edgeList, fci.C, fci.K, fci.T)
{
    # Captures pairs of nodes with similar high positive, negative, 
    # or strongly opposed fold change values .

    if (missing(fci.C)) { fci.C <- 1 }
    if (missing(fci.K)) { fci.K <- 5 }
    if (missing(fci.T)) { fci.T <- 0.3 }


    fciScore <- array(0, dim=c(nrow(edgeList), ncol(expr)))
    for (e in 1:nrow(edgeList))
    {
        for (t in 1:ncol(expr))
        {
            i <- expr[edgeList[e,1], t] # Indexing by integer
            j <- expr[edgeList[e,2], t]

            s <- 1
            if (i*j < 0)
            {
                i <- abs(i)
                j <- abs(j)
                s <- -1;
            }

            s1 <- 1 + fci.C*(exp(-fci.K*(i-fci.T)) + exp(-fci.K*(j-fci.T)))
            s2 <- 1 + fci.C*(exp(-fci.K*(-i-fci.T)) + exp(-fci.K*(-j-fci.T)))
            fscore <- s * abs(s1^(-1) - s2^(-1))

            fciScore[e,t] <- fscore
        }
    }

    return(fciScore)
}


#
# Time Varying Interactivity (TVI) Score
#
scoreTVI  <- function(expressions, edgeList)
{
    #
    # Analyzes the interactivity dynamics among nodes by 
    # considering the dynamics of their expression changes.
    #
    wRange     <- 1
    weights    <- seq(-wRange,wRange)
    w          <- length(weights)
    expressNrm <- expressions

    nE         <- nrow(edgeList)
    prob_W     <- array(rep(0,w*1*nE), dim=c(w,1,nE))


    for (iq in 1:nrow(edgeList))
    {
        a1              <- expressNrm[edgeList[iq,1], 1]
        a2              <- expressNrm[edgeList[iq,2], 1]
        a               <- a1 * a2 
        prob_W[, 1, iq] <- exp(weights*a) / sum(exp(weights*a))
    }

    tv <- .markov(expressNrm, edgeList, weights, prob_W)  

    return(tv)
}

.markov   <- function(X, edges_mat, W, prob_w)
{
    # This function computes the Forward Backward iterates for the 
    # specified edge, E=(i,j), given observed data, X, and estimate for 
    # transition probability
    nE        <- nrow(edges_mat)
    nW        <- length(W)
    var_T     <- ncol(X)
    # memory allocation
    var_O     <- array(rep(0,nW*var_T*nE), dim=c(nW,var_T,nE))
    var_F     <- array(rep(0,nW*var_T*nE), dim=c(nW,var_T,nE))
    # pre-compute
    W             <- t(as.matrix(W))
    for (i in 1:var_T)
    {
        Xmult         <- as.matrix(X[edges_mat[,1],i] * X[edges_mat[,2], i])
        Xmult         <- as.matrix(apply(Xmult, 1, function(x) sum(x) ))
        Wmult         <- exp(t(W) %*% t(Xmult))  ## -t?
        xx             <- t(as.matrix(apply(Wmult, 2, function(x) sum(x) )))
        Wmult          <- Wmult/kronecker(matrix(1,nW,1), xx)
        var_O[,i,]     <- matrix(as.vector(Wmult), nrow=nW, ncol=nE) 
    }

    # initialization
    var_F[,1,]  <- prob_w

    for (t in 2:var_T)
    {
        for (e in 1:nE)
        {
            var_F[, t, e] <- var_O[, t, e] * var_F[, t-1, e]
            var_F[, t, e] <- var_F[, t, e] / sum( var_F[, t, e] )
        }
    }

    pW     <- var_F
    cW     <- matrix(0, nE, var_T)
    for (i in 1:var_T)
    {
        r      <- apply(pW[,i,] , 2, function(x) which.max(x))
        cW[,i] <- W[r]
    }

    return(cW)
}



#
# Evaluate miRNA-mRNA interactions
#
.getMiScores    <- function(geneExpr, mirExpr, edges, lex, mode, fci.C, fci.K,
                            fci.T)
{
    # Create joint expression matrix
    expressions     <- rbind(geneExpr, mirExpr) 
    edgeList        <- edges[,1:2]

    k <- 1
    if (nrow(edgeList) > 3000) 
    { 
        k <- floor(nrow(edgeList)/3000) 
    }
    S  <- splitWork(N=nrow(edgeList), k)

    i  <- 0
    export <- c('scoreTVI', 'scoreFCI')
    IS <- foreach (i = 1:S$k, .export=export, .combine='rbind') %do%
    {
        # Calculate TVI score
        tvr <- scoreTVI(expressions, edgeList[S$jobs[[i]], , drop=FALSE])

        # Calculate FCI score
        fci <- scoreFCI(expressions, edgeList[S$jobs[[i]], , drop=FALSE], 
                            fci.C=fci.C, fci.K=fci.K, fci.T=fci.T) 

        # Calculate mir-gene interactions final score
        # len     <- nrow(edgeList[S$jobs[[i]], , drop=FALSE])
        idx     <- matrix(sign(fci*tvr)>0, nrow=length(S$jobs[[i]]))
        score   <- (0.8*abs(fci) + 0.2*abs(tvr))*idx

        return(score)
    }

    return(edgeScore=IS)
}

.filterMiScores <- function(subpaths, mlex, mirnaScoreThres, type, lex)
{
    
    scoreThr     <- mirnaScoreThres

    if (is.null(subpaths) || nrow(subpaths) < 1) { return(subpaths) }

    # Keep interaction with at least one good score in any time point
    E           <- mlex$edges
    miScore     <- E[, 5:ncol(E)]
    t           <- ncol(miScore)
    idx         <- which(miScore > scoreThr)
    M           <- matrix(0, nrow=nrow(miScore), ncol=ncol(miScore)) 
    M[idx]      <- 1
    midx        <- which(rowSums(M) > 0)
    names(midx) <- midx
    E           <- E[midx, 3:ncol(E)]

    # Find miRNA-gene interactions relevant to subpathway genes.
    genes       <- getSubpathwayGenes(subpaths, type)
    E           <- E[which(E[,2] %in% genes), ]
    Ns          <- getLengths(subpaths)

    # Find unique genes in each subpathway    
    subGenes <- vector(mode='list', length=nrow(subpaths))
    for (i in 1:nrow(subpaths))
    {
        subGenes[[i]] <- getSubpathwayGenes(subpaths[i,, drop=FALSE], type)
    }

    # Find miRNAs targeting each gene
    uGenes  <- unique(E[,2])
    R       <- vector(mode='list', length=length(uGenes))
    for (i in 1:length(R))
    {
        idx     <- which(E[,2] %in% uGenes[i])
        R[[i]]  <- idx
    }
    names(R) <- uGenes


    # Find gene targets for each miRNA
    uniqueMiRNAs    <- unique(E[,1])
    miRNATargets    <- vector(mode='list', length=length(uniqueMiRNAs))
    for (i in 1:length(uniqueMiRNAs))
    {
        miRNATargets[[i]] <- E[which(E[,1] == uniqueMiRNAs[i]), 2]
    }
    names(miRNATargets) <- uniqueMiRNAs

    k <- 1
    if (nrow(subpaths) > 5) 
    {  
        k <- floor(nrow(subpaths)/5) 
    }
    jobs   <- splitWork(N=nrow(subpaths), k)$jobs
    subIds <- 1:nrow(subpaths)

    # Extract compact linear subpaths
    export <- c('getSubpathwayGenes', 'phyper', 'na.omit')
    cores  <- ifelse( nrow(subpaths) > detectCores()*1000, 'default', 1 )

    r <- .doSafeParallel( 
            funcName=miRNAsubScoring, export=export,
            combine='c', N=k, cores=cores,
            subpaths, E, R, genes, Ns, scoreThr, type, subIds, miRNATargets,
            jobs)


    # Unlist first level of results
    subMirs            <- do.call('c', r[seq(1, length(r), 3)])
    mirScores          <- do.call('rbind', r[seq(2, length(r), 3)])
    edgeList           <- do.call('rbind', r[seq(3, length(r), 3)])
    subMirs            <- matrix(subMirs, ncol=1)
    rownames(subMirs)  <- 1:nrow(subMirs)
    colnames(subMirs)  <- 'miRNAsOverSubpathway'
    rownames(edgeList) <- 1:nrow(edgeList)

    # Filter multiple edges
    idx <- which(duplicated(edgeList[, 1:2]))
    if ( length(idx) > 0 )
    {
        edgeList <- edgeList[-idx, ]
    }
    # Sort edgeList according to miRNA
    idx <- order(as.numeric(gsub("\\D", "", edgeList[, 1])))
    edgeList <- edgeList[idx,  ]
    rownames(edgeList) <- 1:nrow(edgeList)

    # Remove unused rows
    mirScores <- mirScores[rowSums(is.na(mirScores)) != ncol(mirScores), ]
    colnames(mirScores) <- c('miRNA', 'Entrez', paste0('T', 1:t))

    res <- list(miRNAsOverSubpathway=subMirs, mirScores=mirScores, 
                edgeList=edgeList)

    return(res)
}

miRNAsubScoring <- function(i, ...)
{

    # ------- Unpacking arguments -------
    args         <- list(...)
    subpaths     <- args[[1]]
    E            <- args[[2]]
    R            <- args[[3]]
    genes        <- args[[4]]
    Ns           <- args[[5]]
    scoreThr     <- args[[6]]
    type         <- args[[7]]
    subIds       <- args[[8]]
    miRNATargets <- args[[9]]
    jobs         <- args[[10]]
    # ----------------------------------
    idx      <- jobs[[i]]
    subpaths <- subpaths[idx, ,drop=FALSE]
    Ns       <- Ns[idx]
    subIds   <- subIds[idx]
    # ----------------------------------


    t           <- ncol(E) - 2 
    subMirs     <- rep('', nrow(subpaths))
    mx          <- nrow(subpaths)*length(unique(E[,1]))
    mirScores   <- matrix(, ncol=(2+t), nrow=mx)

    finalInteractions <- c()
    cRow              <- 1
    for (si in 1:nrow(subpaths)) 
    {
        # Collapse the miRNA-gene scoring matrix to miRNAs targeting the sub.
        locGenes <- getSubpathwayGenes(subpaths[si,], type)
        map <- E[unique(unname(unlist(R[as.character(locGenes)]))), ]

        # Find the miRNAs that target any of the subpathway
        miOverSub   <- unique(map[,1])

        if (length(miOverSub) == 0) { next() }

        # Find statistical significance of each miRNA targeting the sub.
        sigMiOverSub <- miOverSub
        for (j in 1:length(miOverSub))
        {
            # Genes in subpath targeted by the miRNA.
            A       <- length(unique(map[, 2]))
            # User genes
            B       <- length(genes)    
            # Number of gene targets of miRNA in miRecords.
            C       <- length(unlist(miRNATargets[miOverSub[j]]))
            # Subpath length
            D       <- Ns[si]

            if ( (1 - phyper(A, C, B-C, D)) > 0.05) { sigMiOverSub[j] <- NA }
        }

        sigMiOverSub                         <- na.omit(sigMiOverSub)
        attributes(sigMiOverSub)$'na.action' <- NULL

        # Calculate miRNA-subpathway scores
        subMsg              <- NULL
        mirScore            <- matrix(, nrow=length(sigMiOverSub), ncol=(2+t))
        colnames(mirScore)  <- c('miRNA', 'sub', paste('T', 1:t, sep=''))

        for (j in 1:length(sigMiOverSub))
        {
            mir <- sigMiOverSub[j]
            e   <- map[which(map[,1] == mir), , drop=FALSE]

            if (nrow(e) > 0)
            {                
                fScores             <- e[,-c(1,2), drop=FALSE]
                colnames(fScores)   <- paste('T', 1:ncol(fScores), sep='')
            }

            r   <- colMeans(e[-c(1,2)],)
            idx <- unname(which(r >= scoreThr))

            if (length(idx) > 0)
            {
                tP     <- paste(paste('t', idx, sep=''), collapse=',')
                msg    <- sprintf('%s(%s)',mir, tP)
                subMsg <- c(subMsg, msg)

                mirScore[j, 1]         <- sigMiOverSub[j]
                mirScore[j, 2]         <- subIds[si]
                mirScore[j, 3:(2 + t)] <- round(r*10^4)/10^4
            }

            # Save edgelist indexes that pass the bar
            if ( nrow(e) > 0 )
            {
                for ( z in 1:nrow(e) )
                {
                    idx <- unname(which(e[z, , drop=FALSE] >= scoreThr))
                    if (length(idx) > 0)
                    {
                        rname <- rownames(e[, z, drop=FALSE])
                        finalInteractions <- c(finalInteractions, rname)
                    }
                }
            }
        }
        if (nrow(mirScore) > 0)
        {
            idx                 <- cRow : (cRow + nrow(mirScore) - 1)
            mirScores[idx, ]    <- mirScore
            cRow                <- cRow + nrow(mirScore)
        }

        subMirs[si] <- paste(subMsg,  collapse=' ')
    }

    # Return edgeList containing only strong miRNA-mRNA interactions
    edgeList <- E
    idx <- which(rownames(E) %in% unique(finalInteractions))
    if ( length(idx) > 0 )
    {
        edgeList <- E[idx, , drop=FALSE]
    }

    return(list(subMirs=subMirs, mirScores=mirScores, edgeList=edgeList))
}

CHRONOSrun <- function(mRNAexp, mRNAlabel, miRNAexp, pathType, subType, 
                        measures, thresholds, org, export, verbose,
                        miRNAinteractions)
{
    if (missing(mRNAexp))    { mRNAexp  <- 'mRNAexpressions.txt' }
    if (missing(mRNAlabel))  { mRNAlabel <- 'entrezgene' }
    if (missing(miRNAexp))   { miRNAexp <- 'miRNAexpressions.txt' }
    if (missing(pathType))   { pathType <- 'All' }
    if (missing(subType))    { subType  <- 'All' }
    if (missing(measures))   { measures <- 'FALSE' }
    if (missing(org))        { org      <- 'hsa' }
    if (missing(export))     { export   <- '.txt' }
    if (missing(verbose))    { verbose  <- FALSE }
    if (missing(thresholds)) 
    {
        thresholds <- c('p-value'=0.04, 'subScore'=0.4, 'mirScore'=0.4)
    }
    if (missing(miRNAinteractions)) { miRNAinteractions <- NULL }

    if (!verbose) { sink( tempfile() ) }

    importExpressions(data=mRNAexp, type=mRNAlabel, sep='\t', org=org)
    importExpressions(data=miRNAexp, org=org, type='miRNA', sep='\t')

    # Download Insulin Signaling Pathway
    paths   <- downloadPathways(org=org, pathways=pathType)
    
    # Create pathway graph
    graphs  <- createPathwayGraphs(org=org, pathways=paths)

    if ( 'Linear' %in% subType || 'All' %in% subType )
    {
        # Extract linear subpathways
        linSubs <- extractLinearSubpathways(graphs=graphs, filter=TRUE)

        # Filter linear subpathways
        linSubsScored <- scoreSubpathways(subpathways=linSubs, 
                            filters=thresholds,
                            miRNAinteractions=miRNAinteractions)
        if ( '.xlsx' %in% export )
        {
            to <- if (org == 'hsa') 'hgnc_symbol' else mRNAlabel
            to <- if (org == 'mmu') 'mgi_symbol' else to
            visualizeResults( summary=linSubsScored, export=export,
                            from=mRNAlabel, to=to ) 
        }
    }
    if ( 'Non-Linear' %in% subType || 'All' %in% subType )
    {
        # Extract non linear subpathways
        nliSubs <- extractNonLinearSubpathways(graphs=graphs, filter=TRUE)

        # Filter non linear subpathways
        nliSubsScored <- scoreSubpathways(subpathways=nliSubs, 
                            filters=thresholds,
                            miRNAinteractions=miRNAinteractions)
        if ( '.xlsx' %in% export )
        {
            to <- if (org == 'hsa') 'hgnc_symbol' else mRNAlabel
            to <- if (org == 'mmu') 'mgi_symbol' else to
            visualizeResults( summary=nliSubsScored, export=export,
                            from=mRNAlabel, to=to )
        }
        
    }
    out <- list('graphs'=graphs)
    if ( 'Linear' %in% subType )
    {
        out <- list('graphs'=graphs, 'linSubs'=linSubs, 
                'linSubsScored'=linSubsScored) 
    }
    if ( 'Non-Linear' %in% subType )
    {
        out <- list('graphs'=graphs, 'nliSubs'=nliSubs, 
                'nliSubsScored'=nliSubsScored)
    }
    if ( 'All' %in% subType )
    {
        out <- list('graphs'=graphs, 'linSubs'=linSubs, 'nliSubs'=nliSubs, 
                'linSubsScored'=linSubsScored, 'nliSubsScored'=nliSubsScored)
    }
    if (!verbose) { sink() }

    return(out)
}

pathwayMeasures       <- function(graphs)
{
    message('Topological evaluation of genes in pathways...',appendLF = FALSE)
    
    rnd     <- 10^4
    adjMats <- graphs$expanded
    org     <- graphs$org
    f       <- vector(mode='list', length=3)
    lex     <- matrixToLexicon( adjMats=adjMats, org=org, groupMode='expand')

    # Topological evaluation of genes in pathways 1 - Bridgeness
    res1 <- .bridgeness(adjMats, org)
    # Topological evaluation of genes in pathways 2 - Betweenness Centrality
    res2 <- .betweennessCentrality(lex)
    # Topological evaluation of genes in pathways 3 - Degree
    res3 <- .degree(lex)

    res           <- matrix(,ncol=3, nrow=length(lex$genes))
    colnames(res) <- c('pathness', 'BC', 'DEG')
    rownames(res) <- names(lex$genes)
    res[,1]       <- round(normalize(res1) * rnd)/rnd
    res[,2]       <- round(normalize(res2) * rnd)/rnd
    res[,3]       <- round(normalize(res3) * rnd)/rnd
    
    message('done.')

    return(res)
}



.bridgeness            <- function(adjMats, org)
{

    .pathwayGenes          <- function(adjMats, org, lex)
    {
        # Create a matrix which contains the unique genes of a pathway in each 
        # column. Columns contain the organism's pathways. 

        N    <- length(adjMats)
        ids  <- vector(mode='list', length=N)
        lens <- vector(mode='numeric', length=N)
        i   <- 1
        for (adjMat in adjMats)
        {
            if(!is.matrix(adjMat)) { i <- i+1; next() }

            locIds <- c() 
            for (m in 1:length(rownames(adjMat)))
            {
                s      <- rownames(adjMat)[m]
                locIds <- c(locIds, gsub(paste(org,':',sep=''),'',s ))     
            }
            # Filter genes keeping only the ones that appear in the subpaths.
            if (!missing(lex)) 
            { 
                locIds <- intersect(locIds, names(lex$genes)) 
            }
            ids[[i]] <- as.numeric(locIds)
            lens[i]  <- length(locIds)
            i        <- i + 1
        }

        # Turn list of uneven subpaths to matrix
        M <- matrix(0, nrow=max(lens), ncol=N)
        for (i in 1:N)
        {
            if (lens[i] > 0) { M[1:lens[i],i] <- ids[[i]] }
        }

        return(M)
    }


    # Calculates the bridgeness of all provided genes based on 
    # their intersections betweeen pathways.
    
    cat('Calculating bridgeness of pathway genes...')
    
    modules <- .pathwayGenes(adjMats, org)
    m       <- ncol(modules)
    nodes   <- sort(unique(as.vector(modules)))
    if (length(nodes) < 1) { return(NULL) }

    if (nodes[1] == 0) { nodes <- nodes[2:length(nodes)] }

    b      <- vector(mode='numeric', length=length(nodes))

    for (i in 1:(m-1))
    {
        for (j in (i+1):m)
        {
            common <- intersect(modules[,i], modules[,j])
            idx    <- nodes %in% common
            b[idx] <- b[idx] + 1/length(common)
        }
    }
    res        <- b
    names(res) <- nodes

    cat('done\n')

    return(res)
}


.betweennessCentrality <- function(lexicon)
{
    # Calculates the betweeness centrality for all provided genes based on 
    # their corresponding iteractions.

    cat('Calculating betweeness centrality of pathway genes...')

    genes <- lexicon$genes
    edges <- lexicon$edges

    # Create the adjacency matrix for the whole organism
    N      <- length(genes)
    adjMat <- matrix(0, nrow=N, ncol=N)
    for (i in 1:nrow(edges))
    {
        adjMat[edges[i,3], edges[i,4]] <- 1
    }
    rownames(adjMat) <- names(genes)
    colnames(adjMat) <- names(genes)

    # # Create a graph based on the adjacency matrix
    # g   <- ugraph(as(graphAM(adjMat, 'directed'),'graphNEL'))

    # # Calculate the betweeness centrality for each gene
    # r   <- brandes.betweenness.centrality(g)
    # bc  <- t(r$betweenness.centrality.vertices)
    # res <- unname(as.vector(bc))
    # names(res) <- names(genes)

    # Brandes BC is broken in RBGL, TODO if addressed.
    g  <- igraph::graph_from_adjacency_matrix(adjMat, mode="undirected")
    res  <- igraph::betweenness(g, directed=FALSE, normalized=FALSE)

    cat('done\n')

    return(res)
}


.degree                <- function(lexicon)
{
    cat('Calculating degree of pathway genes...')

    genes <- lexicon$genes
    edges <- lexicon$edges

    # Create the adjacency matrix for the whole organism
    N      <- length(genes)
    adjMat <- matrix(0, nrow=N, ncol=N)
    for (i in 1:nrow(edges))
    {
        adjMat[edges[i,3], edges[i,4]] <- 1
    }

    res <- vector(mode='numeric', length=length(genes))
    for (i in 1:nrow(adjMat))
    {
        res[i] <- sum(adjMat[i,]) + sum(adjMat[,i])
    }

    cat('done\n')

    return(res)
}

test_CHRONOSrun <- function() 
{
	message('Testing test_CHRONOSrun...', appendLF = FALSE)
    
    sink( tempfile() ) 

    load(system.file('extdata', 'Examples//data.RData', package='CHRONOS'))


    out <- CHRONOSrun( 
                mRNAexp=mRNAexpr,
    			mRNAlabel='entrezgene',
    			miRNAexp=miRNAexpr,
    			pathType=c('04915', '04917', '04930', '05031'),
				org='hsa',
				subType='All',
				thresholds=c('subScore'=0.4, 'mirScore'=0.4),
                miRNAinteractions=miRNAinteractions)
    
    sink()

    all.equal(CHRONOSdemo, out)

    message('done.')
}

#
# Evaluate statistical significance
#


.getStatistics     <- function(subpaths, genes, type, pVal, pAdjust)
{
    # The statistical significance of the subscore is evaluated via
    # cumulative hypergeometric distribution so as to examine the enrichment
    # of a subpathway in any user-defined set of interesting genes 
    # (e.g. list of differentially expressed genes (DEGs)). 
    #

    # d: Interesting genes involved in the subpathway
    # D: User defined set of interesting genes in pathway list
    # G: User defined genes in pathway list 
    # l: All genes involved in the subpathway

    message('Evaluating statistical significance of subscore...', 
        appendLF = FALSE)
    if (missing(pVal))    { pVal <- 0.05 }
    if (missing(pAdjust)) { pAdjust <- '' }

    # Read interesting genes from directory
    inFile <- cache$dirs$interestingGenes
    if (!file.exists(inFile)) 
    { 
        stop('No interesting genes provided\n') 
    }
    
    interGenes        <- as.integer(readLines(inFile))
    subGenes          <- getSubpathwayGenes(subpaths, type)
    interGenesInSubs  <- interGenes[interGenes %in% subGenes] 
    interGenesInPaths <- interGenes[interGenes %in% genes]

    if ('Linear' %in% type)
    {
        # Genes of each subpathway considered as interesting
        x     <- rowSums(matrix(subpaths %in% interGenesInSubs, 
                        nrow=nrow(subpaths)))
        # Interesting genes in all pathways
        D     <- length(interGenesInPaths)
        # All user genes (in pathways)
        G     <- length(genes)
        # Number of genes in each subpathway
        l     <- getLengths(subpaths)
        # P-value calculation
        PV <- 1 - phyper(x, D, G-D, l)
    }

    if ('Non-Linear' %in% type)
    {
        PV <- rep(0, nrow(subpaths))
        for(i in 1:nrow(subpaths))
        {
            subGenes     <- getSubpathwayGenes(subpaths[i,], type)
            # Genes of each subpathway considered as interesting
            nH             <- length(which(subGenes %in% interGenesInSubs))
            # Interesting genes in all pathways
            nD             <- length(interGenesInPaths)
            # All user genes
            nG             <- length(genes)
            # Number of genes in each subpathway
            nL             <- length(subGenes)
            # P-value calculation
            PV[i]         <- 1 - phyper(nH, nD, nG-nD, nL)
        }
    }

    # The false positive discovery rate of P results is reduced 
    # by providing False Discovery Rate (FDR) corrected P-values (q-values)
    if (pAdjust == 'fdr') { QV <- p.adjust(PV, method='fdr') }
    if (pAdjust != 'fdr') { QV <- PV }

    message('done.')

    return(qValues=QV)
}



#
# Evaluate topological relations
#
.getMeasures       <- function(genes, subpaths, measures, mode)
{
    message('Evaluating subpaths based on gene topology...',appendLF = FALSE)
    if (is.null(subpaths) || nrow(subpaths)==0)
    { 
        message('done.'); return(NULL) 
    }

    T1 <- measures[,1]
    T2 <- measures[,2]
    T3 <- measures[,3]

    # Calculate the bridgeness and the betweenness centrality for all 
    # organism genes. Returns a list of two vectors. One named vector with 
    # the bridgeness values, and one with the betweenness centrality values. 
    # The order of these values is by increasing entrez gene id. 
    # subpathsGenes matrix contains the unique genes of each pathway.

    if (mode == 'Linear')
    {
        # Linear subpaths consist of consecutive genes. To index them, 
        # we assign each gene to real number and use this index to access 
        # the topological values vectors, which contain values in ascending 
        # order of entrez gene id.

        subpathsGenes <- subpaths
    }
    
    if (mode == 'Non-Linear')
    {
        # Non Linear subpaths are a set of interactions. Since ee are 
        # interested in the genes that interact and not the interactions 
        # themselves, we keep the set of unique genes for each subpath and 
        # score as shown previously.

        subpathsGenes <- matrix(0, nrow=nrow(subpaths), ncol=ncol(subpaths))
        for (i in 1:nrow(subpaths))
        {
            uGenes <- unique(unlist(strsplit(subpaths[i,], split='-')))
            subpathsGenes[i,1:length(uGenes)] <- uGenes
        }
    }


    # Evaluate subpaths with respect to the genes they consist of, each 
    # of which has its own bridgeness and betweenness centrality score.
    y          <- as.character(genes)
    y          <- c(y, 0)
    ids        <- 1:(length(y)+1)
    names(ids) <- y
    iSubs      <- matrix(ids[as.character(subpathsGenes)], 
                        ncol=ncol(subpathsGenes), byrow=FALSE)

    # Create indexing structures
    lib1 <- c(T1, 0)
    lib2 <- c(T2, 0)
    lib3 <- c(T3, 0)

    # Subpath length per line
    L  <- getLengths(iSubs)

    # Convert the matrix of gene indexes to a matrix of bridgeness values
    S1 <- matrix(lib1[iSubs], nrow=nrow(iSubs), ncol=ncol(iSubs))
    r1 <- rowSums(S1) / L
    # Scale bridgeness values to [0,1]
    r1 <- r1 / max(r1)

    # Convert the matrix of gene indexes to a matrix of betweenness values
    S2 <- matrix(lib2[iSubs], nrow=nrow(iSubs), ncol=ncol(iSubs))
    r2 <- rowSums(S2) / L
    # Scale betweenness values to [0,1]
    r2 <- r2 / max(r2)  

    # Convert the matrix of gene indexes to a matrix of betweenness values
    S3 <- matrix(lib3[iSubs], nrow=nrow(iSubs), ncol=ncol(iSubs))
    r3 <- rowSums(S3) / L

    res           <- matrix(,ncol=3, nrow=length(r1))
    res[,1]       <- r1
    res[,2]       <- r2
    res[,3]       <- r3
    colnames(res) <- c('subPathness', 'subBC', 'subDEG')
    rownames(res) <- 1:nrow(res)

    message('done.')

    return(res)
}

---
title: 'CHRONOS: A time-varying method for microRNA-mediated sub-pathway
                enrichment analysis'
author: "Aristidis G. Vrahatis, Konstantina Dimitrakopoulou, Panos Balomenos"
date: '`r Sys.Date()`'
output:
    pdf_document:
    dev: pdf
    fig_height: 4
    fig_width: 7.5
    highlight: pygments
    toc: yes
geometry: margin=1in
fontsize: 11pt
vignette: >
    %\VignetteIndexEntry{CHRONOS}
    %\VignetteEngine{knitr::rmarkdown}
    %\usepackage[utf8]{inputenc}
---

# Table of Contents
1. [Package Setup](#Package Setup)
2. [User Input](#User Input)
3. [Default Run](#Default Run)

## Package Setup
CHRONOS (time-vaRying enriCHment integrOmics Subpathway aNalysis tOol) is an 
R package built to extract regulatory subpathways along with their miRNA 
regulators at each time point based on KEGG pathway maps and user-defined 
time series mRNA and microRNA (if available) expression profiles for 
microarray experiments. It is flexible by allowing the user to intervene and 
adapt all discrete phases to the needs of the study under investigation. 
CHRONOS can assist significantly in complex disease analysis by enabling the 
experimentalists to shift from the dynamic to the more realistic time-varying 
view of the involved perturbed mechanisms.

Before loading the package, please specify a user-accessible home directory. 
The default directories for each architecture are as follows:

```{r eval=TRUE, echo=TRUE}
if (.Platform$OS.type == 'unix') 
    { options('CHRONOS_CACHE'=file.path(path.expand("~"), '.CHRONOS') ) }
if (.Platform$OS.type == 'windows') 
    { options('CHRONOS_CACHE'=file.path(gsub("\\\\", "/",
                            Sys.getenv("USERPROFILE")), "AppData/.CHRONOS")) }
```

## User Input
CHRONOS requires mRNA and microRNA (if available) time-series expression data 
along with their labels. The expression data needs to be formatted in matrices
with dimensions (N, E), where N is the number of mRNAs/ microRNAs and E the 
time points of data (i.e. X(i,j) is the expression value of mRNA/miRNA i at 
time j). In case microRNA expression data are not available, CHRONOS can be 
run without processing and exporting miRNAs in the final subpathways. 
CHRONOS operates more effectively if data are normalized and log2-fold change 
differences relative to an initial condition (control state) are computed. 
Multiple biological replicates should be summarized so that one sample per 
time point is provided as input. An indicative example is:

```{r eval=TRUE, echo=TRUE}
library('CHRONOS')
load(system.file('extdata', 'Examples//data.RData', package='CHRONOS'))
head(mRNAexpr)
```

## Default Run

Next we present a default run of CHRONOS, which 
(i) imports mRNA from CHRONOS/extdata/Input/<mRNAexprFile>.txt and 
miRNA expressions from CHRONOS/extdata/Input/<miRNAexprFile>.txt,
(ii) downloads (all availiable) pathways for a specified organism from KEGG,
(iii) creates pathway graphs from downloaded KGML files,
(iv) extracts linear subpathways from metabolic and non metabolic graphs,
(v) downloads miRecords miRNA-mRNA interactions,
(vi) scores extracted subpathways in order to extract significant results,
(vii) visualizes the most the significant results.

```{r eval=TRUE, echo=TRUE, message=FALSE}
out <- CHRONOSrun(  mRNAexp=mRNAexpr,
                    mRNAlabel='entrezgene',
                    miRNAexp=miRNAexpr,
                    pathType=c('04915', '04917', '04930', '05031'),
                    org='hsa',
                    subType='All',
                    thresholds=c('subScore'=0.4, 'mirScore'=0.4),
                    miRNAinteractions=miRNAinteractions,
                    export='.txt')
```
![Results](figures/results.png)

## Citation
The CHRONOS software package itself can be cited as: 
Vrahatis, A. G., Dimitrakopoulou, K., Balomenos, P., Tsakalidis, A. K., & 
Bezerianos, A. (2015). CHRONOS: A time-varying method for microRNA-mediated 
sub-pathway enrichment analysis. Bioinformatics (2016) 32 (6) : 884-892

\name{subpathwayKEGGmap}
\alias{subpathwayKEGGmap}
\title{Create links to KEGG pathway map with highlighted subpathways.}
\usage{
subpathwayKEGGmap(subpathways, type, openInBrowser)
}
\arguments{
\item{subpathways}{Subpathways as returned by 
\code{\link{extractLinearSubpathways}} \cr
or \code{\link{extractNonLinearSubpathways}}}

\item{type}{Subpathway type (Linear, Non-Linear)}

\item{openInBrowser}{Open link in default browser.}
}
\value{
Vector of links of KEGG pathway maps.
}
\description{
Create links to KEGG pathway map with highlighted subpathways.
}

\examples{

# Load extracted linear subpathways from toy data
load(system.file('extdata', 'Examples//data.RData', package='CHRONOS'))

# Opening selected subpathways in default browser
subs <- linSubs$subpaths[1:3, ]

subpathwayKEGGmap(subpathways=subs, type='Linear', openInBrowser=FALSE)
}

\name{CHRONOSrun}
\alias{CHRONOSrun}
\title{Default run of CHRONOS}
\usage{
CHRONOSrun(mRNAexp, mRNAlabel, miRNAexp, pathType, subType, measures,
    thresholds, org, export, verbose, miRNAinteractions)
}
\arguments{
\item{mRNAexp}{mRNA expressions filename located in CHRONOS/extdata/Input}

\item{mRNAlabel}{mRNA nomenclature 
(for supported types see \code{\link{convertNomenclature}})}

\item{miRNAexp}{miRNA expressions filename located in CHRONOS/extdata/Input}

\item{pathType}{Pathway type 
('Metabolic', 'Non-Metabolic', 'All' or vector of pathway ids)}

\item{subType}{Subpathway type ('Linear', 'Non-Linear', 'All')}

\item{measures}{Include subpathway structural and functional aspects 
('TRUE', 'FALSE')}

\item{thresholds}{Subscore, mirscore and p-value thresholds \cr
c('pvalue'=pvalue, 'subscore'=subscore, 'mirscore'=mirscore)}

\item{org}{KEGG organism identifier}

\item{export}{Export file type ('.xlsx', '.txt') }

\item{verbose}{Show informative messages (TRUE/FALSE).}

\item{miRNAinteractions}{Edgelist of miRNA-mRNA interactions.}
}
\value{
.
}
\description{
Default run of CHRONOS
}
\details{
\itemize{
\item{ Imports gene and miRNA expressions from 
        CHRONOS/extdata/Input/<mRNAexpFile>.txt \cr
        and CHRONOS/extdata/Input/<miRNAexpFile>.txt}
\item{ Downloads all availiable pathways for the specified organism 
        from KEGG.}
\item{ Creates pathway graphs from downloaded KGML files.}
\item{ Extracts linear subpathways from metabolic and non 
        metabolic graphs.}
\item{ Extracts non linear subpathways from metabolic and non metabolic 
        graphs.}
\item{ Downloads miRecords miRNA-mRNA interactions.}
\item{ Scores and evaluates (linear and non linear) subpathways to extract
        significant results.}
\item{ Organism identifier.}
\item{ Visualizes most the significant results ('.xlsx' or '.txt').}
\item{ Display informative messages (TRUE/FALSE).}
\item{ User-defined miRNA-mRNA interactions can be supplied in the form of 
        an edgelist with two columns. If no such information is availiable, 
        a missing or a NULL argument forces the use of default interactions 
        by using \code{\link{downloadMiRecords}}. }
}
}
\examples{

# Default run

load(system.file('extdata', 'Examples//data.RData', package='CHRONOS'))

res <- CHRONOSrun(  mRNAexp=mRNAexpr,
                    mRNAlabel='entrezgene',
                    miRNAexp=miRNAexpr,
                    pathType=c('04915', '04917', '04930', '05031'),
                    org='hsa',
                    subType='Linear',
                    thresholds=c('subScore'=0.4, 'mirScore'=0.4),
                    miRNAinteractions=miRNAinteractions)
}

\name{extractLinearSubpathways}
\alias{extractLinearSubpathways}
\title{Linear subpathway extraction from pathway graphs}
\usage{
extractLinearSubpathways(graphs, pathways, a, b, filter, export, groupMode,
    verbose)
}
\arguments{
\item{graphs}{Pathway graphs as returned from 
\code{\link{createPathwayGraphs}}.}

\item{pathways}{The subset of pathways from whom subpathways are to be 
extracted. \cr
If missing, all pathway graphs are used.}

\item{a}{Minimum subpathway length.}

\item{b}{Maximum subpathway length.}

\item{filter}{Filter the subpaths with user genes (TRUE). \cr}

\item{export}{Exports subpaths in CHRONOS/extdata/Output/Subpaths/Linear/<org> 
folder. \cr 
Availiable formats are '.txt' and/or '.RData'.}

\item{groupMode}{Expand paralogues ('expand') or collapse them to a 
single entry ('collapse'). \cr}

\item{verbose}{Display informative messages (TRUE)

Requires previous execution of \code{\link{importExpressions}}.}
}
\value{
Returns a list consisting of
\itemize{
    \item{A matrix of linear subpathways  }{(subpaths)}
    \item{A list of processed pathway graphs adjacency matrices  }{(adjMats)}
    \item{A list of processed pathway genes and interactions between them  }
    {(lexicon)}
}
}
\description{
Linear subpathway extraction from pathway graphs
}
\details{
Subpath filtering supports the removal of subpaths that have at least 
one member not belonging to the set of user supplied genes. These genes 
are extracted from the user's mRNA expressions matrix.Thus, the execution  
of \code{\link{importExpressions}} is a prerequisite.

To extract linear subpathways from a pathway graph, all possible start 
and end nodes are considered. A start node has only outgoing edges while
an end node only has incoming edges. For each such pair, all linear  
subpathways are found by traversing the corresponding graph. Since the 
initial pathway graph's nodes contain one or more genes, resulting 
subpathways consist of bins of one or more genes. These subpaths are 
expanded to subpathways with one gene per bin in order to obtain usable 
subpathways.
}
\examples{

# Load pathway graphs from toy data
load(system.file('extdata', 'Examples//data.RData', package='CHRONOS'))

# Extract linear subpathways
linSubs <- extractLinearSubpathways(graphs=graphs)

}

\name{downloadPathways}
\alias{downloadPathways}
\title{Download KEGG pathways in KGML format.}
\usage{
downloadPathways(org, pathways)
}
\arguments{
\item{org}{KEGG organism identifier}

\item{pathways}{Download pathways for specified organism: 
\tabular{rrl}{
    \tab 'All' \tab  All organism pathways\cr
    \tab 'Metabolic' \tab  Metabolic pathways\cr
    \tab 'Non-Metabolic' \tab  Non metabolic pathways\cr
    \tab <vector of indexes> \tab  Using indexes from 
    \code{\link{downloadKEGGPathwayList}}\cr
    \tab <vector of names> \tab  Using pathway identifiers 
    (i.e. c('00010', '00020'))
}}
}
\value{
Downloaded data is stored in CHRONOS/extdata/Downloads/KEGG/<org>
}
\description{
Download KEGG pathways in KGML format.
}
\details{
KEGG (Kyoto Encyclopedia of Genes and Genomes) is a database resource 
for understanding high-level functions and utilities of the biological ,
system such as the cell, the organism and the ecosystem, from 
molecular-level information, especially large-scale molecular datasets 
generated by genome sequencing and other high-throughput experimental 
technologies. \cr

Files are downloaded in CHRONOS/extdata/Downloads/KEGG/<org> folder. \cr
Downloading is skipped for existing files. \cr

}
\examples{

# View all availiable hsa pathways
\dontrun{pathways <- downloadKEGGPathwayList(org='hsa')}

# Download pathway KGML files
pathways <- c('04915', '04917', '04930', '05031')

\dontrun{pathways <- downloadPathways(org='hsa', pathways=pathways)}

}
\references{
\itemize{
    \item{\url{http://www.genome.jp/kegg/pathway.html}}
}
}

\name{downloadMiRecords}
\alias{downloadMiRecords}
\title{Download miRNA-mRNA interactions for an organism.}
\usage{
downloadMiRecords(org, pn, update, databases)
}
\arguments{
\item{org}{KEGG organism identifier.}

\item{pn}{Number of databases that verify miRNA-mRNA interactions.}

\item{update}{Download preprocessed data (update=FALSE) or new data from 
miRecords (update=TRUE).}

\item{databases}{Specify which miRNA-mRNA interaction databases 
will be used.}
}
\value{
Downloaded data is stored in 
    CHRONOS/extdata/Downloads/miRecords/<org>/miRNATargets.RData
}
\description{
Download miRNA-mRNA interactions for an organism.
}
\details{
miRecords is a resource for animal miRNA-target interactions. 
The Predicted Targets component of miRecords 
is an integration of predicted miRNA targets produced by 11 established 
miRNA target prediction tools, namely DIANA-microT, MicroInspector, 
miRanda, MirTarget2, miTarget, NBmiRTar, PicTar, PITA, RNA22, RNAhybrid, 
and TargetScan/TargertScanS.
}
\examples{

# Load extracted linear subpathways from toy data
load(system.file('extdata', 'Examples//data.RData', package='CHRONOS'))

\dontrun{downloadMiRecords(org='hsa', pn=5, update=FALSE, databases='All')}

}
\references{
\itemize{
    \item{\url{http://c1.accurascience.com/miRecords}}
}
}

\name{pathwayMeasures}
\alias{pathwayMeasures}
\title{Pathway structural and functional aspects}
\usage{
pathwayMeasures(graphs)
}
\arguments{
\item{graphs}{Pathway graphs as returned from
\code{\link{createPathwayGraphs}}.}
}
\value{
Matrix with pathness, betweeness centrality and degree values 
for each gene in the pathway graphs at it's columns.

}
\description{
Pathway structural and functional aspects
}
\details{
Structural and functional aspects of a pathway are calculated in 
respect to all organism pathways.
}
\examples{

# Load pathway graphs from toy data
load(system.file('extdata', 'Examples//data.RData', package='CHRONOS'))

# Calculate pathway structural and functional aspects
measures <- pathwayMeasures(graphs)

}

\name{convertMiRNANomenclature}
\alias{convertMiRNANomenclature}
\title{Conform miRNA annotations to the ones currently used by miRecords.}
\usage{
convertMiRNANomenclature(org, miRNAs, update)
}
\arguments{
\item{org}{KEGG organism identifier.}

\item{miRNAs}{Vector of miRNAs identifiers.}

\item{update}{Update annotation mapper with latest annotation changes.}
}
\value{
.
}
\description{
Conform miRNA annotations to the ones currently used by miRecords.
}
\details{
Determine which miRNAs are incompatible with miRecords annotations
and retreive the suitable ones from www.mirbase.org. 

}
\examples{

data <- c('hsa-let-7g-5p', 'hsa-miR-154-5p', 'hsa-miR-376b-3p')

convertMiRNANomenclature(org='hsa', miRNAs=data)

}

\name{extractNonLinearSubpathways}
\alias{extractNonLinearSubpathways}
\title{Non linear subpathway extraction from pathway graphs}
\usage{
extractNonLinearSubpathways(graphs, pathways, a, b, k, filter, groupMode,
    export, verbose)
}
\arguments{
\item{graphs}{Pathway graphs as returned from 
\code{\link{createPathwayGraphs}}.}

\item{pathways}{The subset of pathways from whom subpathways are to be 
extracted. \cr
If missing, all pathway graphs are used.}

\item{a}{Minimum subpathway length.}

\item{b}{Maximum subpathway length.}

\item{k}{Clique size.}

\item{filter}{Filter the subpaths with user genes (TRUE). \cr}

\item{groupMode}{Expand paralogues ('expand') or collapse them to a single 
entry ('collapse'). \cr}

\item{export}{Exports subpaths in CHRONOS/extdata/Output/Subpaths/Non-Linear/
<org> folder. \cr
Availiable formats are '.txt' and/or '.RData'.}

\item{verbose}{Display informative messages (TRUE)

Requires previous execution of \code{\link{importExpressions}}.}
}
\value{
Returns a list consisting of
\itemize{
    \item{A matrix of linear subpathways  }{(subpaths)}
    \item{A list of processed pathway graphs adjacency matrices}{(adjMats)}
    \item{A list of processed pathway genes and interactions between them}
    {(lexicon)}
}

To extract non linear subpaths from a pathway graph, all interactions 
between nodes of belonging to k-cliques are found. The ones that correspond


To extract non linear subpaths from a pathway graph, all interactions 
between nodes of belonging to k-cliques are found. The ones that correspond
to actual interactions between genes make up the non linear subpath.
}
\description{
Non linear subpathway extraction from pathway graphs
}
\examples{

# Load pathway graphs from toy data
load(system.file('extdata', 'Examples//data.RData', package='CHRONOS'))

# Extract linear subpathways
nliSubs  <- extractNonLinearSubpathways(graphs=graphs)

}

\name{scoreSubpathways}
\alias{scoreSubpathways}
\title{Evaluate subpathways using an interacting scorng scheme (IS) 
for each time point.}
\usage{
scoreSubpathways(subpathways, filters, measures, parameters, miRNAinteractions)
}
\arguments{
\item{subpathways}{Subpaths as returned from 
\code{\link{extractLinearSubpathways}} \cr
and \code{\link{extractNonLinearSubpathways}}.}

\item{filters}{Named vector of filters used for subpathway evaluation. \cr
Values denote corresponding thresholds.
\tabular{llll}{
    \tab \tab pvalue \tab  Statistical evaluation \cr
    \tab \tab measures \tab Structural and functional evaluation\cr
    \tab \tab subScore \tab mRNA-mRNA interaction scoring\cr
    \tab \tab mirScore \tab miRNA-mRNA interaction scoring
}}

\item{measures}{Subpathway structural and functional aspects as returned 
    from \cr
\code{\link{pathwayMeasures}}.}

\item{parameters}{C,K,T parameters of scoring scheme.}
\item{miRNAinteractions}{An edgelist of miRNA-mRNA interactions used to  
    override downloaded interactions from miRecords.}
}
\value{
\tabular{llll}{
    \tab subpathways \tab  High ranking subpathways \cr
    \tab subScores \tab miRNA-subpathway scores\cr
    \tab mRNAScores \tab mRNA-mRNA scores for each subpathway and for each 
    time point\cr
    \tab miRNAsOverSubpathway \tab High ranking miRNAs hitting 
    each subpathway \cr
    \tab pValues\tab P-value of each subpathway\cr
    \tab filters\tab Filters used for the evaluation
}
}
\description{
Evaluate subpathways using an interacting scorng scheme (IS) 
for each time point.
}
\details{
...
}
\examples{

# Load extracted subpathways from toy data
load(system.file('extdata', 'Examples//data.RData', package='CHRONOS'))

# Import mRNA expressions
mRNAexpr <- importExpressions(data=mRNAexpr, type='mRNA', org='hsa')

# Score extracted linear subpathways
filters       <- c('subScore'=0.4)
linSubsScored <- scoreSubpathways(subpathways=linSubs, filters=filters)

}
\references{
Jethava, V., Bhattacharyya, C., Dubhashi, D., & Vemuri, G. N. (2011).  
Netgem: Network embedded temporal generative model for gene expression  
data. BMC bioinformatics, 12(1), 327.

Kim,Y. et al. (2011). Principal network analysis: identification of 
subnetworks representing major dynamics using gene expression data. 
Bioinformatics, 27(3), 391-398
}

\name{subpathwayMiRNAs}
\alias{subpathwayMiRNAs}
\title{Create a circulat plot of a subpathway and the miRNAs that target it.}
\usage{
subpathwayMiRNAs(summary, subIdx, timePoints)
}
\arguments{
\item{summary}{Output from \code{\link{scoreSubpathways}}}

\item{subIdx}{Subpathway index}

\item{timePoints}{Time points to include in visualization, default to all.}
}
\value{
.
}
\description{
Create a circulat plot of a subpathway and the miRNAs that target it.
}


\examples{

# Load scored subpathways from toy data
load(system.file('extdata', 'Examples//data.RData', package='CHRONOS'))
# Visualize one or more subpathways. 
subpathwayMiRNAs(summary=linSubsScored, subIdx=2)

}

\name{convertNomenclature}
\alias{convertNomenclature}
\title{Convert genes identifier nomenclature.}
\usage{
convertNomenclature(ids, org, from, to)
}
\arguments{
\item{ids}{Vector of gene identifiers}

\item{org}{KEGG organism identifier}

\item{from}{Initial identifier type}

\item{to}{A vector of final identifier types}
}
\value{
Vector of converted gene identifiers
}
\description{
Convert genes identifier nomenclature.
}
\details{
\tabular{ll}{
    EntrezGene ID \tab 'entrezgene'\cr
    Ensembl Gene ID \tab 'ensembl_gene_id'\cr
    Ensemble Transcript ID \tab'ensembl_transcript_id'\cr
    Ensemble Protein ID \tab 'ensembl_peptide_id'\cr
    HGNC ID \tab 'hgnc_id'\cr
    HGNC Symbol \tab 'hgnc_symbol'\cr
    HGNC Transcript name \tab 'hgnc_transcript_name'\cr
    Refseq mRNA ID \tab 'refseq_mrna'\cr
    Refseq Protein ID \tab 'refseq_peptide'\cr
    UniProt/Swissprot Accession \tab 'uniprot_swissprot_accession'\cr
    UniProt/Swissprot ID \tab 'uniprot_swissprot'\cr
    UniGene ID \tab 'unigene'\cr
    UniProt Genename ID \tab 'uniprot_genename'
}
}
\examples{
# Identifiers to be converted
ids <- c('5091', '5105')

# Convert to HGNC ID, Ensembl Gene ID and UniProt Genename ID
from <- 'entrezgene'
to <- c('hgnc_symbol','ensembl_gene_id', 'uniprot_genename')
\dontrun{res <- convertNomenclature(ids=ids, org='hsa', from=from, to=to)}

}

\name{createPathwayGraphs}
\alias{createPathwayGraphs}
\title{Convert KEGG Pathways to Gene-Gene Network Graphs.}
\usage{
createPathwayGraphs(org, pathways, edgeTypes, doubleEdges, choice, groupMode)
}
\arguments{
\item{org}{KEGG organism identifier.}

\item{pathways}{Vector of KEGG pathway identifiers.}

\item{edgeTypes}{Vector of edge types mappings.}

\item{doubleEdges}{Specify which edgeTypes should be considered 
bidirectional.}

\item{choice}{Create metabolic graph either by using relations or reactions
from KGML file ('reactions', 'relations')\cr}

\item{groupMode}{'expand' to consider each group member a node, or 
'collapse' to consider all components' genes as a node}
}
\value{
A list containing a list of compact adjacency matrices, a list of 
expanded adjacency matrices, and list detailing all nodes, edges and 
interaction types.
}
\description{
Convert KEGG Pathways to Gene-Gene Network Graphs.
}
\details{
KEGG pathways consist of nodes each one containing one or more genes. 
Thus, two kinds of adjacency matrices are created. The compact adjacency 
matrix retains the groupings and stores edge types between genes and genes,
genes and groups of genes or between group of genes. The expanded adjacency
matrix stores edge type information between individual genes. 


}
\examples{

# Download Insulin Signaling Pathway
pathways <- c('04915', '04917', '04930', '05031')
paths    <- downloadPathways(org='hsa', pathways=pathways)

# Create pathway graph
graphs   <- createPathwayGraphs(org='hsa', pathways=paths)


}
\references{
Li, C., Han, J., Yao, Q., Zou, C., Xu, Y., Zhang, C., ... & Li, X. (2013).
Subpathway-GM: identification of metabolic subpathways via joint power 
of interesting genes and metabolites and their topologies within pathways.
Nucleic acids research, 41(9), e101-e101.
}

\name{importExpressions}
\alias{importExpressions}
\title{Import gene and miRNA expressions from}
\usage{
importExpressions(data, type, sep, org, mRNAnomenclature)
}
\arguments{
\item{data}{Expressions data filename or matrix.}

\item{type}{Expressions data type. (or mRNA expressions, type=<nomenType>.
Availiable gene expression nomenclature can be found in
\code{\link{convertNomenclature}}.
For miRNA expressions, type='miRNA'.}

\item{sep}{File delimiter.}

\item{org}{KEGG organism identifier}

\item{mRNAnomenclature}{Nomenclature of user's mRNA expressions}
}
\value{
.
}
\description{
Import gene and miRNA expressions from
}
\details{
\itemize{
\item{ Import gene expressions data from CHRONOS/extdata/Input/<userFile>.txt
        or a supplied matrix. }
\item{ Import miRNA expressions data from CHRONOS/extdata/Input/<userFile>.txt
        or a supplied matrix.}
}
}
\examples{

# Example

load(system.file('extdata', 'Examples//data.RData', package='CHRONOS'))

importExpressions(data=mRNAexpr, type='mRNA', 
                mRNAnomenclature='entrezgene', sep='\\t', org='hsa')
importExpressions(data=miRNAexpr, type='miRNA', sep='\\t', org='hsa')

}

\name{getEdgeTypes}
\alias{getEdgeTypes}
\title{Map various types of gene-gene interactions in KGML files to edge types 
in corresponding pathway graphs.}
\usage{
getEdgeTypes(type)
}
\arguments{
\item{type}{A vector of interaction types.}
}
\value{
If an interaction type has been supplied, the corresponging edge 
types are returned. 
If not, the complete mapping is returned.
}
\description{
Map various types of gene-gene interactions in KGML files to edge types 
in corresponding pathway graphs.
}
\details{
Edge types

\tabular{llllllll}{
    activation \tab 1 \tab inhibition \tab 2 \tab apathetic \tab 3 \tab 
    no interaction \tab 4
} 

Default interaction - edge type mapping

\tabular{rrrrrr}{
    01 \tab unknown \tab 3 \tab 02 \tab activation \tab 1\cr
    03 \tab inhibition \tab 2 \tab 04 \tab binding/association \tab 3\cr
    05 \tab expression \tab 1 \tab 06 \tab repression \tab 2\cr
    07 \tab phosphorylation \tab 3 \tab 08 \tab dephosphorylation \tab 3\cr
    09 \tab ubiquitination \tab 3 \tab 10 \tab dissociation \tab 3\cr
    11 \tab indirect effect \tab 3 \tab 12 \tab state change \tab 3\cr
    13 \tab compound \tab 3 \tab 14 \tab hidden compound \tab 3\cr
    16 \tab missing interaction 
        \tab 3 \tab 16 \tab activation_phosphorylation \tab 1\cr
    17 \tab activation_dephosphorylation 
        \tab 1 \tab 18 \tab activation_ubiquitination \tab 1\cr
    19 \tab activation_indirect effect 
        \tab 1 \tab 20 \tab activation_binding/association \tab 1\cr
    21 \tab activation_inhibition 
        \tab 3 \tab 22 \tab activation_methylation \tab 1\cr
    23 \tab inhibition_phosphorylation 
        \tab 2 \tab 24 \tab inhibition_dephosphorylation \tab 2\cr
    25 \tab inhibition_ubiquitination 
        \tab 2 \tab 26 \tab inhibition_indirect effect \tab 2\cr
    27 \tab inhibition_binding/association 
        \tab 2 \tab 28 \tab inhibition_expression \tab 2\cr
    29 \tab inhibition_methylation 
        \tab 2 \tab 30 \tab compound_expression \tab 1\cr
    31 \tab compound_activation 
        \tab 1 \tab 32 \tab compound_inhibition \tab 2\cr
}

\tabular{rrrrrr}{
    33 \tab compound_activation_indirect effect \tab 1 \cr 
    34 \tab compound_activation_phosphorylation \tab 1\cr
    35 \tab phosphorylation_indirect effect \tab 3 \cr 
    36 \tab phosphorylation_binding/association \tab 3\cr
    37 \tab phosphorylation_dissociation \tab 3 \cr 
    38 \tab dephosphorylation_indirect effect \tab 3\cr
    39 \tab binding/association_missing interaction \tab 3 \cr 
    40 \tab binding/association_indirect effect \tab 3\cr
    41 \tab expression_indirect effect \tab 1 \cr 
    42 \tab repression_indirect effect \tab 2\cr
    43 \tab ubiquitination_inhibition \tab 2 \cr 
    44 \tab dissociation_missing interaction \tab 3\cr
    45 \tab indirect effect_phosphorylation \tab 3  \tab \tab \cr
    46 \tab activation_phosphorylation_binding/association \tab 1 \cr
    47 \tab activation_phosphorylation_indirect effect \tab 1\cr
}
}
\examples{

# Example 1

# Retreive edge types for phosphorylation and dephosphorylation.
getEdgeTypes(c(7,8)) 

# Example 2

# Returns a data frame containing the innteraction - edge type mapper.
types <- getEdgeTypes()

# Set phosphorylation to inhibition.
types[8,2] <- 2


}

\name{downloadKEGGPathwayList}
\alias{downloadKEGGPathwayList}
\title{Retrieve all availiable pathways for an organism.}
\usage{
downloadKEGGPathwayList(org)
}
\arguments{
\item{org}{KEGG organism identifier.}
}
\value{
Data frame of pathway ids and names.
}
\description{
Retrieve all availiable pathways for an organism.
}
\details{
.
}
\examples{

# Load extracted linear subpathways from toy data
load(system.file('extdata', 'Examples//data.RData', package='CHRONOS'))

# Retrieve all availiable hsa pathways
\dontrun{pathways <- downloadKEGGPathwayList(org='hsa')}

}
\references{
\itemize{
    \item{\url{http://www.genome.jp/kegg/pathway.html}}
}
}

\name{visualizeResults}
\alias{visualizeResults}
\title{Visualize results in tabular form (txt, xlsx)}
\usage{
visualizeResults(summary, export, expand, colors, from, to)
}
\arguments{
\item{summary}{Evaluation results as returned from 
\code{\link{scoreSubpathways}}}

\item{export}{'.xlsx' exports a xlsx file and '.txt' a .txt file.}

\item{expand}{TRUE if each subpathway member and miRNA belongs to a single 
cell, FALSE if all subpathway members belong to one cell and
miRNAs to another cell.}

\item{colors}{The color scheme used in subScores heatmap.}

\item{from}{Primary annotation \code{\link{convertNomenclature}}.
Defaults to EntrezGene ID.}

\item{to}{Secondary annotation \code{\link{convertNomenclature}}}
}
\value{
A txt or a xlsx file in CHRONOS/extdata/Output/Scores/Linear/<org> \cr
or CHRONOS/extdata/Output/Scores/Non-Linear/<org>
}
\description{
Visualize results in tabular form (txt, xlsx)
}


\examples{

# Load scored subpathways from toy data
load(system.file('extdata', 'Examples//data.RData', package='CHRONOS'))

visualizeResults(linSubsScored, export='txt')

}
